package com.huawei.dli.restapi.auth;

import com.huawei.dli.restapi.Pair;

import java.util.Map;
import java.util.List;

public interface Authentication {
    /**
     * Apply authentication settings to header and query params.
     *
     * @param url The request HTTP URL
     * @param method The request method, one of "GET", "HEAD", "OPTIONS", "POST", "PUT", "PATCH" and "DELETE"
     * @param queryParams List of query parameters
     * @param headerParams Map of header parameters
     * @param body The request body object
     */
    void applyToParams(String url, String method, List<Pair> queryParams, Map<String, String> headerParams, Object body);
}
