/*
 * DLI API Swagger
 * This is DLI API swagger-maven-plugin
 *
 * OpenAPI spec version: v1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.dli.restapi.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * UpdateFlinkJarJobRequest
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2023-09-07T10:41:28.432+08:00")

public class UpdateFlinkJarJobRequest {
  @SerializedName("name")
  private String name = null;

  @SerializedName("desc")
  private String desc = null;

  @SerializedName("queue_name")
  private String queueName = null;

  @SerializedName("cu_number")
  private Integer cuNumber = null;

  @SerializedName("manager_cu_number")
  private Integer managerCuNumber = null;

  @SerializedName("parallel_number")
  private Integer parallelNumber = null;

  @SerializedName("obs_bucket")
  private String obsBucket = null;

  @SerializedName("log_enabled")
  private Boolean logEnabled = false;

  @SerializedName("smn_topic")
  private String smnTopic = null;

  @SerializedName("main_class")
  private String mainClass = null;

  @SerializedName("entrypoint_args")
  private String entrypointArgs = null;

  @SerializedName("restart_when_exception")
  private Boolean restartWhenException = false;

  @SerializedName("entrypoint")
  private String entrypoint = null;

  @SerializedName("dependency_jars")
  private List<String> dependencyJars = null;

  @SerializedName("dependency_files")
  private List<String> dependencyFiles = null;

  @SerializedName("feature")
  private String feature = null;

  @SerializedName("flink_version")
  private String flinkVersion = null;

  @SerializedName("image")
  private String image = null;

  public UpdateFlinkJarJobRequest name(String name) {
    this.name = name;
    return this;
  }

   /**
   * 作业名称。长度限制：0-57个字符。
   * @return name
  **/
  @ApiModelProperty(example = "my_job_001", value = "作业名称。长度限制：0-57个字符。")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public UpdateFlinkJarJobRequest desc(String desc) {
    this.desc = desc;
    return this;
  }

   /**
   * 作业描述。长度限制：0-2048个字符。
   * @return desc
  **/
  @ApiModelProperty(example = "这是我的第一个作业", value = "作业描述。长度限制：0-2048个字符。")
  public String getDesc() {
    return desc;
  }

  public void setDesc(String desc) {
    this.desc = desc;
  }

  public UpdateFlinkJarJobRequest queueName(String queueName) {
    this.queueName = queueName;
    return this;
  }

   /**
   * 队列名称。长度限制：1-128个字符。
   * @return queueName
  **/
  @ApiModelProperty(example = "queue1", value = "队列名称。长度限制：1-128个字符。")
  public String getQueueName() {
    return queueName;
  }

  public void setQueueName(String queueName) {
    this.queueName = queueName;
  }

  public UpdateFlinkJarJobRequest cuNumber(Integer cuNumber) {
    this.cuNumber = cuNumber;
    return this;
  }

   /**
   * 用户为作业选择的CU数量
   * minimum: 2
   * maximum: 400
   * @return cuNumber
  **/
  @ApiModelProperty(value = "用户为作业选择的CU数量")
  public Integer getCuNumber() {
    return cuNumber;
  }

  public void setCuNumber(Integer cuNumber) {
    this.cuNumber = cuNumber;
  }

  public UpdateFlinkJarJobRequest managerCuNumber(Integer managerCuNumber) {
    this.managerCuNumber = managerCuNumber;
    return this;
  }

   /**
   * 用户为作业选择的管理节点CU数量，对应为flink jobmanager数量
   * minimum: 1
   * maximum: 4
   * @return managerCuNumber
  **/
  @ApiModelProperty(value = "用户为作业选择的管理节点CU数量，对应为flink jobmanager数量")
  public Integer getManagerCuNumber() {
    return managerCuNumber;
  }

  public void setManagerCuNumber(Integer managerCuNumber) {
    this.managerCuNumber = managerCuNumber;
  }

  public UpdateFlinkJarJobRequest parallelNumber(Integer parallelNumber) {
    this.parallelNumber = parallelNumber;
    return this;
  }

   /**
   * 用户设置的作业并行数
   * minimum: 1
   * maximum: 2000
   * @return parallelNumber
  **/
  @ApiModelProperty(value = "用户设置的作业并行数")
  public Integer getParallelNumber() {
    return parallelNumber;
  }

  public void setParallelNumber(Integer parallelNumber) {
    this.parallelNumber = parallelNumber;
  }

  public UpdateFlinkJarJobRequest obsBucket(String obsBucket) {
    this.obsBucket = obsBucket;
    return this;
  }

   /**
   * checkpoint_enabled&#x3D;&#x3D;true时, 用户授权保存快照的OBS桶,log_enabled&#x3D;&#x3D;true时，保存作业日志的OBS桶
   * @return obsBucket
  **/
  @ApiModelProperty(example = "my_obs_bucket", value = "checkpoint_enabled==true时, 用户授权保存快照的OBS桶,log_enabled==true时，保存作业日志的OBS桶")
  public String getObsBucket() {
    return obsBucket;
  }

  public void setObsBucket(String obsBucket) {
    this.obsBucket = obsBucket;
  }

  public UpdateFlinkJarJobRequest logEnabled(Boolean logEnabled) {
    this.logEnabled = logEnabled;
    return this;
  }

   /**
   * 是否开启作业的日志上传到用户的OBS功能
   * @return logEnabled
  **/
  @ApiModelProperty(value = "是否开启作业的日志上传到用户的OBS功能")
  public Boolean getLogEnabled() {
    return logEnabled;
  }

  public void setLogEnabled(Boolean logEnabled) {
    this.logEnabled = logEnabled;
  }

  public UpdateFlinkJarJobRequest smnTopic(String smnTopic) {
    this.smnTopic = smnTopic;
    return this;
  }

   /**
   * 当作业异常时，向该SMN主题推送告警信息
   * @return smnTopic
  **/
  @ApiModelProperty(example = "cs_job_exception", value = "当作业异常时，向该SMN主题推送告警信息")
  public String getSmnTopic() {
    return smnTopic;
  }

  public void setSmnTopic(String smnTopic) {
    this.smnTopic = smnTopic;
  }

  public UpdateFlinkJarJobRequest mainClass(String mainClass) {
    this.mainClass = mainClass;
    return this;
  }

   /**
   * 作业入口类
   * @return mainClass
  **/
  @ApiModelProperty(example = "org.apache.flink.WordCount", value = "作业入口类")
  public String getMainClass() {
    return mainClass;
  }

  public void setMainClass(String mainClass) {
    this.mainClass = mainClass;
  }

  public UpdateFlinkJarJobRequest entrypointArgs(String entrypointArgs) {
    this.entrypointArgs = entrypointArgs;
    return this;
  }

   /**
   * 作业入口类参数
   * @return entrypointArgs
  **/
  @ApiModelProperty(example = "192.168.10.123 8080", value = "作业入口类参数")
  public String getEntrypointArgs() {
    return entrypointArgs;
  }

  public void setEntrypointArgs(String entrypointArgs) {
    this.entrypointArgs = entrypointArgs;
  }

  public UpdateFlinkJarJobRequest restartWhenException(Boolean restartWhenException) {
    this.restartWhenException = restartWhenException;
    return this;
  }

   /**
   * 是否开启异常重启功能
   * @return restartWhenException
  **/
  @ApiModelProperty(value = "是否开启异常重启功能")
  public Boolean getRestartWhenException() {
    return restartWhenException;
  }

  public void setRestartWhenException(Boolean restartWhenException) {
    this.restartWhenException = restartWhenException;
  }

  public UpdateFlinkJarJobRequest entrypoint(String entrypoint) {
    this.entrypoint = entrypoint;
    return this;
  }

   /**
   * 用户已上传到DLI资源管理系统的资源包名，用户自定义作业主类所在的jar包
   * @return entrypoint
  **/
  @ApiModelProperty(example = "myGroup/test.jar", value = "用户已上传到DLI资源管理系统的资源包名，用户自定义作业主类所在的jar包")
  public String getEntrypoint() {
    return entrypoint;
  }

  public void setEntrypoint(String entrypoint) {
    this.entrypoint = entrypoint;
  }

  public UpdateFlinkJarJobRequest dependencyJars(List<String> dependencyJars) {
    this.dependencyJars = dependencyJars;
    return this;
  }

  public UpdateFlinkJarJobRequest addDependencyJarsItem(String dependencyJarsItem) {
    if (this.dependencyJars == null) {
      this.dependencyJars = new ArrayList<String>();
    }
    this.dependencyJars.add(dependencyJarsItem);
    return this;
  }

   /**
   * 用户已上传到DLI资源管理系统的资源包名，用户自定义作业的其他依赖包
   * @return dependencyJars
  **/
  @ApiModelProperty(example = "\"{'dependency_jars':['myGroup/test.jar','myGroup/test1.jar']}\"", value = "用户已上传到DLI资源管理系统的资源包名，用户自定义作业的其他依赖包")
  public List<String> getDependencyJars() {
    return dependencyJars;
  }

  public void setDependencyJars(List<String> dependencyJars) {
    this.dependencyJars = dependencyJars;
  }

  public UpdateFlinkJarJobRequest dependencyFiles(List<String> dependencyFiles) {
    this.dependencyFiles = dependencyFiles;
    return this;
  }

  public UpdateFlinkJarJobRequest addDependencyFilesItem(String dependencyFilesItem) {
    if (this.dependencyFiles == null) {
      this.dependencyFiles = new ArrayList<String>();
    }
    this.dependencyFiles.add(dependencyFilesItem);
    return this;
  }

   /**
   * 用户已上传到DLI资源管理系统的资源包名，用户自定义作业的依赖文件
   * @return dependencyFiles
  **/
  @ApiModelProperty(example = "\"{'dependency_files':['myGroup/test.cvs','myGroup/test1.csv']}\"", value = "用户已上传到DLI资源管理系统的资源包名，用户自定义作业的依赖文件")
  public List<String> getDependencyFiles() {
    return dependencyFiles;
  }

  public void setDependencyFiles(List<String> dependencyFiles) {
    this.dependencyFiles = dependencyFiles;
  }

  public UpdateFlinkJarJobRequest feature(String feature) {
    this.feature = feature;
    return this;
  }

   /**
   * 作业特性，代表用户作业使用flink镜像的类型，basic表示使用DLI提供的基础flink镜像，custom表示使用用户自定义的flink镜像
   * @return feature
  **/
  @ApiModelProperty(example = "basic", value = "作业特性，代表用户作业使用flink镜像的类型，basic表示使用DLI提供的基础flink镜像，custom表示使用用户自定义的flink镜像")
  public String getFeature() {
    return feature;
  }

  public void setFeature(String feature) {
    this.feature = feature;
  }

  public UpdateFlinkJarJobRequest flinkVersion(String flinkVersion) {
    this.flinkVersion = flinkVersion;
    return this;
  }

   /**
   * flink版本，当用户设置feature为basic时，该参数生效，用户可通过与feature参数配合使用，指定作业运行使用的DLI基础flink镜像的版本
   * @return flinkVersion
  **/
  @ApiModelProperty(example = "1.7", value = "flink版本，当用户设置feature为basic时，该参数生效，用户可通过与feature参数配合使用，指定作业运行使用的DLI基础flink镜像的版本")
  public String getFlinkVersion() {
    return flinkVersion;
  }

  public void setFlinkVersion(String flinkVersion) {
    this.flinkVersion = flinkVersion;
  }

  public UpdateFlinkJarJobRequest image(String image) {
    this.image = image;
    return this;
  }

   /**
   * 自定义镜像，格式为：组织名/镜像名:镜像版本，当用户设置feature为custom时，该参数生效，用户可通过与feature参数配合使用，指定作业运行使用自己的flink镜像
   * @return image
  **/
  @ApiModelProperty(example = "myImage/flink:v01", value = "自定义镜像，格式为：组织名/镜像名:镜像版本，当用户设置feature为custom时，该参数生效，用户可通过与feature参数配合使用，指定作业运行使用自己的flink镜像")
  public String getImage() {
    return image;
  }

  public void setImage(String image) {
    this.image = image;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UpdateFlinkJarJobRequest updateFlinkJarJobRequest = (UpdateFlinkJarJobRequest) o;
    return Objects.equals(this.name, updateFlinkJarJobRequest.name) &&
        Objects.equals(this.desc, updateFlinkJarJobRequest.desc) &&
        Objects.equals(this.queueName, updateFlinkJarJobRequest.queueName) &&
        Objects.equals(this.cuNumber, updateFlinkJarJobRequest.cuNumber) &&
        Objects.equals(this.managerCuNumber, updateFlinkJarJobRequest.managerCuNumber) &&
        Objects.equals(this.parallelNumber, updateFlinkJarJobRequest.parallelNumber) &&
        Objects.equals(this.obsBucket, updateFlinkJarJobRequest.obsBucket) &&
        Objects.equals(this.logEnabled, updateFlinkJarJobRequest.logEnabled) &&
        Objects.equals(this.smnTopic, updateFlinkJarJobRequest.smnTopic) &&
        Objects.equals(this.mainClass, updateFlinkJarJobRequest.mainClass) &&
        Objects.equals(this.entrypointArgs, updateFlinkJarJobRequest.entrypointArgs) &&
        Objects.equals(this.restartWhenException, updateFlinkJarJobRequest.restartWhenException) &&
        Objects.equals(this.entrypoint, updateFlinkJarJobRequest.entrypoint) &&
        Objects.equals(this.dependencyJars, updateFlinkJarJobRequest.dependencyJars) &&
        Objects.equals(this.dependencyFiles, updateFlinkJarJobRequest.dependencyFiles) &&
        Objects.equals(this.feature, updateFlinkJarJobRequest.feature) &&
        Objects.equals(this.flinkVersion, updateFlinkJarJobRequest.flinkVersion) &&
        Objects.equals(this.image, updateFlinkJarJobRequest.image);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, desc, queueName, cuNumber, managerCuNumber, parallelNumber, obsBucket, logEnabled, smnTopic, mainClass, entrypointArgs, restartWhenException, entrypoint, dependencyJars, dependencyFiles, feature, flinkVersion, image);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UpdateFlinkJarJobRequest {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    desc: ").append(toIndentedString(desc)).append("\n");
    sb.append("    queueName: ").append(toIndentedString(queueName)).append("\n");
    sb.append("    cuNumber: ").append(toIndentedString(cuNumber)).append("\n");
    sb.append("    managerCuNumber: ").append(toIndentedString(managerCuNumber)).append("\n");
    sb.append("    parallelNumber: ").append(toIndentedString(parallelNumber)).append("\n");
    sb.append("    obsBucket: ").append(toIndentedString(obsBucket)).append("\n");
    sb.append("    logEnabled: ").append(toIndentedString(logEnabled)).append("\n");
    sb.append("    smnTopic: ").append(toIndentedString(smnTopic)).append("\n");
    sb.append("    mainClass: ").append(toIndentedString(mainClass)).append("\n");
    sb.append("    entrypointArgs: ").append(toIndentedString(entrypointArgs)).append("\n");
    sb.append("    restartWhenException: ").append(toIndentedString(restartWhenException)).append("\n");
    sb.append("    entrypoint: ").append(toIndentedString(entrypoint)).append("\n");
    sb.append("    dependencyJars: ").append(toIndentedString(dependencyJars)).append("\n");
    sb.append("    dependencyFiles: ").append(toIndentedString(dependencyFiles)).append("\n");
    sb.append("    feature: ").append(toIndentedString(feature)).append("\n");
    sb.append("    flinkVersion: ").append(toIndentedString(flinkVersion)).append("\n");
    sb.append("    image: ").append(toIndentedString(image)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

