/*
 * DLI API Swagger
 * This is DLI API swagger-maven-plugin
 *
 * OpenAPI spec version: v1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.huawei.dli.restapi.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * UpdateFlinkSqlJobRequest
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2023-09-07T10:41:28.432+08:00")

public class UpdateFlinkSqlJobRequest {
  @SerializedName("name")
  private String name = null;

  @SerializedName("desc")
  private String desc = null;

  @SerializedName("queue_name")
  private String queueName = null;

  @SerializedName("sql_body")
  private String sqlBody = null;

  /**
   * 作业运行模式，共享或者独享或者边缘节点
   */
  @JsonAdapter(RunModeEnum.Adapter.class)
  public enum RunModeEnum {
    SHARED_CLUSTER("shared_cluster"),
    
    EXCLUSIVE_CLUSTER("exclusive_cluster"),
    
    EDGE_NODE("edge_node");

    private String value;

    RunModeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static RunModeEnum fromValue(String text) {
      for (RunModeEnum b : RunModeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<RunModeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final RunModeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public RunModeEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return RunModeEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("run_mode")
  private RunModeEnum runMode = RunModeEnum.SHARED_CLUSTER;

  @SerializedName("cu_number")
  private Integer cuNumber = null;

  @SerializedName("parallel_number")
  private Integer parallelNumber = null;

  @SerializedName("checkpoint_enabled")
  private Boolean checkpointEnabled = false;

  @SerializedName("checkpoint_mode")
  private Integer checkpointMode = null;

  @SerializedName("checkpoint_interval")
  private Integer checkpointInterval = 10;

  @SerializedName("obs_bucket")
  private String obsBucket = null;

  @SerializedName("log_enabled")
  private Boolean logEnabled = false;

  @SerializedName("smn_topic")
  private String smnTopic = null;

  @SerializedName("restart_when_exception")
  private Boolean restartWhenException = false;

  @SerializedName("idle_state_retention")
  private Integer idleStateRetention = 3600;

  @SerializedName("edge_group_ids")
  private List<String> edgeGroupIds = null;

  @SerializedName("dirty_data_strategy")
  private String dirtyDataStrategy = "0";

  @SerializedName("udf_jar_url")
  private String udfJarUrl = null;

  public UpdateFlinkSqlJobRequest name(String name) {
    this.name = name;
    return this;
  }

   /**
   * 作业名称。长度限制：0-57个字符。
   * @return name
  **/
  @ApiModelProperty(example = "my_job_001", value = "作业名称。长度限制：0-57个字符。")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public UpdateFlinkSqlJobRequest desc(String desc) {
    this.desc = desc;
    return this;
  }

   /**
   * 作业描述。长度限制：0-2048个字符。
   * @return desc
  **/
  @ApiModelProperty(example = "这是我的第一个作业", value = "作业描述。长度限制：0-2048个字符。")
  public String getDesc() {
    return desc;
  }

  public void setDesc(String desc) {
    this.desc = desc;
  }

  public UpdateFlinkSqlJobRequest queueName(String queueName) {
    this.queueName = queueName;
    return this;
  }

   /**
   * 队列名称。长度限制：1-128个字符。
   * @return queueName
  **/
  @ApiModelProperty(example = "queue1", value = "队列名称。长度限制：1-128个字符。")
  public String getQueueName() {
    return queueName;
  }

  public void setQueueName(String queueName) {
    this.queueName = queueName;
  }

  public UpdateFlinkSqlJobRequest sqlBody(String sqlBody) {
    this.sqlBody = sqlBody;
    return this;
  }

   /**
   * Stream SQL语句, 至少包含source, query, sink三个部分。长度限制：0-1024*1024个字符。
   * @return sqlBody
  **/
  @ApiModelProperty(example = "select * from source_table", value = "Stream SQL语句, 至少包含source, query, sink三个部分。长度限制：0-1024*1024个字符。")
  public String getSqlBody() {
    return sqlBody;
  }

  public void setSqlBody(String sqlBody) {
    this.sqlBody = sqlBody;
  }

  public UpdateFlinkSqlJobRequest runMode(RunModeEnum runMode) {
    this.runMode = runMode;
    return this;
  }

   /**
   * 作业运行模式，共享或者独享或者边缘节点
   * @return runMode
  **/
  @ApiModelProperty(example = "shared_cluster", value = "作业运行模式，共享或者独享或者边缘节点")
  public RunModeEnum getRunMode() {
    return runMode;
  }

  public void setRunMode(RunModeEnum runMode) {
    this.runMode = runMode;
  }

  public UpdateFlinkSqlJobRequest cuNumber(Integer cuNumber) {
    this.cuNumber = cuNumber;
    return this;
  }

   /**
   * 用户为作业选择的CU数量
   * minimum: 2
   * maximum: 400
   * @return cuNumber
  **/
  @ApiModelProperty(value = "用户为作业选择的CU数量")
  public Integer getCuNumber() {
    return cuNumber;
  }

  public void setCuNumber(Integer cuNumber) {
    this.cuNumber = cuNumber;
  }

  public UpdateFlinkSqlJobRequest parallelNumber(Integer parallelNumber) {
    this.parallelNumber = parallelNumber;
    return this;
  }

   /**
   * 用户设置的作业并行数
   * minimum: 1
   * maximum: 2000
   * @return parallelNumber
  **/
  @ApiModelProperty(value = "用户设置的作业并行数")
  public Integer getParallelNumber() {
    return parallelNumber;
  }

  public void setParallelNumber(Integer parallelNumber) {
    this.parallelNumber = parallelNumber;
  }

  public UpdateFlinkSqlJobRequest checkpointEnabled(Boolean checkpointEnabled) {
    this.checkpointEnabled = checkpointEnabled;
    return this;
  }

   /**
   * 是否开启作业自动快照功能, true开启, false关闭, 默认false
   * @return checkpointEnabled
  **/
  @ApiModelProperty(value = "是否开启作业自动快照功能, true开启, false关闭, 默认false")
  public Boolean getCheckpointEnabled() {
    return checkpointEnabled;
  }

  public void setCheckpointEnabled(Boolean checkpointEnabled) {
    this.checkpointEnabled = checkpointEnabled;
  }

  public UpdateFlinkSqlJobRequest checkpointMode(Integer checkpointMode) {
    this.checkpointMode = checkpointMode;
    return this;
  }

   /**
   * 快照模式：1表示ExactlyOnce：数据只被消费一次。2表示AtLeastOnce：数据至少被消费一次。默认值为1。
   * @return checkpointMode
  **/
  @ApiModelProperty(example = "1", value = "快照模式：1表示ExactlyOnce：数据只被消费一次。2表示AtLeastOnce：数据至少被消费一次。默认值为1。")
  public Integer getCheckpointMode() {
    return checkpointMode;
  }

  public void setCheckpointMode(Integer checkpointMode) {
    this.checkpointMode = checkpointMode;
  }

  public UpdateFlinkSqlJobRequest checkpointInterval(Integer checkpointInterval) {
    this.checkpointInterval = checkpointInterval;
    return this;
  }

   /**
   * 快照时间间隔, 单位为秒
   * @return checkpointInterval
  **/
  @ApiModelProperty(value = "快照时间间隔, 单位为秒")
  public Integer getCheckpointInterval() {
    return checkpointInterval;
  }

  public void setCheckpointInterval(Integer checkpointInterval) {
    this.checkpointInterval = checkpointInterval;
  }

  public UpdateFlinkSqlJobRequest obsBucket(String obsBucket) {
    this.obsBucket = obsBucket;
    return this;
  }

   /**
   * checkpoint_enabled&#x3D;&#x3D;true时, 用户授权保存快照的OBS桶,log_enabled&#x3D;&#x3D;true时，保存作业日志的OBS桶
   * @return obsBucket
  **/
  @ApiModelProperty(example = "my_obs_bucket", value = "checkpoint_enabled==true时, 用户授权保存快照的OBS桶,log_enabled==true时，保存作业日志的OBS桶")
  public String getObsBucket() {
    return obsBucket;
  }

  public void setObsBucket(String obsBucket) {
    this.obsBucket = obsBucket;
  }

  public UpdateFlinkSqlJobRequest logEnabled(Boolean logEnabled) {
    this.logEnabled = logEnabled;
    return this;
  }

   /**
   * 是否开启作业的日志上传到用户的OBS功能
   * @return logEnabled
  **/
  @ApiModelProperty(value = "是否开启作业的日志上传到用户的OBS功能")
  public Boolean getLogEnabled() {
    return logEnabled;
  }

  public void setLogEnabled(Boolean logEnabled) {
    this.logEnabled = logEnabled;
  }

  public UpdateFlinkSqlJobRequest smnTopic(String smnTopic) {
    this.smnTopic = smnTopic;
    return this;
  }

   /**
   * 当作业异常时，向该SMN主题推送告警信息
   * @return smnTopic
  **/
  @ApiModelProperty(example = "cs_job_exception", value = "当作业异常时，向该SMN主题推送告警信息")
  public String getSmnTopic() {
    return smnTopic;
  }

  public void setSmnTopic(String smnTopic) {
    this.smnTopic = smnTopic;
  }

  public UpdateFlinkSqlJobRequest restartWhenException(Boolean restartWhenException) {
    this.restartWhenException = restartWhenException;
    return this;
  }

   /**
   * 是否开启异常重启功能
   * @return restartWhenException
  **/
  @ApiModelProperty(value = "是否开启异常重启功能")
  public Boolean getRestartWhenException() {
    return restartWhenException;
  }

  public void setRestartWhenException(Boolean restartWhenException) {
    this.restartWhenException = restartWhenException;
  }

  public UpdateFlinkSqlJobRequest idleStateRetention(Integer idleStateRetention) {
    this.idleStateRetention = idleStateRetention;
    return this;
  }

   /**
   * 空闲状态最长保留时间，超过该时间没有进行更新的中间状态会被删除，单位为秒
   * @return idleStateRetention
  **/
  @ApiModelProperty(value = "空闲状态最长保留时间，超过该时间没有进行更新的中间状态会被删除，单位为秒")
  public Integer getIdleStateRetention() {
    return idleStateRetention;
  }

  public void setIdleStateRetention(Integer idleStateRetention) {
    this.idleStateRetention = idleStateRetention;
  }

  public UpdateFlinkSqlJobRequest edgeGroupIds(List<String> edgeGroupIds) {
    this.edgeGroupIds = edgeGroupIds;
    return this;
  }

  public UpdateFlinkSqlJobRequest addEdgeGroupIdsItem(String edgeGroupIdsItem) {
    if (this.edgeGroupIds == null) {
      this.edgeGroupIds = new ArrayList<String>();
    }
    this.edgeGroupIds.add(edgeGroupIdsItem);
    return this;
  }

   /**
   * 边缘计算组ID列表, 多个ID以逗号分隔
   * @return edgeGroupIds
  **/
  @ApiModelProperty(example = "\"{'edge_group_ids':['62de1e1c-066e-48a8-a79d-f461a31b2ee1','2eb00f85-99f2-4144-bcb7-d39ff47f9002']\"", value = "边缘计算组ID列表, 多个ID以逗号分隔")
  public List<String> getEdgeGroupIds() {
    return edgeGroupIds;
  }

  public void setEdgeGroupIds(List<String> edgeGroupIds) {
    this.edgeGroupIds = edgeGroupIds;
  }

  public UpdateFlinkSqlJobRequest dirtyDataStrategy(String dirtyDataStrategy) {
    this.dirtyDataStrategy = dirtyDataStrategy;
    return this;
  }

   /**
   * 作业脏数据策略。‘2’：保存；‘1’：抛出异常；‘0’：忽略；默认值为‘0’。
   * @return dirtyDataStrategy
  **/
  @ApiModelProperty(example = "0", value = "作业脏数据策略。‘2’：保存；‘1’：抛出异常；‘0’：忽略；默认值为‘0’。")
  public String getDirtyDataStrategy() {
    return dirtyDataStrategy;
  }

  public void setDirtyDataStrategy(String dirtyDataStrategy) {
    this.dirtyDataStrategy = dirtyDataStrategy;
  }

  public UpdateFlinkSqlJobRequest udfJarUrl(String udfJarUrl) {
    this.udfJarUrl = udfJarUrl;
    return this;
  }

   /**
   * 用户已上传到DLI资源管理系统的资源包名，用户sql作业的udf jar通过该参数传入
   * @return udfJarUrl
  **/
  @ApiModelProperty(example = "group/test.jar", value = "用户已上传到DLI资源管理系统的资源包名，用户sql作业的udf jar通过该参数传入")
  public String getUdfJarUrl() {
    return udfJarUrl;
  }

  public void setUdfJarUrl(String udfJarUrl) {
    this.udfJarUrl = udfJarUrl;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UpdateFlinkSqlJobRequest updateFlinkSqlJobRequest = (UpdateFlinkSqlJobRequest) o;
    return Objects.equals(this.name, updateFlinkSqlJobRequest.name) &&
        Objects.equals(this.desc, updateFlinkSqlJobRequest.desc) &&
        Objects.equals(this.queueName, updateFlinkSqlJobRequest.queueName) &&
        Objects.equals(this.sqlBody, updateFlinkSqlJobRequest.sqlBody) &&
        Objects.equals(this.runMode, updateFlinkSqlJobRequest.runMode) &&
        Objects.equals(this.cuNumber, updateFlinkSqlJobRequest.cuNumber) &&
        Objects.equals(this.parallelNumber, updateFlinkSqlJobRequest.parallelNumber) &&
        Objects.equals(this.checkpointEnabled, updateFlinkSqlJobRequest.checkpointEnabled) &&
        Objects.equals(this.checkpointMode, updateFlinkSqlJobRequest.checkpointMode) &&
        Objects.equals(this.checkpointInterval, updateFlinkSqlJobRequest.checkpointInterval) &&
        Objects.equals(this.obsBucket, updateFlinkSqlJobRequest.obsBucket) &&
        Objects.equals(this.logEnabled, updateFlinkSqlJobRequest.logEnabled) &&
        Objects.equals(this.smnTopic, updateFlinkSqlJobRequest.smnTopic) &&
        Objects.equals(this.restartWhenException, updateFlinkSqlJobRequest.restartWhenException) &&
        Objects.equals(this.idleStateRetention, updateFlinkSqlJobRequest.idleStateRetention) &&
        Objects.equals(this.edgeGroupIds, updateFlinkSqlJobRequest.edgeGroupIds) &&
        Objects.equals(this.dirtyDataStrategy, updateFlinkSqlJobRequest.dirtyDataStrategy) &&
        Objects.equals(this.udfJarUrl, updateFlinkSqlJobRequest.udfJarUrl);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, desc, queueName, sqlBody, runMode, cuNumber, parallelNumber, checkpointEnabled, checkpointMode, checkpointInterval, obsBucket, logEnabled, smnTopic, restartWhenException, idleStateRetention, edgeGroupIds, dirtyDataStrategy, udfJarUrl);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UpdateFlinkSqlJobRequest {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    desc: ").append(toIndentedString(desc)).append("\n");
    sb.append("    queueName: ").append(toIndentedString(queueName)).append("\n");
    sb.append("    sqlBody: ").append(toIndentedString(sqlBody)).append("\n");
    sb.append("    runMode: ").append(toIndentedString(runMode)).append("\n");
    sb.append("    cuNumber: ").append(toIndentedString(cuNumber)).append("\n");
    sb.append("    parallelNumber: ").append(toIndentedString(parallelNumber)).append("\n");
    sb.append("    checkpointEnabled: ").append(toIndentedString(checkpointEnabled)).append("\n");
    sb.append("    checkpointMode: ").append(toIndentedString(checkpointMode)).append("\n");
    sb.append("    checkpointInterval: ").append(toIndentedString(checkpointInterval)).append("\n");
    sb.append("    obsBucket: ").append(toIndentedString(obsBucket)).append("\n");
    sb.append("    logEnabled: ").append(toIndentedString(logEnabled)).append("\n");
    sb.append("    smnTopic: ").append(toIndentedString(smnTopic)).append("\n");
    sb.append("    restartWhenException: ").append(toIndentedString(restartWhenException)).append("\n");
    sb.append("    idleStateRetention: ").append(toIndentedString(idleStateRetention)).append("\n");
    sb.append("    edgeGroupIds: ").append(toIndentedString(edgeGroupIds)).append("\n");
    sb.append("    dirtyDataStrategy: ").append(toIndentedString(dirtyDataStrategy)).append("\n");
    sb.append("    udfJarUrl: ").append(toIndentedString(udfJarUrl)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

