package com.huawei.dli.sdk;

import com.huawei.dli.restapi.model.GroupResourceInfo;
import com.huawei.dli.restapi.model.PkgResourceInfo;

import java.util.ArrayList;
import java.util.List;

public class GroupResource {

    private String groupName;

    private String status;

    private String[] resourceNames;

    private long createTime;

    private long updateTime;

    private PackageResource[] details;

    public GroupResource(GroupResourceInfo groupResourceInfo) {
        this.groupName = groupResourceInfo.getGroupName();
        this.status = groupResourceInfo.getStatus();
        this.resourceNames = groupResourceInfo.getResources().toArray(new String[0]);
        this.createTime = groupResourceInfo.getCreateTime();
        this.updateTime = groupResourceInfo.getUpdateTime();
        List<PackageResource> packageResources = new ArrayList<>();
        if (groupResourceInfo.getDetails() != null) {
            for (PkgResourceInfo pkgResourceInfo : groupResourceInfo.getDetails()) {
                PackageResource packageResource = new PackageResource(pkgResourceInfo);
                packageResources.add(packageResource);
            }
        }
        this.details = packageResources.toArray(new PackageResource[0]);
    }

    public String getGroupName() {
        return groupName;
    }

    public String getStatus() {
        return status;
    }

    public String[] getResourceNames() {
        return resourceNames;
    }

    public long getCreateTime() {
        return createTime;
    }

    public long getUpdateTime() {
        return updateTime;
    }

    public PackageResource[] getDetails() {
        return details;
    }
}
