package com.huawei.dli.sdk;

import com.huawei.dli.restapi.model.PkgResourceInfo;

public class PackageResource {
    private String resourceName;

    private String resourceType;

    private String status;

    private String underlyingName;

    private long createTime;

    private long updateTime;

    public PackageResource(PkgResourceInfo pkgResourceInfo) {
        this.resourceName = pkgResourceInfo.getResourceName();
        this.resourceType = pkgResourceInfo.getResourceType();
        this.status = pkgResourceInfo.getStatus();
        this.underlyingName = pkgResourceInfo.getUnderlyingName();
        this.createTime = pkgResourceInfo.getCreateTime();
        this.updateTime = pkgResourceInfo.getUpdateTime();
    }

    public PackageResource(String name) {
        this.resourceName = name;
    }

    public String getResourceName() {
        return resourceName;
    }

    public String getResourceType() {
        return resourceType;
    }

    public String getStatus() {
        return status;
    }

    public String getUnderlyingName() {
        return underlyingName;
    }

    public long getCreateTime() {
        return createTime;
    }

    public long getUpdateTime() {
        return updateTime;
    }

    @Override
    public String toString() {
        return "Resource{"
            + "resourceName='" + resourceName + '\''
            + ", resourceType='" + resourceType + '\''
            + ", status='" + status + '\''
            + ", underlyingName='" + underlyingName + '\''
            + ", createTime=" + createTime
            + ", updateTime=" + updateTime
            + "}";
    }
}
