package com.huawei.dli.sdk.common;

import java.util.Locale;

public enum CompressType {

    NONE("NONE", 0),
    GZIP("GZIP", 1),
    BZIP2("BZIP2", 2),
    DEFLATE("DEFLATE", 3),
    UNKNOWN("UNKNOWN", 4);

    private final int value;

    private final String name;

    CompressType(String name, int value) {
        this.name = name;
        this.value = value;
    }

    public String getName() {
        return name;
    }

    public int getValue() {
        return value;
    }

    public static CompressType fromName(String name) {
        name = name.toUpperCase(Locale.ENGLISH);
        if (name.equals(NONE.name)) {
            return NONE;
        } else if (name.equals(GZIP.name)) {
            return GZIP;
        } else if (name.equals(BZIP2.name)) {
            return BZIP2;
        } else if (name.equals(DEFLATE.name)) {
            return DEFLATE;
        } else {
            return UNKNOWN;
        }
    }
}
