package com.huawei.dli.sdk.common;

import com.huawei.dli.sdk.TunnelJob;

import java.util.ArrayList;
import java.util.List;

import lombok.Builder;
import lombok.Getter;

@Builder
@Getter
public class DownloadJobParam {
    private String dbName;
    private String tblName;
    private String transactionId;
    private List<PartitionSpec> partitionSpecs;
    private TunnelJob.FileFormat fileFormat;
    private BadRecordPolicy badRecordPolicy;

    public void addPartitionSpecs(List<PartitionSpec> partitions) {
        if (partitionSpecs == null) {
            partitionSpecs = new ArrayList<>();
        }
        if (partitions != null && partitions.size() > 0) {
            this.partitionSpecs.addAll(partitions);
        }
    }

    public void addPartitionSpec(PartitionSpec partition) {
        if (partitionSpecs == null) {
            partitionSpecs = new ArrayList<>();
        }
        if (partition != null) {
            this.partitionSpecs.add(partition);
        }
    }
}
