package com.huawei.dli.sdk.common;

import java.util.Locale;

public enum ExportMode {

    ERRORIFEXISTS("ERRORIFEXISTS", 0),
    APPEND("APPEND", 1),
    OVERWRITE("OVERWRITE", 2),
    UNKNOWN("UNKNOWN", 3);

    private final int value;

    private final String name;

    ExportMode(String name, int value) {
        this.name = name;
        this.value = value;
    }

    public String getName() {
        return name;
    }

    public int getValue() {
        return value;
    }

    public static ExportMode fromName(String name) {
        name = name.toUpperCase(Locale.ENGLISH);
        if (name.equals(ERRORIFEXISTS.name)) {
            return ERRORIFEXISTS;
        } else if (name.equals(APPEND.name)) {
            return APPEND;
        } else if (name.equals(OVERWRITE.name)) {
            return OVERWRITE;
        } else {
            return UNKNOWN;
        }
    }
}
