package com.huawei.dli.sdk.common;

import com.huawei.dli.restapi.model.JobProgressListInfo;

import java.util.List;

public class JobProgressInfo {
    private Boolean isSuccess;

    private Long id = null;

    private String name = null;

    private String description = null;

    private String submissionTime = null;

    private String completionTime = null;

    private List<Long> stageIds = null;

    private String jobGroup = null;

    private JobStatus status = null;

    private Long numTasks = null;

    private Long numActiveTasks = null;

    private Long numCompletedTasks = null;

    private Long numSkippedTasks = null;

    private Long numFailedTasks = null;

    private Long numKilledTasks = null;

    private Long numCompletedIndices = null;

    private String numActiveStages = null;

    private Long numCompletedStages = null;

    private Long numSkippedStages = null;

    private Long numFailedStages = null;

    private Long killedTasksSummary = null;

    public JobProgressInfo(JobProgressListInfo jobProgressListInfo) {
        this.id = jobProgressListInfo.getId();
        this.name = jobProgressListInfo.getName();
        this.description = jobProgressListInfo.getDescription();
        this.submissionTime = jobProgressListInfo.getSubmissionTime();
        this.completionTime = jobProgressListInfo.getCompletionTime();
        this.stageIds = jobProgressListInfo.getStageIds();
        this.jobGroup = jobProgressListInfo.getJobGroup();
        this.status = JobStatus.fromName(jobProgressListInfo.getStatus());
        this.numTasks = jobProgressListInfo.getNumTasks();
        this.numActiveTasks = jobProgressListInfo.getNumActiveTasks();
        this.numCompletedTasks = jobProgressListInfo.getNumCompletedTasks();
        this.numSkippedTasks = jobProgressListInfo.getNumSkippedTasks();
        this.numFailedTasks = jobProgressListInfo.getNumFailedTasks();
        this.numKilledTasks = jobProgressListInfo.getNumKilledTasks();
        this.numCompletedIndices = jobProgressListInfo.getNumCompletedIndices();
        this.numActiveStages = jobProgressListInfo.getNumActiveStages();
        this.numCompletedStages = jobProgressListInfo.getNumCompletedStages();
        this.numSkippedStages = jobProgressListInfo.getNumSkippedStages();
        this.numFailedStages = jobProgressListInfo.getNumFailedStages();
        this.killedTasksSummary = jobProgressListInfo.getKilledTasksSummary();

    }

    public Boolean getSuccess() {
        return isSuccess;
    }

    public void setSuccess(Boolean success) {
        isSuccess = success;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getSubmissionTime() {
        return submissionTime;
    }

    public void setSubmissionTime(String submissionTime) {
        this.submissionTime = submissionTime;
    }

    public String getCompletionTime() {
        return completionTime;
    }

    public void setCompletionTime(String completionTime) {
        this.completionTime = completionTime;
    }

    public List<Long> getStageIds() {
        return stageIds;
    }

    public void setStageIds(List<Long> stageIds) {
        this.stageIds = stageIds;
    }

    public String getJobGroup() {
        return jobGroup;
    }

    public void setJobGroup(String jobGroup) {
        this.jobGroup = jobGroup;
    }

    public JobStatus getStatus() {
        return status;
    }

    public void setStatus(JobStatus status) {
        this.status = status;
    }

    public Long getNumTasks() {
        return numTasks;
    }

    public void setNumTasks(Long numTasks) {
        this.numTasks = numTasks;
    }

    public Long getNumActiveTasks() {
        return numActiveTasks;
    }

    public void setNumActiveTasks(Long numActiveTasks) {
        this.numActiveTasks = numActiveTasks;
    }

    public Long getNumCompletedTasks() {
        return numCompletedTasks;
    }

    public void setNumCompletedTasks(Long numCompletedTasks) {
        this.numCompletedTasks = numCompletedTasks;
    }

    public Long getNumSkippedTasks() {
        return numSkippedTasks;
    }

    public void setNumSkippedTasks(Long numSkippedTasks) {
        this.numSkippedTasks = numSkippedTasks;
    }

    public Long getNumFailedTasks() {
        return numFailedTasks;
    }

    public void setNumFailedTasks(Long numFailedTasks) {
        this.numFailedTasks = numFailedTasks;
    }

    public Long getNumKilledTasks() {
        return numKilledTasks;
    }

    public void setNumKilledTasks(Long numKilledTasks) {
        this.numKilledTasks = numKilledTasks;
    }

    public Long getNumCompletedIndices() {
        return numCompletedIndices;
    }

    public void setNumCompletedIndices(Long numCompletedIndices) {
        this.numCompletedIndices = numCompletedIndices;
    }

    public String getNumActiveStages() {
        return numActiveStages;
    }

    public void setNumActiveStages(String numActiveStages) {
        this.numActiveStages = numActiveStages;
    }

    public Long getNumCompletedStages() {
        return numCompletedStages;
    }

    public void setNumCompletedStages(Long numCompletedStages) {
        this.numCompletedStages = numCompletedStages;
    }

    public Long getNumSkippedStages() {
        return numSkippedStages;
    }

    public void setNumSkippedStages(Long numSkippedStages) {
        this.numSkippedStages = numSkippedStages;
    }

    public Long getNumFailedStages() {
        return numFailedStages;
    }

    public void setNumFailedStages(Long numFailedStages) {
        this.numFailedStages = numFailedStages;
    }

    public Long getKilledTasksSummary() {
        return killedTasksSummary;
    }

    public void setKilledTasksSummary(Long killedTasksSummary) {
        this.killedTasksSummary = killedTasksSummary;
    }
}
