package com.huawei.dli.sdk.common;

import java.util.Locale;

public enum JobStatus {

    LAUNCHING("LAUNCHING", 0),
    RUNNING("RUNNING", 1),
    FINISHED("FINISHED", 2),
    FAILED("FAILED", 3),
    CANCELLED("CANCELLED", 4),
    UNKNOWN("UNKNOWN", 5);

    private final int value;

    private final String name;

    JobStatus(String name, int value) {
        this.name = name;
        this.value = value;
    }

    public String getName() {
        return name;
    }

    public int getValue() {
        return value;
    }

    public static JobStatus fromName(String name) {
        name = name.toUpperCase(Locale.ENGLISH);
        if (name.equals(LAUNCHING.name)) {
            return LAUNCHING;
        } else if (name.equals(RUNNING.name)) {
            return RUNNING;
        } else if (name.equals(FINISHED.name)) {
            return FINISHED;
        } else if (name.equals(FAILED.name)) {
            return FAILED;
        } else if (name.equals(CANCELLED.name)) {
            return CANCELLED;
        } else {
            return UNKNOWN;
        }
    }

}
