package com.huawei.dli.sdk.common;

import com.google.gson.JsonArray;
import com.google.gson.JsonObject;

import java.util.HashMap;
import java.util.Map;

public class SparkJobInfo {

    private String kind;

    private String file;

    private String className;

    private String clusterName;

    private String[] args;

    private String scType;

    private String[] jars;

    private String[] pyFiles;

    private String[] files;

    private String[] modules;

    private SparkJobResource[] resources;

    private String[] groups;

    private Map<String, String> conf;

    private String name;

    private int heartbeatTimeoutInSecond = -1;

    private String driverMemory;

    private int driverCores = -1;

    private String executorMemory;

    private int executorCores = -1;

    private int numExecutors = -1;

    private String obsBucket;

    private boolean autoRecovery;

    private int maxRetryTimes;

    private String catalogName;

    private int from;

    private int size;

    private int index;

    private String jobId;

    private String image;

    private String feature;

    private String sparkVersion;

    public void addConfItem(String key, String value) {
        if (this.conf == null) {
            this.conf = new HashMap<>();
        }
        this.conf.put(key, value);
    }

    public String getKind() {
        return kind;
    }

    public void setKind(String kind) {
        this.kind = kind;
    }

    public String getFile() {
        return file;
    }

    public void setFile(String file) {
        this.file = file;
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public String getClusterName() {
        return clusterName;
    }

    /**
     * use getClusterName()
     * @return the queue name
     */
    @Deprecated
    public String getCluster_name() {
        return clusterName;
    }

    public void setClusterName(String clusterName) {
        this.clusterName = clusterName;
    }

    /**
     * use setClusterName(String clusterName)
     * @param clusterName the queue name
     */
    @Deprecated
    public void setCluster_name(String clusterName) {
        this.clusterName = clusterName;
    }

    public String[] getArgs() {
        return args;
    }

    public void setArgs(String[] args) {
        this.args = args;
    }

    public String getScType() {
        return scType;
    }

    /**
     * use getScType()
     * @return scType
     */
    @Deprecated
    public String getSc_type() {
        return scType;
    }

    public void setScType(String scType) {
        this.scType = scType;
    }

    /**
     * use setScType(String scType)
     * @param scType A, B or C
     */
    @Deprecated
    public void setSc_type(String scType) {
        this.scType = scType;
    }

    public String[] getJars() {
        return jars;
    }

    public void setJars(String[] jars) {
        this.jars = jars;
    }

    public String[] getPyFiles() {
        return pyFiles;
    }

    public void setPyFiles(String[] pyFiles) {
        this.pyFiles = pyFiles;
    }

    public String[] getFiles() {
        return files;
    }

    public void setFiles(String[] files) {
        this.files = files;
    }

    public String[] getModules() {
        return modules;
    }

    public void setModules(String[] modules) {
        this.modules = modules;
    }

    public SparkJobResource[] getResources() {
        return resources;
    }

    public void setResources(SparkJobResource[] resources) {
        this.resources = resources;
    }

    public String[] getGroups() {
        return groups;
    }

    public void setGroups(String[] groups) {
        this.groups = groups;
    }

    public Map<String, String> getConf() {
        return conf;
    }

    public void setConf(Map<String, String> conf) {
        this.conf = conf;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getHeartbeatTimeoutInSecond() {
        return heartbeatTimeoutInSecond;
    }

    public void setHeartbeatTimeoutInSecond(int heartbeatTimeoutInSecond) {
        this.heartbeatTimeoutInSecond = heartbeatTimeoutInSecond;
    }

    public String getDriverMemory() {
        return driverMemory;
    }

    public void setDriverMemory(String driverMemory) {
        this.driverMemory = driverMemory;
    }

    public int getDriverCores() {
        return driverCores;
    }

    public void setDriverCores(int driverCores) {
        this.driverCores = driverCores;
    }

    public String getExecutorMemory() {
        return executorMemory;
    }

    public void setExecutorMemory(String executorMemory) {
        this.executorMemory = executorMemory;
    }

    public int getExecutorCores() {
        return executorCores;
    }

    public void setExecutorCores(int executorCores) {
        this.executorCores = executorCores;
    }

    public int getNumExecutors() {
        return numExecutors;
    }

    public void setNumExecutors(int numExecutors) {
        this.numExecutors = numExecutors;
    }

    public String getObsBucket() {
        return obsBucket;
    }

    public void setObsBucket(String obsBucket) {
        this.obsBucket = obsBucket;
    }

    public boolean isAutoRecovery() {
        return autoRecovery;
    }

    public void setAutoRecovery(boolean autoRecovery) {
        this.autoRecovery = autoRecovery;
    }

    public int getMaxRetryTimes() {
        return maxRetryTimes;
    }

    public void setMaxRetryTimes(int maxRetryTimes) {
        this.maxRetryTimes = maxRetryTimes;
        if (maxRetryTimes == 0) {
            if (this.isAutoRecovery()) {
                this.maxRetryTimes = 20;
            }
        }
    }

    public String getCatalogName() {
        return catalogName;
    }

    public void setCatalogName(String catalogName) {
        this.catalogName = catalogName;
    }

    public int getFrom() {
        return from;
    }

    public void setFrom(int from) {
        this.from = from;
    }

    public int getSize() {
        return size;
    }

    public void setSize(int size) {
        this.size = size;
    }

    public int getIndex() {
        return index;
    }

    public void setIndex(int index) {
        this.index = index;
    }

    public String getJobId() {
        return jobId;
    }

    public void setJobId(String jobId) {
        this.jobId = jobId;
    }

    public void setImage(String image) {
        this.image = image;
    }

    public String getImage() {
        return image;
    }

    public void setSparkVersion(String sparkVersion) {
        this.sparkVersion = sparkVersion;
    }

    public String getSparkVersion() {
        return sparkVersion;
    }

    public void setFeature(String feature) {
        this.feature = feature;
    }

    public String getFeature() {
        return feature;
    }

    public JsonObject toJsonObj() {
        JsonObject jsonObject = new JsonObject();
        if (kind != null) {
            jsonObject.addProperty("kind", kind);
        }
        if (file != null) {
            jsonObject.addProperty("file", file);
        }
        if (className != null) {
            jsonObject.addProperty("className", className);
        }
        jsonObject.addProperty("cluster_name", clusterName);
        if (args != null && args.length > 0) {
            JsonArray argsJsonArray = addArr(args);
            jsonObject.add("args", argsJsonArray);
        }
        if (scType != null) {
            jsonObject.addProperty("sc_type", scType);
        }
        if (jars != null && jars.length > 0) {
            JsonArray jarsJsonArr = addArr(jars);
            jsonObject.add("jars", jarsJsonArr);
        }
        if (pyFiles != null && pyFiles.length > 0) {
            JsonArray pyFilesJsonArr = addArr(pyFiles);
            jsonObject.add("pyFiles", pyFilesJsonArr);
        }
        if (files != null && files.length > 0) {
            JsonArray filesJsonArr = addArr(files);
            jsonObject.add("files", filesJsonArr);
        }
        if (modules != null && modules.length > 0) {
            JsonArray modulesJsonArr = addArr(modules);
            jsonObject.add("modules", modulesJsonArr);
        }
        if (resources != null && resources.length > 0) {
            JsonArray resJsonArr = new JsonArray();
            for (SparkJobResource jobResource : resources) {
                JsonObject resJsonObj = new JsonObject();
                resJsonObj.addProperty("name", jobResource.getName());
                resJsonObj.addProperty("type", jobResource.getType());
                resJsonArr.add(resJsonObj);
            }
            jsonObject.add("resources", resJsonArr);
        }
        if (groups != null && groups.length > 0) {
            JsonArray groupsJsonArr = addArr(groups);
            jsonObject.add("groups", groupsJsonArr);
        }
        if (conf != null && conf.size() > 0) {
            JsonObject confJsonObj = new JsonObject();
            for (Map.Entry<String, String> entry : conf.entrySet()) {
                confJsonObj.addProperty(entry.getKey(), entry.getValue());
            }
            jsonObject.add("conf", confJsonObj);
        }
        if (name != null) {
            jsonObject.addProperty("name", name);
        }
        if (heartbeatTimeoutInSecond != -1) {
            jsonObject.addProperty("heartbeatTimeoutInSecond", heartbeatTimeoutInSecond);
        }
        if (driverMemory != null) {
            jsonObject.addProperty("driverMemory", driverMemory);
        }
        if (driverCores != -1) {
            jsonObject.addProperty("driverCores", driverCores);
        }
        if (executorMemory != null) {
            jsonObject.addProperty("executorMemory", executorMemory);
        }
        if (executorCores != -1) {
            jsonObject.addProperty("executorCores", executorCores);
        }
        if (numExecutors != -1) {
            jsonObject.addProperty("numExecutors", numExecutors);
        }
        if (obsBucket != null) {
            jsonObject.addProperty("obsBucket", obsBucket);
        }
        if (autoRecovery) {
            jsonObject.addProperty("autoRecovery", true);
            jsonObject.addProperty("maxRetryTimes", maxRetryTimes);
        }
        if (catalogName != null) {
            jsonObject.addProperty("catalog_name", catalogName);
        }
        if (image != null) {
            jsonObject.addProperty("image", image);
        }
        if (sparkVersion != null) {
            jsonObject.addProperty("spark_version", sparkVersion);
        }

        if (feature != null) {
            jsonObject.addProperty("feature", feature);
        }

        return jsonObject;
    }

    private JsonArray addArr(String[] strArr) {
        JsonArray jsonArr = new JsonArray();
        for (String str : strArr) {
            jsonArr.add(str);
        }
        return jsonArr;
    }

    public String toJson() {
        return toJsonObj().toString();
    }

}
