package com.huawei.dli.sdk.common;

import com.huawei.dli.restapi.model.SessionInfo;

import java.util.Map;

public class SparkJobResultInfo {
    private String id;

    private String appId;

    private String name;

    private String owner;

    private String proxyUser;

    private SparkJobStatus state;

    private String kind;

    private Map<String, String> appInfo;

    private String scType;

    private String clusterName;

    private long createTime;

    private long updateTime;

    private long duration;

    public SparkJobResultInfo(SessionInfo sessionInfo) {
        this.id = sessionInfo.getId();
        this.appId = sessionInfo.getAppId();
        this.name = sessionInfo.getName();
        this.owner = sessionInfo.getOwner();
        this.proxyUser = sessionInfo.getProxyUser();
        this.state = SparkJobStatus.fromName(sessionInfo.getState());
        this.kind = sessionInfo.getKind();
        this.appInfo = sessionInfo.getAppInfo();
        this.scType = sessionInfo.getScType();
        this.clusterName = sessionInfo.getClusterName();
        this.createTime = sessionInfo.getCreateTime();
        this.updateTime = sessionInfo.getUpdateTime();
        if (sessionInfo.getDuration() != null) {
            this.duration = sessionInfo.getDuration();
        }
    }

    public String getId() {
        return id;
    }

    public String getAppId() {
        return appId;
    }

    public String getName() {
        return name;
    }

    public String getOwner() {
        return owner;
    }

    public String getProxyUser() {
        return proxyUser;
    }

    public SparkJobStatus getState() {
        return state;
    }

    public String getKind() {
        return kind;
    }

    public Map<String, String> getAppInfo() {
        return appInfo;
    }

    public String getScType() {
        return scType;
    }

    public String getClusterName() {
        return clusterName;
    }

    public long getCreateTime() {
        return createTime;
    }

    public long getUpdateTime() {
        return updateTime;
    }

    public long getDuration() {
        return duration;
    }

    @Override
    public String toString() {
        return "SparkJobResultInfo{"
            + "id='" + id + '\''
            + ", appId='" + appId + '\''
            + ", name='" + name + '\''
            + ", owner='" + owner + '\''
            + ", proxyUser='" + proxyUser + '\''
            + ", state=" + state
            + ", kind='" + kind + '\''
            + ", appInfo=" + appInfo
            + ", scType='" + scType + '\''
            + ", clusterName='" + clusterName + '\''
            + ", createTime=" + createTime
            + ", updateTime=" + updateTime
            + ", duration=" + duration
            + '}';
    }
}
