package com.huawei.dli.sdk.common;

import java.util.Locale;

public enum SparkJobStatus {

    NOT_STARTED("not_started", 0),
    STARTING("starting", 1),
    IDLE("idle", 2),
    BUSY("busy", 3),
    RUNNING("running", 4),
    SHUTTING_DOWN("shutting_down", 5),
    ERROR("error", 6),
    DEAD("dead", 7),
    SUCCESS("success", 8),
    UNKNOWN("UNKNOWN", 9);

    private final String name;

    private final int value;

    SparkJobStatus(String name, int value) {
        this.value = value;
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public int getValue() {
        return value;
    }

    public static SparkJobStatus fromName(String name) {
        name = name.toLowerCase(Locale.ENGLISH);
        if (name.equals(NOT_STARTED.name)) {
            return NOT_STARTED;
        } else if (name.equals(STARTING.name)) {
            return STARTING;
        } else if (name.equals(IDLE.name)) {
            return IDLE;
        } else if (name.equals(BUSY.name)) {
            return BUSY;
        } else if (name.equals(RUNNING.name)) {
            return RUNNING;
        } else if (name.equals(SHUTTING_DOWN.name)) {
            return SHUTTING_DOWN;
        } else if (name.equals(ERROR.name)) {
            return ERROR;
        } else if (name.equals(DEAD.name)) {
            return DEAD;
        } else if (name.equals(SUCCESS.name)) {
            return SUCCESS;
        } else {
            return UNKNOWN;
        }
    }
}
