package com.huawei.dli.sdk.common;

import java.util.Locale;

public enum StorageType {

    CSV("csv", 0),
    PARQUET("parquet", 1),
    ORC("orc", 2),
    JSON("json", 3),
    CARBON("carbon", 4),
    AVRO("avro", 5),
    UNKNOWN("UNKNOWN", 6);

    private final int value;

    private final String name;

    StorageType(String name, int value) {
        this.name = name;
        this.value = value;
    }

    public String getName() {
        return name;
    }

    public int getValue() {
        return value;
    }

    public static StorageType fromName(String name) {
        name = name.toLowerCase(Locale.ENGLISH);
        if (name.equals(CSV.name)) {
            return CSV;
        } else if (name.equals(PARQUET.name)) {
            return PARQUET;
        } else if (name.equals(ORC.name)) {
            return ORC;
        } else if (name.equals(JSON.name)) {
            return JSON;
        } else if (name.equals(CARBON.name)) {
            return CARBON;
        } else if (name.equals(AVRO.name)) {
            return AVRO;
        } else {
            return UNKNOWN;
        }

    }
}

