package com.huawei.dli.sdk.common;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.Locale;

public enum TableType {

    EXTERNAL("EXTERNAL", 0),
    MANAGED("MANAGED", 1),
    VIEW("VIEW", 2),
    UNKNOWN("UNKNOWN", 3);

    private final int value;

    private final String name;

    private static final Logger LOGGER = LoggerFactory.getLogger(TableType.class);

    TableType(String name, int value) {
        this.name = name;
        this.value = value;
    }

    public String getName() {
        return name;
    }

    public int getValue() {
        return value;
    }

    public static TableType fromName(String name) {
        name = name.toUpperCase(Locale.ENGLISH);
        if (name.equals(EXTERNAL.name)) {
            return EXTERNAL;
        } else if (name.equals(MANAGED.name)) {
            return MANAGED;
        } else if (name.equals(VIEW.name)) {
            return VIEW;
        } else {
            LOGGER.error("fromName: " + name);
            return UNKNOWN;
        }
    }
}
