package com.huawei.dli.sdk.common.type;

import com.huawei.dli.sdk.common.DataTypeInfo;
import com.huawei.dli.sdk.exception.DLIException;

import java.util.List;

public interface DliArray {
    /**
     * Get the data type info of the element in the Array.
     *
     * @return DataTypeInfo
     */
    DataTypeInfo getElementTypeInfo();

    /**
     * Get the list of the elements in the Array
     *
     * @return List
     * @throws DLIException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    List<Object> getElementValues() throws DLIException;
}
