package com.huawei.dli.sdk.common.type;

import com.huawei.dli.sdk.common.DataTypeInfo;
import com.huawei.dli.sdk.exception.DLIException;

import java.util.Map;

public interface DliMap {
    /**
     * Get the Type info of the key in the Map
     *
     * @return DataTypeInfo
     */
    DataTypeInfo getKeyTypeInfo();

    /**
     * Get the Type info of the value in the Map
     *
     * @return DataTypeInfo
     */
    DataTypeInfo getValueTypeInfo();

    /**
     * Get the key and value of the Map
     *
     * @return Map
     * @throws DLIException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    Map getValues() throws DLIException;
}
