package com.huawei.dli.sdk.common.type;

import com.huawei.dli.sdk.common.DataType;
import com.huawei.dli.sdk.common.DataTypeInfo;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class SimpleArrayTypeInfo implements ArrayTypeInfo {
    private static final Logger LOGGER = LoggerFactory.getLogger(SimpleArrayTypeInfo.class);

    private DataTypeInfo valueType;

    SimpleArrayTypeInfo(DataTypeInfo typeInfo) {
        if (typeInfo == null) {
            LOGGER.error("Invalid element type.");
            throw new IllegalArgumentException("Invalid element type.");
        } else {
            this.valueType = typeInfo;
        }
    }

    public String getTypeName() {
        return this.getDataType().getName() + "<" + this.valueType.toString() + ">";
    }

    public DataTypeInfo getElementTypeInfo() {
        return this.valueType;
    }

    public DataType getDataType() {
        return DataType.ARRAY;
    }

    public String toString() {
        return this.getTypeName();
    }
}
