package com.huawei.dli.sdk.common.type;

import com.huawei.dli.sdk.common.DataType;
import com.huawei.dli.sdk.common.DataTypeInfo;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class SimpleMapTypeInfo implements MapTypeInfo {
    private static final Logger LOGGER = LoggerFactory.getLogger(SimpleMapTypeInfo.class);

    private DataTypeInfo keyType;

    private DataTypeInfo valueType;

    SimpleMapTypeInfo(DataTypeInfo keyType, DataTypeInfo valueType) {
        if (keyType == null || valueType == null) {
            LOGGER.error("Invalid key or value type for map.");
            throw new IllegalArgumentException("Invalid key or value type for map.");
        }

        this.keyType = keyType;
        this.valueType = valueType;
    }

    public DataTypeInfo getKeyTypeInfo() {
        return this.keyType;
    }

    public DataTypeInfo getValueTypeInfo() {
        return this.valueType;
    }

    public DataType getDataType() {
        return DataType.MAP;
    }

    public String getTypeName() {
        return this.getDataType().getName() + "<" + keyType.toString() + "," + valueType.toString() + ">";
    }

    public String toString() {
        return this.getTypeName();
    }
}
