package com.huawei.dli.sdk.common.type;

import com.huawei.dli.sdk.common.DataTypeInfo;

import java.util.List;

public interface StructTypeInfo extends DataTypeInfo {
    /**
     * Get the list of the field names of the Struct type info
     *
     * @return List
     */
    List<String> getFieldNames();

    /**
     * Get the list of the field type infos of the Struct type info
     *
     * @return List
     */
    List<DataTypeInfo> getFieldTypeInfos();

    /**
     * Get the field number of the Struct type info
     *
     * @return int
     */
    int getFieldCount();
}
