package com.huawei.dli.restapi.api;

import com.huawei.dli.restapi.ApiCallback;
import com.huawei.dli.restapi.ApiClient;
import com.huawei.dli.restapi.ApiException;
import com.huawei.dli.restapi.ApiResponse;
import com.huawei.dli.restapi.Configuration;
import com.huawei.dli.restapi.Pair;
import com.huawei.dli.restapi.ProgressRequestBody;
import com.huawei.dli.restapi.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.huawei.dli.restapi.model.ClusterInfo;
import com.huawei.dli.restapi.model.ClusterInfos;
import com.huawei.dli.restapi.model.ColumnResult;
import com.huawei.dli.restapi.model.CreateClusterRequest;
import com.huawei.dli.restapi.model.CreateFlinkJarJobRequest;
import com.huawei.dli.restapi.model.CreateFlinkJobTemplateRequest;
import com.huawei.dli.restapi.model.CreateTsdbReq;
import com.huawei.dli.restapi.model.CreateTsdbResp;
import com.huawei.dli.restapi.model.DatabaseInfo;
import com.huawei.dli.restapi.model.DatabaseResult;
import com.huawei.dli.restapi.model.DeleteJobInBatchRequest;
import com.huawei.dli.restapi.model.DetailResult;
import com.huawei.dli.restapi.model.DownloadCreateJobResult;
import com.huawei.dli.restapi.model.EmptyBody;
import com.huawei.dli.restapi.model.EmptyResponse;
import com.huawei.dli.restapi.model.ExportCommonInfo;
import com.huawei.dli.restapi.model.ExportJobRequest;
import com.huawei.dli.restapi.model.FlinkJobApigSinksResponse;
import com.huawei.dli.restapi.model.FlinkJobExecutePlanResponse;
import com.huawei.dli.restapi.model.FlinkJobTemplateCreateResponse;
import com.huawei.dli.restapi.model.FlinkJobTemplateDeleteResponse;
import com.huawei.dli.restapi.model.FlinkJobTemplateListResponse;
import com.huawei.dli.restapi.model.GetFlinkJobDetailResponse;
import com.huawei.dli.restapi.model.GetFlinkJobsMetricsBody;
import com.huawei.dli.restapi.model.GetTsdbByIdResp;
import com.huawei.dli.restapi.model.GetTsdbListResp;
import com.huawei.dli.restapi.model.GlobalBatchResponse;
import com.huawei.dli.restapi.model.GlobalErrorResponse;
import com.huawei.dli.restapi.model.GlobalResponse;
import com.huawei.dli.restapi.model.ImportJobRequest;
import com.huawei.dli.restapi.model.JobListResult;
import com.huawei.dli.restapi.model.JobProgressResult;
import com.huawei.dli.restapi.model.JobResult;
import com.huawei.dli.restapi.model.JobStatusResponse;
import com.huawei.dli.restapi.model.JobUpdateResponse;
import com.huawei.dli.restapi.model.MessageInfo;
import com.huawei.dli.restapi.model.ObsBuckets;
import com.huawei.dli.restapi.model.ObsSelectJobRequest;
import com.huawei.dli.restapi.model.ObsSelectJobResult;
import com.huawei.dli.restapi.model.PartitionResult;
import com.huawei.dli.restapi.model.PkgResourceInfo;
import com.huawei.dli.restapi.model.PkgResourceRequest;
import com.huawei.dli.restapi.model.PrivilegeInfo;
import com.huawei.dli.restapi.model.PrivilegeResult;
import com.huawei.dli.restapi.model.QueryFlinkJobListResponse;
import com.huawei.dli.restapi.model.QueryFlinkJobMetricsResponse;
import com.huawei.dli.restapi.model.QueueActionErrorResponse;
import com.huawei.dli.restapi.model.QueueActionRequest;
import com.huawei.dli.restapi.model.QueueActionResponse;
import com.huawei.dli.restapi.model.QueueInfo;
import com.huawei.dli.restapi.model.QueueResult;
import com.huawei.dli.restapi.model.ResourceInfos;
import com.huawei.dli.restapi.model.ResourceMsg;
import com.huawei.dli.restapi.model.ResponseInfo;
import com.huawei.dli.restapi.model.ResponseJobInfo;
import com.huawei.dli.restapi.model.ResponseQueueInfo;
import com.huawei.dli.restapi.model.RunFlinkJobRequest;
import com.huawei.dli.restapi.model.SQLJobRequest;
import com.huawei.dli.restapi.model.SessionInfo;
import com.huawei.dli.restapi.model.SessionInfos;
import com.huawei.dli.restapi.model.SessionLog;
import com.huawei.dli.restapi.model.SessionState;
import com.huawei.dli.restapi.model.StatusResult;
import com.huawei.dli.restapi.model.StopFlinkJobRequest;
import com.huawei.dli.restapi.model.SubmitFlinkSqlJobRequest;
import com.huawei.dli.restapi.model.TableInfo;
import com.huawei.dli.restapi.model.TableListResult;
import com.huawei.dli.restapi.model.UpdateFlinkJarJobRequest;
import com.huawei.dli.restapi.model.UpdateFlinkJobTemplateRequest;
import com.huawei.dli.restapi.model.UpdateFlinkSqlJobRequest;
import com.huawei.dli.restapi.model.UpdateResourceOwner;
import com.huawei.dli.restapi.model.UpdateTsdbReq;
import com.huawei.dli.restapi.model.UploadCommitJobRequest;
import com.huawei.dli.restapi.model.UploadCommitJobResult;
import com.huawei.dli.restapi.model.UploadCreateJobRequest;
import com.huawei.dli.restapi.model.UploadCreateJobResult;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class RestApi {
    private ApiClient apiClient;

    public RestApi() {
        this(Configuration.getDefaultApiClient());
    }

    public RestApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for alertResourceOrGroupOwner
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call alertResourceOrGroupOwnerCall(String projectId, UpdateResourceOwner body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/resources/owner"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call alertResourceOrGroupOwnerValidateBeforeCall(String projectId, UpdateResourceOwner body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling alertResourceOrGroupOwner(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling alertResourceOrGroupOwner(Async)");
        }
        
        
        okhttp3.Call call = alertResourceOrGroupOwnerCall(projectId, body, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Modify owner of resource
     * Modify owner of resource.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ResponseInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseInfo alertResourceOrGroupOwner(String projectId, UpdateResourceOwner body, String xAuthToken) throws ApiException {
        ApiResponse<ResponseInfo> resp = alertResourceOrGroupOwnerWithHttpInfo(projectId, body, xAuthToken);
        return resp.getData();
    }

    /**
     * Modify owner of resource
     * Modify owner of resource.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;ResponseInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseInfo> alertResourceOrGroupOwnerWithHttpInfo(String projectId, UpdateResourceOwner body, String xAuthToken) throws ApiException {
        okhttp3.Call call = alertResourceOrGroupOwnerValidateBeforeCall(projectId, body, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Modify owner of resource (asynchronously)
     * Modify owner of resource.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call alertResourceOrGroupOwnerAsync(String projectId, UpdateResourceOwner body, String xAuthToken, final ApiCallback<ResponseInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = alertResourceOrGroupOwnerValidateBeforeCall(projectId, body, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for authorizeBucket
     * @param projectId project id, 用于不同project取token. (required)
     * @param obsBuckets 授权一个或多个OBS bucket权限给Data lake insight, 请求参数为json格式 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call authorizeBucketCall(String projectId, ObsBuckets obsBuckets, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = obsBuckets;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/dli/obs-authorize"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call authorizeBucketValidateBeforeCall(String projectId, ObsBuckets obsBuckets, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling authorizeBucket(Async)");
        }
        
        // verify the required parameter 'obsBuckets' is set
        if (obsBuckets == null) {
            throw new ApiException("Missing the required parameter 'obsBuckets' when calling authorizeBucket(Async)");
        }
        
        
        okhttp3.Call call = authorizeBucketCall(projectId, obsBuckets, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 用户主动授权起OBS桶的操作权限给DLI服务, 用于保存用户作业的checkpoint、作业的运行日志等
     * 
     * @param projectId project id, 用于不同project取token. (required)
     * @param obsBuckets 授权一个或多个OBS bucket权限给Data lake insight, 请求参数为json格式 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return GlobalResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GlobalResponse authorizeBucket(String projectId, ObsBuckets obsBuckets, String xAuthToken) throws ApiException {
        ApiResponse<GlobalResponse> resp = authorizeBucketWithHttpInfo(projectId, obsBuckets, xAuthToken);
        return resp.getData();
    }

    /**
     * 用户主动授权起OBS桶的操作权限给DLI服务, 用于保存用户作业的checkpoint、作业的运行日志等
     * 
     * @param projectId project id, 用于不同project取token. (required)
     * @param obsBuckets 授权一个或多个OBS bucket权限给Data lake insight, 请求参数为json格式 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;GlobalResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GlobalResponse> authorizeBucketWithHttpInfo(String projectId, ObsBuckets obsBuckets, String xAuthToken) throws ApiException {
        okhttp3.Call call = authorizeBucketValidateBeforeCall(projectId, obsBuckets, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<GlobalResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 用户主动授权起OBS桶的操作权限给DLI服务, 用于保存用户作业的checkpoint、作业的运行日志等 (asynchronously)
     * 
     * @param projectId project id, 用于不同project取token. (required)
     * @param obsBuckets 授权一个或多个OBS bucket权限给Data lake insight, 请求参数为json格式 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call authorizeBucketAsync(String projectId, ObsBuckets obsBuckets, String xAuthToken, final ApiCallback<GlobalResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = authorizeBucketValidateBeforeCall(projectId, obsBuckets, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GlobalResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for cancelJob
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call cancelJobCall(String projectId, String jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/jobs/{job_id}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "job_id" + "\\}", apiClient.escapeString(jobId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call cancelJobValidateBeforeCall(String projectId, String jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling cancelJob(Async)");
        }
        
        // verify the required parameter 'jobId' is set
        if (jobId == null) {
            throw new ApiException("Missing the required parameter 'jobId' when calling cancelJob(Async)");
        }
        
        
        okhttp3.Call call = cancelJobCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Cancel job
     * Canceling a job that has already been submitted can not be canceled if the job has been completed or failed.
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ResponseInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseInfo cancelJob(String projectId, String jobId, String xAuthToken) throws ApiException {
        ApiResponse<ResponseInfo> resp = cancelJobWithHttpInfo(projectId, jobId, xAuthToken);
        return resp.getData();
    }

    /**
     * Cancel job
     * Canceling a job that has already been submitted can not be canceled if the job has been completed or failed.
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;ResponseInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseInfo> cancelJobWithHttpInfo(String projectId, String jobId, String xAuthToken) throws ApiException {
        okhttp3.Call call = cancelJobValidateBeforeCall(projectId, jobId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Cancel job (asynchronously)
     * Canceling a job that has already been submitted can not be canceled if the job has been completed or failed.
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call cancelJobAsync(String projectId, String jobId, String xAuthToken, final ApiCallback<ResponseInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = cancelJobValidateBeforeCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for cancelJob_0
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The current queue name, the SQL will use the current queue resources to calculate. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call cancelJob_0Call(String projectId, String queueName, String jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/queues/{queue_name}/jobs/{job_id}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "queue_name" + "\\}", apiClient.escapeString(queueName.toString()))
            .replaceAll("\\{" + "job_id" + "\\}", apiClient.escapeString(jobId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call cancelJob_0ValidateBeforeCall(String projectId, String queueName, String jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling cancelJob_0(Async)");
        }
        
        // verify the required parameter 'queueName' is set
        if (queueName == null) {
            throw new ApiException("Missing the required parameter 'queueName' when calling cancelJob_0(Async)");
        }
        
        // verify the required parameter 'jobId' is set
        if (jobId == null) {
            throw new ApiException("Missing the required parameter 'jobId' when calling cancelJob_0(Async)");
        }
        
        
        okhttp3.Call call = cancelJob_0Call(projectId, queueName, jobId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Cancel job
     * Canceling a job that has already been submitted can not be canceled if the job has been completed or failed.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The current queue name, the SQL will use the current queue resources to calculate. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ResponseInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseInfo cancelJob_0(String projectId, String queueName, String jobId, String xAuthToken) throws ApiException {
        ApiResponse<ResponseInfo> resp = cancelJob_0WithHttpInfo(projectId, queueName, jobId, xAuthToken);
        return resp.getData();
    }

    /**
     * Cancel job
     * Canceling a job that has already been submitted can not be canceled if the job has been completed or failed.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The current queue name, the SQL will use the current queue resources to calculate. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;ResponseInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseInfo> cancelJob_0WithHttpInfo(String projectId, String queueName, String jobId, String xAuthToken) throws ApiException {
        okhttp3.Call call = cancelJob_0ValidateBeforeCall(projectId, queueName, jobId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Cancel job (asynchronously)
     * Canceling a job that has already been submitted can not be canceled if the job has been completed or failed.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The current queue name, the SQL will use the current queue resources to calculate. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call cancelJob_0Async(String projectId, String queueName, String jobId, String xAuthToken, final ApiCallback<ResponseInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = cancelJob_0ValidateBeforeCall(projectId, queueName, jobId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for checkSQL
     * @param projectId Project ID for resource isolation. (required)
     * @param sqLJobInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call checkSQLCall(String projectId, SQLJobRequest sqLJobInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = sqLJobInfo;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/jobs/check-sql"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call checkSQLValidateBeforeCall(String projectId, SQLJobRequest sqLJobInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling checkSQL(Async)");
        }
        
        // verify the required parameter 'sqLJobInfo' is set
        if (sqLJobInfo == null) {
            throw new ApiException("Missing the required parameter 'sqLJobInfo' when calling checkSQL(Async)");
        }
        
        
        okhttp3.Call call = checkSQLCall(projectId, sqLJobInfo, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Check sql
     * Check the SQL grammar.
     * @param projectId Project ID for resource isolation. (required)
     * @param sqLJobInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ResponseJobInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseJobInfo checkSQL(String projectId, SQLJobRequest sqLJobInfo, String xAuthToken) throws ApiException {
        ApiResponse<ResponseJobInfo> resp = checkSQLWithHttpInfo(projectId, sqLJobInfo, xAuthToken);
        return resp.getData();
    }

    /**
     * Check sql
     * Check the SQL grammar.
     * @param projectId Project ID for resource isolation. (required)
     * @param sqLJobInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;ResponseJobInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseJobInfo> checkSQLWithHttpInfo(String projectId, SQLJobRequest sqLJobInfo, String xAuthToken) throws ApiException {
        okhttp3.Call call = checkSQLValidateBeforeCall(projectId, sqLJobInfo, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseJobInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Check sql (asynchronously)
     * Check the SQL grammar.
     * @param projectId Project ID for resource isolation. (required)
     * @param sqLJobInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call checkSQLAsync(String projectId, SQLJobRequest sqLJobInfo, String xAuthToken, final ApiCallback<ResponseJobInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = checkSQLValidateBeforeCall(projectId, sqLJobInfo, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseJobInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for commitUploadJob
     * @param projectId Project ID for resource isolation. (required)
     * @param uploadCommitJobRequest Request parameters for commit direct upload job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call commitUploadJobCall(String projectId, UploadCommitJobRequest uploadCommitJobRequest, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = uploadCommitJobRequest;
        
        // create path and map variables
        String localVarPath = "/v2/{project_id}/uploader/commit"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call commitUploadJobValidateBeforeCall(String projectId, UploadCommitJobRequest uploadCommitJobRequest, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling commitUploadJob(Async)");
        }
        
        // verify the required parameter 'uploadCommitJobRequest' is set
        if (uploadCommitJobRequest == null) {
            throw new ApiException("Missing the required parameter 'uploadCommitJobRequest' when calling commitUploadJob(Async)");
        }
        
        
        okhttp3.Call call = commitUploadJobCall(projectId, uploadCommitJobRequest, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Commit direct upload job
     * Commit direct upload job for upload data to DLI.
     * @param projectId Project ID for resource isolation. (required)
     * @param uploadCommitJobRequest Request parameters for commit direct upload job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return UploadCommitJobResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public UploadCommitJobResult commitUploadJob(String projectId, UploadCommitJobRequest uploadCommitJobRequest, String xAuthToken) throws ApiException {
        ApiResponse<UploadCommitJobResult> resp = commitUploadJobWithHttpInfo(projectId, uploadCommitJobRequest, xAuthToken);
        return resp.getData();
    }

    /**
     * Commit direct upload job
     * Commit direct upload job for upload data to DLI.
     * @param projectId Project ID for resource isolation. (required)
     * @param uploadCommitJobRequest Request parameters for commit direct upload job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;UploadCommitJobResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<UploadCommitJobResult> commitUploadJobWithHttpInfo(String projectId, UploadCommitJobRequest uploadCommitJobRequest, String xAuthToken) throws ApiException {
        okhttp3.Call call = commitUploadJobValidateBeforeCall(projectId, uploadCommitJobRequest, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<UploadCommitJobResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Commit direct upload job (asynchronously)
     * Commit direct upload job for upload data to DLI.
     * @param projectId Project ID for resource isolation. (required)
     * @param uploadCommitJobRequest Request parameters for commit direct upload job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call commitUploadJobAsync(String projectId, UploadCommitJobRequest uploadCommitJobRequest, String xAuthToken, final ApiCallback<UploadCommitJobResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = commitUploadJobValidateBeforeCall(projectId, uploadCommitJobRequest, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<UploadCommitJobResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createBatch
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call createBatchCall(String projectId, Object body, String xAuthToken, String USER_ID, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/batches"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));
        if (USER_ID != null)
        localVarHeaderParams.put("USER_ID", apiClient.parameterToString(USER_ID));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call createBatchValidateBeforeCall(String projectId, Object body, String xAuthToken, String USER_ID, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling createBatch(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling createBatch(Async)");
        }
        
        
        okhttp3.Call call = createBatchCall(projectId, body, xAuthToken, USER_ID, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create batch
     * Create batch.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @return SessionInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public SessionInfo createBatch(String projectId, Object body, String xAuthToken, String USER_ID) throws ApiException {
        ApiResponse<SessionInfo> resp = createBatchWithHttpInfo(projectId, body, xAuthToken, USER_ID);
        return resp.getData();
    }

    /**
     * Create batch
     * Create batch.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @return ApiResponse&lt;SessionInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<SessionInfo> createBatchWithHttpInfo(String projectId, Object body, String xAuthToken, String USER_ID) throws ApiException {
        okhttp3.Call call = createBatchValidateBeforeCall(projectId, body, xAuthToken, USER_ID, null, null);
        Type localVarReturnType = new TypeToken<SessionInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create batch (asynchronously)
     * Create batch.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call createBatchAsync(String projectId, Object body, String xAuthToken, String USER_ID, final ApiCallback<SessionInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = createBatchValidateBeforeCall(projectId, body, xAuthToken, USER_ID, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<SessionInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createCluster
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (required)
     * @param createClusterRequest  (required)
     * @param USER_ID Real user id (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call createClusterCall(String projectId, String xAuthToken, CreateClusterRequest createClusterRequest, String USER_ID, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = createClusterRequest;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/clusters"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));
        if (USER_ID != null)
        localVarHeaderParams.put("USER_ID", apiClient.parameterToString(USER_ID));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call createClusterValidateBeforeCall(String projectId, String xAuthToken, CreateClusterRequest createClusterRequest, String USER_ID, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling createCluster(Async)");
        }
        
        // verify the required parameter 'xAuthToken' is set
        if (xAuthToken == null) {
            throw new ApiException("Missing the required parameter 'xAuthToken' when calling createCluster(Async)");
        }
        
        // verify the required parameter 'createClusterRequest' is set
        if (createClusterRequest == null) {
            throw new ApiException("Missing the required parameter 'createClusterRequest' when calling createCluster(Async)");
        }
        
        
        okhttp3.Call call = createClusterCall(projectId, xAuthToken, createClusterRequest, USER_ID, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create cluster
     * Create cluster.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (required)
     * @param createClusterRequest  (required)
     * @param USER_ID Real user id (optional)
     * @return EmptyResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public EmptyResponse createCluster(String projectId, String xAuthToken, CreateClusterRequest createClusterRequest, String USER_ID) throws ApiException {
        ApiResponse<EmptyResponse> resp = createClusterWithHttpInfo(projectId, xAuthToken, createClusterRequest, USER_ID);
        return resp.getData();
    }

    /**
     * Create cluster
     * Create cluster.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (required)
     * @param createClusterRequest  (required)
     * @param USER_ID Real user id (optional)
     * @return ApiResponse&lt;EmptyResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<EmptyResponse> createClusterWithHttpInfo(String projectId, String xAuthToken, CreateClusterRequest createClusterRequest, String USER_ID) throws ApiException {
        okhttp3.Call call = createClusterValidateBeforeCall(projectId, xAuthToken, createClusterRequest, USER_ID, null, null);
        Type localVarReturnType = new TypeToken<EmptyResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create cluster (asynchronously)
     * Create cluster.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (required)
     * @param createClusterRequest  (required)
     * @param USER_ID Real user id (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call createClusterAsync(String projectId, String xAuthToken, CreateClusterRequest createClusterRequest, String USER_ID, final ApiCallback<EmptyResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = createClusterValidateBeforeCall(projectId, xAuthToken, createClusterRequest, USER_ID, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<EmptyResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createDatabase
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseInfo \&quot;database_name\&quot;:\&quot;dbName\&quot;,    \&quot;description\&quot;:\&quot;this is the database description template.\&quot; (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call createDatabaseCall(String projectId, DatabaseInfo databaseInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = databaseInfo;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/databases"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call createDatabaseValidateBeforeCall(String projectId, DatabaseInfo databaseInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling createDatabase(Async)");
        }
        
        // verify the required parameter 'databaseInfo' is set
        if (databaseInfo == null) {
            throw new ApiException("Missing the required parameter 'databaseInfo' when calling createDatabase(Async)");
        }
        
        
        okhttp3.Call call = createDatabaseCall(projectId, databaseInfo, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create database
     * create a database
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseInfo \&quot;database_name\&quot;:\&quot;dbName\&quot;,    \&quot;description\&quot;:\&quot;this is the database description template.\&quot; (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ResponseInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseInfo createDatabase(String projectId, DatabaseInfo databaseInfo, String xAuthToken) throws ApiException {
        ApiResponse<ResponseInfo> resp = createDatabaseWithHttpInfo(projectId, databaseInfo, xAuthToken);
        return resp.getData();
    }

    /**
     * Create database
     * create a database
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseInfo \&quot;database_name\&quot;:\&quot;dbName\&quot;,    \&quot;description\&quot;:\&quot;this is the database description template.\&quot; (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;ResponseInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseInfo> createDatabaseWithHttpInfo(String projectId, DatabaseInfo databaseInfo, String xAuthToken) throws ApiException {
        okhttp3.Call call = createDatabaseValidateBeforeCall(projectId, databaseInfo, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create database (asynchronously)
     * create a database
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseInfo \&quot;database_name\&quot;:\&quot;dbName\&quot;,    \&quot;description\&quot;:\&quot;this is the database description template.\&quot; (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call createDatabaseAsync(String projectId, DatabaseInfo databaseInfo, String xAuthToken, final ApiCallback<ResponseInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = createDatabaseValidateBeforeCall(projectId, databaseInfo, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createDownloadJob
     * @param projectId Project ID for resource isolation. (required)
     * @param emptyBody Request parameters for create direct download job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call createDownloadJobCall(String projectId, EmptyBody emptyBody, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = emptyBody;
        
        // create path and map variables
        String localVarPath = "/v1/{project_id}/downloaders"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call createDownloadJobValidateBeforeCall(String projectId, EmptyBody emptyBody, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling createDownloadJob(Async)");
        }
        
        // verify the required parameter 'emptyBody' is set
        if (emptyBody == null) {
            throw new ApiException("Missing the required parameter 'emptyBody' when calling createDownloadJob(Async)");
        }
        
        
        okhttp3.Call call = createDownloadJobCall(projectId, emptyBody, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create direct download job
     * Create direct download job for download data from DLI.
     * @param projectId Project ID for resource isolation. (required)
     * @param emptyBody Request parameters for create direct download job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return DownloadCreateJobResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public DownloadCreateJobResult createDownloadJob(String projectId, EmptyBody emptyBody, String xAuthToken) throws ApiException {
        ApiResponse<DownloadCreateJobResult> resp = createDownloadJobWithHttpInfo(projectId, emptyBody, xAuthToken);
        return resp.getData();
    }

    /**
     * Create direct download job
     * Create direct download job for download data from DLI.
     * @param projectId Project ID for resource isolation. (required)
     * @param emptyBody Request parameters for create direct download job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;DownloadCreateJobResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<DownloadCreateJobResult> createDownloadJobWithHttpInfo(String projectId, EmptyBody emptyBody, String xAuthToken) throws ApiException {
        okhttp3.Call call = createDownloadJobValidateBeforeCall(projectId, emptyBody, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<DownloadCreateJobResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create direct download job (asynchronously)
     * Create direct download job for download data from DLI.
     * @param projectId Project ID for resource isolation. (required)
     * @param emptyBody Request parameters for create direct download job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call createDownloadJobAsync(String projectId, EmptyBody emptyBody, String xAuthToken, final ApiCallback<DownloadCreateJobResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = createDownloadJobValidateBeforeCall(projectId, emptyBody, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<DownloadCreateJobResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createFlinkJobTemplate
     * @param projectId project id, 用于不同project取token. (required)
     * @param body Create job template request (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call createFlinkJobTemplateCall(String projectId, CreateFlinkJobTemplateRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/job-templates"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call createFlinkJobTemplateValidateBeforeCall(String projectId, CreateFlinkJobTemplateRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling createFlinkJobTemplate(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling createFlinkJobTemplate(Async)");
        }
        
        
        okhttp3.Call call = createFlinkJobTemplateCall(projectId, body, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 创建作业模板
     * Create job template on Data lake insight
     * @param projectId project id, 用于不同project取token. (required)
     * @param body Create job template request (required)
     * @param xAuthToken Authorization Token (optional)
     * @return FlinkJobTemplateCreateResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public FlinkJobTemplateCreateResponse createFlinkJobTemplate(String projectId, CreateFlinkJobTemplateRequest body, String xAuthToken) throws ApiException {
        ApiResponse<FlinkJobTemplateCreateResponse> resp = createFlinkJobTemplateWithHttpInfo(projectId, body, xAuthToken);
        return resp.getData();
    }

    /**
     * 创建作业模板
     * Create job template on Data lake insight
     * @param projectId project id, 用于不同project取token. (required)
     * @param body Create job template request (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;FlinkJobTemplateCreateResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<FlinkJobTemplateCreateResponse> createFlinkJobTemplateWithHttpInfo(String projectId, CreateFlinkJobTemplateRequest body, String xAuthToken) throws ApiException {
        okhttp3.Call call = createFlinkJobTemplateValidateBeforeCall(projectId, body, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<FlinkJobTemplateCreateResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 创建作业模板 (asynchronously)
     * Create job template on Data lake insight
     * @param projectId project id, 用于不同project取token. (required)
     * @param body Create job template request (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call createFlinkJobTemplateAsync(String projectId, CreateFlinkJobTemplateRequest body, String xAuthToken, final ApiCallback<FlinkJobTemplateCreateResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = createFlinkJobTemplateValidateBeforeCall(projectId, body, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<FlinkJobTemplateCreateResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createObsSelectJob
     * @param projectId Project ID for resource isolation. (required)
     * @param obsSelectJobRequest Request parameters for create upload job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call createObsSelectJobCall(String projectId, ObsSelectJobRequest obsSelectJobRequest, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = obsSelectJobRequest;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/obs/select"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call createObsSelectJobValidateBeforeCall(String projectId, ObsSelectJobRequest obsSelectJobRequest, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling createObsSelectJob(Async)");
        }
        
        // verify the required parameter 'obsSelectJobRequest' is set
        if (obsSelectJobRequest == null) {
            throw new ApiException("Missing the required parameter 'obsSelectJobRequest' when calling createObsSelectJob(Async)");
        }
        
        
        okhttp3.Call call = createObsSelectJobCall(projectId, obsSelectJobRequest, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create Obs select job
     * Create Obs select job to DLI.
     * @param projectId Project ID for resource isolation. (required)
     * @param obsSelectJobRequest Request parameters for create upload job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ObsSelectJobResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ObsSelectJobResult createObsSelectJob(String projectId, ObsSelectJobRequest obsSelectJobRequest, String xAuthToken) throws ApiException {
        ApiResponse<ObsSelectJobResult> resp = createObsSelectJobWithHttpInfo(projectId, obsSelectJobRequest, xAuthToken);
        return resp.getData();
    }

    /**
     * Create Obs select job
     * Create Obs select job to DLI.
     * @param projectId Project ID for resource isolation. (required)
     * @param obsSelectJobRequest Request parameters for create upload job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;ObsSelectJobResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ObsSelectJobResult> createObsSelectJobWithHttpInfo(String projectId, ObsSelectJobRequest obsSelectJobRequest, String xAuthToken) throws ApiException {
        okhttp3.Call call = createObsSelectJobValidateBeforeCall(projectId, obsSelectJobRequest, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ObsSelectJobResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create Obs select job (asynchronously)
     * Create Obs select job to DLI.
     * @param projectId Project ID for resource isolation. (required)
     * @param obsSelectJobRequest Request parameters for create upload job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call createObsSelectJobAsync(String projectId, ObsSelectJobRequest obsSelectJobRequest, String xAuthToken, final ApiCallback<ObsSelectJobResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = createObsSelectJobValidateBeforeCall(projectId, obsSelectJobRequest, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ObsSelectJobResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createQueue
     * @param projectId Project ID for resource isolation. (required)
     * @param queueInfo Request parameters (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call createQueueCall(String projectId, QueueInfo queueInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = queueInfo;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/queues"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call createQueueValidateBeforeCall(String projectId, QueueInfo queueInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling createQueue(Async)");
        }
        
        // verify the required parameter 'queueInfo' is set
        if (queueInfo == null) {
            throw new ApiException("Missing the required parameter 'queueInfo' when calling createQueue(Async)");
        }
        
        
        okhttp3.Call call = createQueueCall(projectId, queueInfo, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create queue
     * Create a queue that will bind user-specified computing resources.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueInfo Request parameters (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ResponseQueueInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseQueueInfo createQueue(String projectId, QueueInfo queueInfo, String xAuthToken) throws ApiException {
        ApiResponse<ResponseQueueInfo> resp = createQueueWithHttpInfo(projectId, queueInfo, xAuthToken);
        return resp.getData();
    }

    /**
     * Create queue
     * Create a queue that will bind user-specified computing resources.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueInfo Request parameters (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;ResponseQueueInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseQueueInfo> createQueueWithHttpInfo(String projectId, QueueInfo queueInfo, String xAuthToken) throws ApiException {
        okhttp3.Call call = createQueueValidateBeforeCall(projectId, queueInfo, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseQueueInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create queue (asynchronously)
     * Create a queue that will bind user-specified computing resources.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueInfo Request parameters (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call createQueueAsync(String projectId, QueueInfo queueInfo, String xAuthToken, final ApiCallback<ResponseQueueInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = createQueueValidateBeforeCall(projectId, queueInfo, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseQueueInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createTable
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName New table where the database name. (required)
     * @param tableInfo New table request parameters. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call createTableCall(String projectId, String databaseName, TableInfo tableInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = tableInfo;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/databases/{database_name}/tables"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "database_name" + "\\}", apiClient.escapeString(databaseName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call createTableValidateBeforeCall(String projectId, String databaseName, TableInfo tableInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling createTable(Async)");
        }
        
        // verify the required parameter 'databaseName' is set
        if (databaseName == null) {
            throw new ApiException("Missing the required parameter 'databaseName' when calling createTable(Async)");
        }
        
        // verify the required parameter 'tableInfo' is set
        if (tableInfo == null) {
            throw new ApiException("Missing the required parameter 'tableInfo' when calling createTable(Async)");
        }
        
        
        okhttp3.Call call = createTableCall(projectId, databaseName, tableInfo, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create a new table
     * Data location:DLI and OBS，OBS must set data_location and data_type parameter
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName New table where the database name. (required)
     * @param tableInfo New table request parameters. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ResponseInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseInfo createTable(String projectId, String databaseName, TableInfo tableInfo, String xAuthToken) throws ApiException {
        ApiResponse<ResponseInfo> resp = createTableWithHttpInfo(projectId, databaseName, tableInfo, xAuthToken);
        return resp.getData();
    }

    /**
     * Create a new table
     * Data location:DLI and OBS，OBS must set data_location and data_type parameter
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName New table where the database name. (required)
     * @param tableInfo New table request parameters. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;ResponseInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseInfo> createTableWithHttpInfo(String projectId, String databaseName, TableInfo tableInfo, String xAuthToken) throws ApiException {
        okhttp3.Call call = createTableValidateBeforeCall(projectId, databaseName, tableInfo, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a new table (asynchronously)
     * Data location:DLI and OBS，OBS must set data_location and data_type parameter
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName New table where the database name. (required)
     * @param tableInfo New table request parameters. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call createTableAsync(String projectId, String databaseName, TableInfo tableInfo, String xAuthToken, final ApiCallback<ResponseInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = createTableValidateBeforeCall(projectId, databaseName, tableInfo, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createTsdb
     * @param createTsdbReq This is a auto create Body Object (required)
     * @param projectId  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call createTsdbCall(CreateTsdbReq createTsdbReq, String projectId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = createTsdbReq;
        
        // create path and map variables
        String localVarPath = "/v3/{project_id}/tsdbs"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call createTsdbValidateBeforeCall(CreateTsdbReq createTsdbReq, String projectId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'createTsdbReq' is set
        if (createTsdbReq == null) {
            throw new ApiException("Missing the required parameter 'createTsdbReq' when calling createTsdb(Async)");
        }
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling createTsdb(Async)");
        }
        
        
        okhttp3.Call call = createTsdbCall(createTsdbReq, projectId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 创建时序数据库配置信息
     * 
     * @param createTsdbReq This is a auto create Body Object (required)
     * @param projectId  (required)
     * @param xAuthToken Authorization Token (optional)
     * @return CreateTsdbResp
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public CreateTsdbResp createTsdb(CreateTsdbReq createTsdbReq, String projectId, String xAuthToken) throws ApiException {
        ApiResponse<CreateTsdbResp> resp = createTsdbWithHttpInfo(createTsdbReq, projectId, xAuthToken);
        return resp.getData();
    }

    /**
     * 创建时序数据库配置信息
     * 
     * @param createTsdbReq This is a auto create Body Object (required)
     * @param projectId  (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;CreateTsdbResp&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<CreateTsdbResp> createTsdbWithHttpInfo(CreateTsdbReq createTsdbReq, String projectId, String xAuthToken) throws ApiException {
        okhttp3.Call call = createTsdbValidateBeforeCall(createTsdbReq, projectId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<CreateTsdbResp>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 创建时序数据库配置信息 (asynchronously)
     * 
     * @param createTsdbReq This is a auto create Body Object (required)
     * @param projectId  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call createTsdbAsync(CreateTsdbReq createTsdbReq, String projectId, String xAuthToken, final ApiCallback<CreateTsdbResp> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = createTsdbValidateBeforeCall(createTsdbReq, projectId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<CreateTsdbResp>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createUploadJob
     * @param projectId Project ID for resource isolation. (required)
     * @param uploadCreateJobRequest Request parameters for create direct upload job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call createUploadJobCall(String projectId, UploadCreateJobRequest uploadCreateJobRequest, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = uploadCreateJobRequest;
        
        // create path and map variables
        String localVarPath = "/v2/{project_id}/uploader/create"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call createUploadJobValidateBeforeCall(String projectId, UploadCreateJobRequest uploadCreateJobRequest, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling createUploadJob(Async)");
        }
        
        // verify the required parameter 'uploadCreateJobRequest' is set
        if (uploadCreateJobRequest == null) {
            throw new ApiException("Missing the required parameter 'uploadCreateJobRequest' when calling createUploadJob(Async)");
        }
        
        
        okhttp3.Call call = createUploadJobCall(projectId, uploadCreateJobRequest, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create direct upload job
     * Create direct upload job for upload data to DLI.
     * @param projectId Project ID for resource isolation. (required)
     * @param uploadCreateJobRequest Request parameters for create direct upload job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return UploadCreateJobResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public UploadCreateJobResult createUploadJob(String projectId, UploadCreateJobRequest uploadCreateJobRequest, String xAuthToken) throws ApiException {
        ApiResponse<UploadCreateJobResult> resp = createUploadJobWithHttpInfo(projectId, uploadCreateJobRequest, xAuthToken);
        return resp.getData();
    }

    /**
     * Create direct upload job
     * Create direct upload job for upload data to DLI.
     * @param projectId Project ID for resource isolation. (required)
     * @param uploadCreateJobRequest Request parameters for create direct upload job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;UploadCreateJobResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<UploadCreateJobResult> createUploadJobWithHttpInfo(String projectId, UploadCreateJobRequest uploadCreateJobRequest, String xAuthToken) throws ApiException {
        okhttp3.Call call = createUploadJobValidateBeforeCall(projectId, uploadCreateJobRequest, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<UploadCreateJobResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create direct upload job (asynchronously)
     * Create direct upload job for upload data to DLI.
     * @param projectId Project ID for resource isolation. (required)
     * @param uploadCreateJobRequest Request parameters for create direct upload job (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call createUploadJobAsync(String projectId, UploadCreateJobRequest uploadCreateJobRequest, String xAuthToken, final ApiCallback<UploadCreateJobResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = createUploadJobValidateBeforeCall(projectId, uploadCreateJobRequest, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<UploadCreateJobResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for dataAuthorize
     * @param projectId Project ID for resource isolation. (required)
     * @param privilegeInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call dataAuthorizeCall(String projectId, PrivilegeInfo privilegeInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = privilegeInfo;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/user-authorization"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call dataAuthorizeValidateBeforeCall(String projectId, PrivilegeInfo privilegeInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling dataAuthorize(Async)");
        }
        
        // verify the required parameter 'privilegeInfo' is set
        if (privilegeInfo == null) {
            throw new ApiException("Missing the required parameter 'privilegeInfo' when calling dataAuthorize(Async)");
        }
        
        
        okhttp3.Call call = dataAuthorizeCall(projectId, privilegeInfo, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List queue users
     * Privilege data permissions to the database or data table to other specified users.
     * @param projectId Project ID for resource isolation. (required)
     * @param privilegeInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ResponseInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseInfo dataAuthorize(String projectId, PrivilegeInfo privilegeInfo, String xAuthToken) throws ApiException {
        ApiResponse<ResponseInfo> resp = dataAuthorizeWithHttpInfo(projectId, privilegeInfo, xAuthToken);
        return resp.getData();
    }

    /**
     * List queue users
     * Privilege data permissions to the database or data table to other specified users.
     * @param projectId Project ID for resource isolation. (required)
     * @param privilegeInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;ResponseInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseInfo> dataAuthorizeWithHttpInfo(String projectId, PrivilegeInfo privilegeInfo, String xAuthToken) throws ApiException {
        okhttp3.Call call = dataAuthorizeValidateBeforeCall(projectId, privilegeInfo, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List queue users (asynchronously)
     * Privilege data permissions to the database or data table to other specified users.
     * @param projectId Project ID for resource isolation. (required)
     * @param privilegeInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call dataAuthorizeAsync(String projectId, PrivilegeInfo privilegeInfo, String xAuthToken, final ApiCallback<ResponseInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = dataAuthorizeValidateBeforeCall(projectId, privilegeInfo, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for delBatch
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call delBatchCall(String projectId, String batchId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/batches/{batch_id}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "batch_id" + "\\}", apiClient.escapeString(batchId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call delBatchValidateBeforeCall(String projectId, String batchId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling delBatch(Async)");
        }
        
        // verify the required parameter 'batchId' is set
        if (batchId == null) {
            throw new ApiException("Missing the required parameter 'batchId' when calling delBatch(Async)");
        }
        
        
        okhttp3.Call call = delBatchCall(projectId, batchId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Delete specified batch
     * Delete specified batch.
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @return MessageInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public MessageInfo delBatch(String projectId, String batchId, String xAuthToken) throws ApiException {
        ApiResponse<MessageInfo> resp = delBatchWithHttpInfo(projectId, batchId, xAuthToken);
        return resp.getData();
    }

    /**
     * Delete specified batch
     * Delete specified batch.
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;MessageInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<MessageInfo> delBatchWithHttpInfo(String projectId, String batchId, String xAuthToken) throws ApiException {
        okhttp3.Call call = delBatchValidateBeforeCall(projectId, batchId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<MessageInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete specified batch (asynchronously)
     * Delete specified batch.
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call delBatchAsync(String projectId, String batchId, String xAuthToken, final ApiCallback<MessageInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = delBatchValidateBeforeCall(projectId, batchId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<MessageInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for deleteCluster
     * @param projectId Project ID for resource isolation. (required)
     * @param clusterName Cluster name (required)
     * @param xAuthToken Authorization Token (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call deleteClusterCall(String projectId, String clusterName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/clusters/{cluster_name}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "cluster_name" + "\\}", apiClient.escapeString(clusterName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call deleteClusterValidateBeforeCall(String projectId, String clusterName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling deleteCluster(Async)");
        }
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling deleteCluster(Async)");
        }
        
        // verify the required parameter 'xAuthToken' is set
        if (xAuthToken == null) {
            throw new ApiException("Missing the required parameter 'xAuthToken' when calling deleteCluster(Async)");
        }
        
        
        okhttp3.Call call = deleteClusterCall(projectId, clusterName, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Delete cluster
     * Delete cluster.
     * @param projectId Project ID for resource isolation. (required)
     * @param clusterName Cluster name (required)
     * @param xAuthToken Authorization Token (required)
     * @return EmptyResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public EmptyResponse deleteCluster(String projectId, String clusterName, String xAuthToken) throws ApiException {
        ApiResponse<EmptyResponse> resp = deleteClusterWithHttpInfo(projectId, clusterName, xAuthToken);
        return resp.getData();
    }

    /**
     * Delete cluster
     * Delete cluster.
     * @param projectId Project ID for resource isolation. (required)
     * @param clusterName Cluster name (required)
     * @param xAuthToken Authorization Token (required)
     * @return ApiResponse&lt;EmptyResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<EmptyResponse> deleteClusterWithHttpInfo(String projectId, String clusterName, String xAuthToken) throws ApiException {
        okhttp3.Call call = deleteClusterValidateBeforeCall(projectId, clusterName, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<EmptyResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete cluster (asynchronously)
     * Delete cluster.
     * @param projectId Project ID for resource isolation. (required)
     * @param clusterName Cluster name (required)
     * @param xAuthToken Authorization Token (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call deleteClusterAsync(String projectId, String clusterName, String xAuthToken, final ApiCallback<EmptyResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = deleteClusterValidateBeforeCall(projectId, clusterName, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<EmptyResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for deleteDatabase
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName Delete database by this name. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call deleteDatabaseCall(String projectId, String databaseName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/databases/{database_name}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "database_name" + "\\}", apiClient.escapeString(databaseName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call deleteDatabaseValidateBeforeCall(String projectId, String databaseName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling deleteDatabase(Async)");
        }
        
        // verify the required parameter 'databaseName' is set
        if (databaseName == null) {
            throw new ApiException("Missing the required parameter 'databaseName' when calling deleteDatabase(Async)");
        }
        
        
        okhttp3.Call call = deleteDatabaseCall(projectId, databaseName, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Delete database
     * Delete database by database name.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName Delete database by this name. (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ResponseInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseInfo deleteDatabase(String projectId, String databaseName, String xAuthToken) throws ApiException {
        ApiResponse<ResponseInfo> resp = deleteDatabaseWithHttpInfo(projectId, databaseName, xAuthToken);
        return resp.getData();
    }

    /**
     * Delete database
     * Delete database by database name.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName Delete database by this name. (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;ResponseInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseInfo> deleteDatabaseWithHttpInfo(String projectId, String databaseName, String xAuthToken) throws ApiException {
        okhttp3.Call call = deleteDatabaseValidateBeforeCall(projectId, databaseName, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete database (asynchronously)
     * Delete database by database name.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName Delete database by this name. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call deleteDatabaseAsync(String projectId, String databaseName, String xAuthToken, final ApiCallback<ResponseInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = deleteDatabaseValidateBeforeCall(projectId, databaseName, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for deleteFlinkJob
     * @param projectId project id, 用于不同project取token. (required)
     * @param deleteJobInBatchRequest  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call deleteFlinkJobCall(String projectId, DeleteJobInBatchRequest deleteJobInBatchRequest, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = deleteJobInBatchRequest;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/jobs/delete"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call deleteFlinkJobValidateBeforeCall(String projectId, DeleteJobInBatchRequest deleteJobInBatchRequest, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling deleteFlinkJob(Async)");
        }
        
        // verify the required parameter 'deleteJobInBatchRequest' is set
        if (deleteJobInBatchRequest == null) {
            throw new ApiException("Missing the required parameter 'deleteJobInBatchRequest' when calling deleteFlinkJob(Async)");
        }
        
        
        okhttp3.Call call = deleteFlinkJobCall(projectId, deleteJobInBatchRequest, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 批量删除作业
     * 
     * @param projectId project id, 用于不同project取token. (required)
     * @param deleteJobInBatchRequest  (required)
     * @param xAuthToken Authorization Token (optional)
     * @return List&lt;GlobalBatchResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<GlobalBatchResponse> deleteFlinkJob(String projectId, DeleteJobInBatchRequest deleteJobInBatchRequest, String xAuthToken) throws ApiException {
        ApiResponse<List<GlobalBatchResponse>> resp = deleteFlinkJobWithHttpInfo(projectId, deleteJobInBatchRequest, xAuthToken);
        return resp.getData();
    }

    /**
     * 批量删除作业
     * 
     * @param projectId project id, 用于不同project取token. (required)
     * @param deleteJobInBatchRequest  (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;List&lt;GlobalBatchResponse&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<GlobalBatchResponse>> deleteFlinkJobWithHttpInfo(String projectId, DeleteJobInBatchRequest deleteJobInBatchRequest, String xAuthToken) throws ApiException {
        okhttp3.Call call = deleteFlinkJobValidateBeforeCall(projectId, deleteJobInBatchRequest, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<List<GlobalBatchResponse>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 批量删除作业 (asynchronously)
     * 
     * @param projectId project id, 用于不同project取token. (required)
     * @param deleteJobInBatchRequest  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call deleteFlinkJobAsync(String projectId, DeleteJobInBatchRequest deleteJobInBatchRequest, String xAuthToken, final ApiCallback<List<GlobalBatchResponse>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = deleteFlinkJobValidateBeforeCall(projectId, deleteJobInBatchRequest, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<GlobalBatchResponse>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for deleteFlinkJobTemplate
     * @param projectId project id, 用于不同project取token. (required)
     * @param templateId  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call deleteFlinkJobTemplateCall(String projectId, Long templateId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/job-templates/{template_id}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "template_id" + "\\}", apiClient.escapeString(templateId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call deleteFlinkJobTemplateValidateBeforeCall(String projectId, Long templateId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling deleteFlinkJobTemplate(Async)");
        }
        
        // verify the required parameter 'templateId' is set
        if (templateId == null) {
            throw new ApiException("Missing the required parameter 'templateId' when calling deleteFlinkJobTemplate(Async)");
        }
        
        
        okhttp3.Call call = deleteFlinkJobTemplateCall(projectId, templateId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 删除作业模板
     * 当前模板被引用也允许删除模板
     * @param projectId project id, 用于不同project取token. (required)
     * @param templateId  (required)
     * @param xAuthToken Authorization Token (optional)
     * @return FlinkJobTemplateDeleteResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public FlinkJobTemplateDeleteResponse deleteFlinkJobTemplate(String projectId, Long templateId, String xAuthToken) throws ApiException {
        ApiResponse<FlinkJobTemplateDeleteResponse> resp = deleteFlinkJobTemplateWithHttpInfo(projectId, templateId, xAuthToken);
        return resp.getData();
    }

    /**
     * 删除作业模板
     * 当前模板被引用也允许删除模板
     * @param projectId project id, 用于不同project取token. (required)
     * @param templateId  (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;FlinkJobTemplateDeleteResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<FlinkJobTemplateDeleteResponse> deleteFlinkJobTemplateWithHttpInfo(String projectId, Long templateId, String xAuthToken) throws ApiException {
        okhttp3.Call call = deleteFlinkJobTemplateValidateBeforeCall(projectId, templateId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<FlinkJobTemplateDeleteResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 删除作业模板 (asynchronously)
     * 当前模板被引用也允许删除模板
     * @param projectId project id, 用于不同project取token. (required)
     * @param templateId  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call deleteFlinkJobTemplateAsync(String projectId, Long templateId, String xAuthToken, final ApiCallback<FlinkJobTemplateDeleteResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = deleteFlinkJobTemplateValidateBeforeCall(projectId, templateId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<FlinkJobTemplateDeleteResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for deleteJob
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call deleteJobCall(String projectId, Long jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/jobs/{job_id}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "job_id" + "\\}", apiClient.escapeString(jobId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call deleteJobValidateBeforeCall(String projectId, Long jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling deleteJob(Async)");
        }
        
        // verify the required parameter 'jobId' is set
        if (jobId == null) {
            throw new ApiException("Missing the required parameter 'jobId' when calling deleteJob(Async)");
        }
        
        
        okhttp3.Call call = deleteJobCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 删除作业
     * 删除任何状态的作业
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @return GlobalResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GlobalResponse deleteJob(String projectId, Long jobId, String xAuthToken) throws ApiException {
        ApiResponse<GlobalResponse> resp = deleteJobWithHttpInfo(projectId, jobId, xAuthToken);
        return resp.getData();
    }

    /**
     * 删除作业
     * 删除任何状态的作业
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;GlobalResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GlobalResponse> deleteJobWithHttpInfo(String projectId, Long jobId, String xAuthToken) throws ApiException {
        okhttp3.Call call = deleteJobValidateBeforeCall(projectId, jobId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<GlobalResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 删除作业 (asynchronously)
     * 删除任何状态的作业
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call deleteJobAsync(String projectId, Long jobId, String xAuthToken, final ApiCallback<GlobalResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = deleteJobValidateBeforeCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GlobalResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for deleteQueue
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the queue (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call deleteQueueCall(String projectId, String queueName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/queues/{queue_name}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "queue_name" + "\\}", apiClient.escapeString(queueName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call deleteQueueValidateBeforeCall(String projectId, String queueName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling deleteQueue(Async)");
        }
        
        // verify the required parameter 'queueName' is set
        if (queueName == null) {
            throw new ApiException("Missing the required parameter 'queueName' when calling deleteQueue(Async)");
        }
        
        
        okhttp3.Call call = deleteQueueCall(projectId, queueName, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Delete queue
     * Delete the specified queue.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the queue (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ResponseInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseInfo deleteQueue(String projectId, String queueName, String xAuthToken) throws ApiException {
        ApiResponse<ResponseInfo> resp = deleteQueueWithHttpInfo(projectId, queueName, xAuthToken);
        return resp.getData();
    }

    /**
     * Delete queue
     * Delete the specified queue.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the queue (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;ResponseInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseInfo> deleteQueueWithHttpInfo(String projectId, String queueName, String xAuthToken) throws ApiException {
        okhttp3.Call call = deleteQueueValidateBeforeCall(projectId, queueName, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete queue (asynchronously)
     * Delete the specified queue.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the queue (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call deleteQueueAsync(String projectId, String queueName, String xAuthToken, final ApiCallback<ResponseInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = deleteQueueValidateBeforeCall(projectId, queueName, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for deleteResource
     * @param projectId Project ID for resource isolation. (required)
     * @param resourceName Resource name. (required)
     * @param group Resource group. (optional)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call deleteResourceCall(String projectId, String resourceName, String group, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/resources/{resource_name}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "resource_name" + "\\}", apiClient.escapeString(resourceName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (group != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("group", group));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call deleteResourceValidateBeforeCall(String projectId, String resourceName, String group, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling deleteResource(Async)");
        }
        
        // verify the required parameter 'resourceName' is set
        if (resourceName == null) {
            throw new ApiException("Missing the required parameter 'resourceName' when calling deleteResource(Async)");
        }
        
        
        okhttp3.Call call = deleteResourceCall(projectId, resourceName, group, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Delete specified resource
     * Delete specified resource.
     * @param projectId Project ID for resource isolation. (required)
     * @param resourceName Resource name. (required)
     * @param group Resource group. (optional)
     * @param xAuthToken Authorization Token (optional)
     * @return EmptyResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public EmptyResponse deleteResource(String projectId, String resourceName, String group, String xAuthToken) throws ApiException {
        ApiResponse<EmptyResponse> resp = deleteResourceWithHttpInfo(projectId, resourceName, group, xAuthToken);
        return resp.getData();
    }

    /**
     * Delete specified resource
     * Delete specified resource.
     * @param projectId Project ID for resource isolation. (required)
     * @param resourceName Resource name. (required)
     * @param group Resource group. (optional)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;EmptyResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<EmptyResponse> deleteResourceWithHttpInfo(String projectId, String resourceName, String group, String xAuthToken) throws ApiException {
        okhttp3.Call call = deleteResourceValidateBeforeCall(projectId, resourceName, group, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<EmptyResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete specified resource (asynchronously)
     * Delete specified resource.
     * @param projectId Project ID for resource isolation. (required)
     * @param resourceName Resource name. (required)
     * @param group Resource group. (optional)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call deleteResourceAsync(String projectId, String resourceName, String group, String xAuthToken, final ApiCallback<EmptyResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = deleteResourceValidateBeforeCall(projectId, resourceName, group, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<EmptyResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for deleteTable
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The name of the database where the table to be deleted is located. (required)
     * @param tableName The name of the table to be deleted. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call deleteTableCall(String projectId, String databaseName, String tableName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/databases/{database_name}/tables/{table_name}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "database_name" + "\\}", apiClient.escapeString(databaseName.toString()))
            .replaceAll("\\{" + "table_name" + "\\}", apiClient.escapeString(tableName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call deleteTableValidateBeforeCall(String projectId, String databaseName, String tableName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling deleteTable(Async)");
        }
        
        // verify the required parameter 'databaseName' is set
        if (databaseName == null) {
            throw new ApiException("Missing the required parameter 'databaseName' when calling deleteTable(Async)");
        }
        
        // verify the required parameter 'tableName' is set
        if (tableName == null) {
            throw new ApiException("Missing the required parameter 'tableName' when calling deleteTable(Async)");
        }
        
        
        okhttp3.Call call = deleteTableCall(projectId, databaseName, tableName, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Delete table
     * Delete the specified table.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The name of the database where the table to be deleted is located. (required)
     * @param tableName The name of the table to be deleted. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ResponseInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseInfo deleteTable(String projectId, String databaseName, String tableName, String xAuthToken) throws ApiException {
        ApiResponse<ResponseInfo> resp = deleteTableWithHttpInfo(projectId, databaseName, tableName, xAuthToken);
        return resp.getData();
    }

    /**
     * Delete table
     * Delete the specified table.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The name of the database where the table to be deleted is located. (required)
     * @param tableName The name of the table to be deleted. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;ResponseInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseInfo> deleteTableWithHttpInfo(String projectId, String databaseName, String tableName, String xAuthToken) throws ApiException {
        okhttp3.Call call = deleteTableValidateBeforeCall(projectId, databaseName, tableName, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete table (asynchronously)
     * Delete the specified table.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The name of the database where the table to be deleted is located. (required)
     * @param tableName The name of the table to be deleted. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call deleteTableAsync(String projectId, String databaseName, String tableName, String xAuthToken, final ApiCallback<ResponseInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = deleteTableValidateBeforeCall(projectId, databaseName, tableName, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for deleteTsdb
     * @param projectId  (required)
     * @param tsdbId  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call deleteTsdbCall(String projectId, String tsdbId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v3/{project_id}/tsdbs/{tsdb_id}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "tsdb_id" + "\\}", apiClient.escapeString(tsdbId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call deleteTsdbValidateBeforeCall(String projectId, String tsdbId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling deleteTsdb(Async)");
        }
        
        // verify the required parameter 'tsdbId' is set
        if (tsdbId == null) {
            throw new ApiException("Missing the required parameter 'tsdbId' when calling deleteTsdb(Async)");
        }
        
        
        okhttp3.Call call = deleteTsdbCall(projectId, tsdbId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 删除时序数据库配置信息
     * 删除时序数据库配置信息
     * @param projectId  (required)
     * @param tsdbId  (required)
     * @param xAuthToken Authorization Token (optional)
     * @return GlobalResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GlobalResponse deleteTsdb(String projectId, String tsdbId, String xAuthToken) throws ApiException {
        ApiResponse<GlobalResponse> resp = deleteTsdbWithHttpInfo(projectId, tsdbId, xAuthToken);
        return resp.getData();
    }

    /**
     * 删除时序数据库配置信息
     * 删除时序数据库配置信息
     * @param projectId  (required)
     * @param tsdbId  (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;GlobalResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GlobalResponse> deleteTsdbWithHttpInfo(String projectId, String tsdbId, String xAuthToken) throws ApiException {
        okhttp3.Call call = deleteTsdbValidateBeforeCall(projectId, tsdbId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<GlobalResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 删除时序数据库配置信息 (asynchronously)
     * 删除时序数据库配置信息
     * @param projectId  (required)
     * @param tsdbId  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call deleteTsdbAsync(String projectId, String tsdbId, String xAuthToken, final ApiCallback<GlobalResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = deleteTsdbValidateBeforeCall(projectId, tsdbId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GlobalResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for describeTable
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The name of the database where the table to be described is located. (required)
     * @param tableName The name of the table to be described. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call describeTableCall(String projectId, String databaseName, String tableName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/databases/{database_name}/tables/{table_name}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "database_name" + "\\}", apiClient.escapeString(databaseName.toString()))
            .replaceAll("\\{" + "table_name" + "\\}", apiClient.escapeString(tableName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call describeTableValidateBeforeCall(String projectId, String databaseName, String tableName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling describeTable(Async)");
        }
        
        // verify the required parameter 'databaseName' is set
        if (databaseName == null) {
            throw new ApiException("Missing the required parameter 'databaseName' when calling describeTable(Async)");
        }
        
        // verify the required parameter 'tableName' is set
        if (tableName == null) {
            throw new ApiException("Missing the required parameter 'tableName' when calling describeTable(Async)");
        }
        
        
        okhttp3.Call call = describeTableCall(projectId, databaseName, tableName, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Describe Table
     * Describes the metadata information for the specified table.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The name of the database where the table to be described is located. (required)
     * @param tableName The name of the table to be described. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ColumnResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ColumnResult describeTable(String projectId, String databaseName, String tableName, String xAuthToken) throws ApiException {
        ApiResponse<ColumnResult> resp = describeTableWithHttpInfo(projectId, databaseName, tableName, xAuthToken);
        return resp.getData();
    }

    /**
     * Describe Table
     * Describes the metadata information for the specified table.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The name of the database where the table to be described is located. (required)
     * @param tableName The name of the table to be described. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;ColumnResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ColumnResult> describeTableWithHttpInfo(String projectId, String databaseName, String tableName, String xAuthToken) throws ApiException {
        okhttp3.Call call = describeTableValidateBeforeCall(projectId, databaseName, tableName, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ColumnResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Describe Table (asynchronously)
     * Describes the metadata information for the specified table.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The name of the database where the table to be described is located. (required)
     * @param tableName The name of the table to be described. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call describeTableAsync(String projectId, String databaseName, String tableName, String xAuthToken, final ApiCallback<ColumnResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = describeTableValidateBeforeCall(projectId, databaseName, tableName, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ColumnResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for execute
     * @param projectId Project ID for resource isolation. (required)
     * @param sqLJobInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call executeCall(String projectId, SQLJobRequest sqLJobInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = sqLJobInfo;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/jobs/submit-job"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call executeValidateBeforeCall(String projectId, SQLJobRequest sqLJobInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling execute(Async)");
        }
        
        // verify the required parameter 'sqLJobInfo' is set
        if (sqLJobInfo == null) {
            throw new ApiException("Missing the required parameter 'sqLJobInfo' when calling execute(Async)");
        }
        
        
        okhttp3.Call call = executeCall(projectId, sqLJobInfo, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Submit job
     * This API is used to submit jobs to the cluster by executing SQL statements. The job contains the following types: DDL, DCL, IMPORT, EXPORT, QUERY, and INSERT.
     * @param projectId Project ID for resource isolation. (required)
     * @param sqLJobInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ResponseJobInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseJobInfo execute(String projectId, SQLJobRequest sqLJobInfo, String xAuthToken) throws ApiException {
        ApiResponse<ResponseJobInfo> resp = executeWithHttpInfo(projectId, sqLJobInfo, xAuthToken);
        return resp.getData();
    }

    /**
     * Submit job
     * This API is used to submit jobs to the cluster by executing SQL statements. The job contains the following types: DDL, DCL, IMPORT, EXPORT, QUERY, and INSERT.
     * @param projectId Project ID for resource isolation. (required)
     * @param sqLJobInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;ResponseJobInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseJobInfo> executeWithHttpInfo(String projectId, SQLJobRequest sqLJobInfo, String xAuthToken) throws ApiException {
        okhttp3.Call call = executeValidateBeforeCall(projectId, sqLJobInfo, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseJobInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Submit job (asynchronously)
     * This API is used to submit jobs to the cluster by executing SQL statements. The job contains the following types: DDL, DCL, IMPORT, EXPORT, QUERY, and INSERT.
     * @param projectId Project ID for resource isolation. (required)
     * @param sqLJobInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call executeAsync(String projectId, SQLJobRequest sqLJobInfo, String xAuthToken, final ApiCallback<ResponseJobInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = executeValidateBeforeCall(projectId, sqLJobInfo, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseJobInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for execute_0
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the current queue, the SQL for the use of resources will be used to calculate the resources of the queue. (required)
     * @param sqLJobInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call execute_0Call(String projectId, String queueName, SQLJobRequest sqLJobInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = sqLJobInfo;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/queues/{queue_name}/jobs/submit-job"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "queue_name" + "\\}", apiClient.escapeString(queueName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call execute_0ValidateBeforeCall(String projectId, String queueName, SQLJobRequest sqLJobInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling execute_0(Async)");
        }
        
        // verify the required parameter 'queueName' is set
        if (queueName == null) {
            throw new ApiException("Missing the required parameter 'queueName' when calling execute_0(Async)");
        }
        
        // verify the required parameter 'sqLJobInfo' is set
        if (sqLJobInfo == null) {
            throw new ApiException("Missing the required parameter 'sqLJobInfo' when calling execute_0(Async)");
        }
        
        
        okhttp3.Call call = execute_0Call(projectId, queueName, sqLJobInfo, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Submit job
     * This API is used to submit jobs to the cluster by executing SQL statements. The job contains the following types: DDL, DCL, IMPORT, EXPORT, QUERY, and INSERT.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the current queue, the SQL for the use of resources will be used to calculate the resources of the queue. (required)
     * @param sqLJobInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ResponseJobInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseJobInfo execute_0(String projectId, String queueName, SQLJobRequest sqLJobInfo, String xAuthToken) throws ApiException {
        ApiResponse<ResponseJobInfo> resp = execute_0WithHttpInfo(projectId, queueName, sqLJobInfo, xAuthToken);
        return resp.getData();
    }

    /**
     * Submit job
     * This API is used to submit jobs to the cluster by executing SQL statements. The job contains the following types: DDL, DCL, IMPORT, EXPORT, QUERY, and INSERT.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the current queue, the SQL for the use of resources will be used to calculate the resources of the queue. (required)
     * @param sqLJobInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;ResponseJobInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseJobInfo> execute_0WithHttpInfo(String projectId, String queueName, SQLJobRequest sqLJobInfo, String xAuthToken) throws ApiException {
        okhttp3.Call call = execute_0ValidateBeforeCall(projectId, queueName, sqLJobInfo, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseJobInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Submit job (asynchronously)
     * This API is used to submit jobs to the cluster by executing SQL statements. The job contains the following types: DDL, DCL, IMPORT, EXPORT, QUERY, and INSERT.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the current queue, the SQL for the use of resources will be used to calculate the resources of the queue. (required)
     * @param sqLJobInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call execute_0Async(String projectId, String queueName, SQLJobRequest sqLJobInfo, String xAuthToken, final ApiCallback<ResponseJobInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = execute_0ValidateBeforeCall(projectId, queueName, sqLJobInfo, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseJobInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for exportData
     * @param projectId Project ID for resource isolation. (required)
     * @param exportInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call exportDataCall(String projectId, ExportJobRequest exportInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = exportInfo;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/jobs/export-table"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call exportDataValidateBeforeCall(String projectId, ExportJobRequest exportInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling exportData(Async)");
        }
        
        // verify the required parameter 'exportInfo' is set
        if (exportInfo == null) {
            throw new ApiException("Missing the required parameter 'exportInfo' when calling exportData(Async)");
        }
        
        
        okhttp3.Call call = exportDataCall(projectId, exportInfo, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Export data
     * Export the data to a file. Support data export to file from DLI table, OBS table or view.
     * @param projectId Project ID for resource isolation. (required)
     * @param exportInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ResponseJobInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseJobInfo exportData(String projectId, ExportJobRequest exportInfo, String xAuthToken) throws ApiException {
        ApiResponse<ResponseJobInfo> resp = exportDataWithHttpInfo(projectId, exportInfo, xAuthToken);
        return resp.getData();
    }

    /**
     * Export data
     * Export the data to a file. Support data export to file from DLI table, OBS table or view.
     * @param projectId Project ID for resource isolation. (required)
     * @param exportInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;ResponseJobInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseJobInfo> exportDataWithHttpInfo(String projectId, ExportJobRequest exportInfo, String xAuthToken) throws ApiException {
        okhttp3.Call call = exportDataValidateBeforeCall(projectId, exportInfo, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseJobInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Export data (asynchronously)
     * Export the data to a file. Support data export to file from DLI table, OBS table or view.
     * @param projectId Project ID for resource isolation. (required)
     * @param exportInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call exportDataAsync(String projectId, ExportJobRequest exportInfo, String xAuthToken, final ApiCallback<ResponseJobInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = exportDataValidateBeforeCall(projectId, exportInfo, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseJobInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getBatchInfo
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getBatchInfoCall(String projectId, String batchId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/batches/{batch_id}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "batch_id" + "\\}", apiClient.escapeString(batchId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getBatchInfoValidateBeforeCall(String projectId, String batchId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getBatchInfo(Async)");
        }
        
        // verify the required parameter 'batchId' is set
        if (batchId == null) {
            throw new ApiException("Missing the required parameter 'batchId' when calling getBatchInfo(Async)");
        }
        
        
        okhttp3.Call call = getBatchInfoCall(projectId, batchId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List specified batch
     * List specified batch.
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @return SessionInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public SessionInfo getBatchInfo(String projectId, String batchId, String xAuthToken) throws ApiException {
        ApiResponse<SessionInfo> resp = getBatchInfoWithHttpInfo(projectId, batchId, xAuthToken);
        return resp.getData();
    }

    /**
     * List specified batch
     * List specified batch.
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;SessionInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<SessionInfo> getBatchInfoWithHttpInfo(String projectId, String batchId, String xAuthToken) throws ApiException {
        okhttp3.Call call = getBatchInfoValidateBeforeCall(projectId, batchId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<SessionInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List specified batch (asynchronously)
     * List specified batch.
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getBatchInfoAsync(String projectId, String batchId, String xAuthToken, final ApiCallback<SessionInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getBatchInfoValidateBeforeCall(projectId, batchId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<SessionInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getBatchList
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param clusterName  (optional)
     * @param from  (optional)
     * @param size  (optional)
     * @param jobId  (optional)
     * @param jobName  (optional)
     * @param start  (optional)
     * @param end  (optional)
     * @param order  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getBatchListCall(String projectId, String xAuthToken, String clusterName, Integer from, Integer size, String jobId, String jobName, Long start, Long end, String order, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/batches"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (clusterName != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("cluster_name", clusterName));
        if (from != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("from", from));
        if (size != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("size", size));
        if (jobId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("job_id", jobId));
        if (jobName != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("job_name", jobName));
        if (start != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("start", start));
        if (end != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("end", end));
        if (order != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("order", order));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getBatchListValidateBeforeCall(String projectId, String xAuthToken, String clusterName, Integer from, Integer size, String jobId, String jobName, Long start, Long end, String order, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getBatchList(Async)");
        }
        
        
        okhttp3.Call call = getBatchListCall(projectId, xAuthToken, clusterName, from, size, jobId, jobName, start, end, order, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List all batchs
     * List all batchs.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param clusterName  (optional)
     * @param from  (optional)
     * @param size  (optional)
     * @param jobId  (optional)
     * @param jobName  (optional)
     * @param start  (optional)
     * @param end  (optional)
     * @param order  (optional)
     * @return SessionInfos
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public SessionInfos getBatchList(String projectId, String xAuthToken, String clusterName, Integer from, Integer size, String jobId, String jobName, Long start, Long end, String order) throws ApiException {
        ApiResponse<SessionInfos> resp = getBatchListWithHttpInfo(projectId, xAuthToken, clusterName, from, size, jobId, jobName, start, end, order);
        return resp.getData();
    }

    /**
     * List all batchs
     * List all batchs.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param clusterName  (optional)
     * @param from  (optional)
     * @param size  (optional)
     * @param jobId  (optional)
     * @param jobName  (optional)
     * @param start  (optional)
     * @param end  (optional)
     * @param order  (optional)
     * @return ApiResponse&lt;SessionInfos&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<SessionInfos> getBatchListWithHttpInfo(String projectId, String xAuthToken, String clusterName, Integer from, Integer size, String jobId, String jobName, Long start, Long end, String order) throws ApiException {
        okhttp3.Call call = getBatchListValidateBeforeCall(projectId, xAuthToken, clusterName, from, size, jobId, jobName, start, end, order, null, null);
        Type localVarReturnType = new TypeToken<SessionInfos>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List all batchs (asynchronously)
     * List all batchs.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param clusterName  (optional)
     * @param from  (optional)
     * @param size  (optional)
     * @param jobId  (optional)
     * @param jobName  (optional)
     * @param start  (optional)
     * @param end  (optional)
     * @param order  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getBatchListAsync(String projectId, String xAuthToken, String clusterName, Integer from, Integer size, String jobId, String jobName, Long start, Long end, String order, final ApiCallback<SessionInfos> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getBatchListValidateBeforeCall(projectId, xAuthToken, clusterName, from, size, jobId, jobName, start, end, order, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<SessionInfos>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getBatchLog
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param from  (optional)
     * @param size  (optional)
     * @param type  (optional)
     * @param index  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getBatchLogCall(String projectId, String batchId, String xAuthToken, Integer from, Integer size, String type, Integer index, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/batches/{batch_id}/log"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "batch_id" + "\\}", apiClient.escapeString(batchId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (from != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("from", from));
        if (size != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("size", size));
        if (type != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("type", type));
        if (index != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("index", index));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getBatchLogValidateBeforeCall(String projectId, String batchId, String xAuthToken, Integer from, Integer size, String type, Integer index, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getBatchLog(Async)");
        }
        
        // verify the required parameter 'batchId' is set
        if (batchId == null) {
            throw new ApiException("Missing the required parameter 'batchId' when calling getBatchLog(Async)");
        }
        
        
        okhttp3.Call call = getBatchLogCall(projectId, batchId, xAuthToken, from, size, type, index, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get specified batch log
     * Get specified batch log.
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param from  (optional)
     * @param size  (optional)
     * @param type  (optional)
     * @param index  (optional)
     * @return SessionLog
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public SessionLog getBatchLog(String projectId, String batchId, String xAuthToken, Integer from, Integer size, String type, Integer index) throws ApiException {
        ApiResponse<SessionLog> resp = getBatchLogWithHttpInfo(projectId, batchId, xAuthToken, from, size, type, index);
        return resp.getData();
    }

    /**
     * Get specified batch log
     * Get specified batch log.
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param from  (optional)
     * @param size  (optional)
     * @param type  (optional)
     * @param index  (optional)
     * @return ApiResponse&lt;SessionLog&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<SessionLog> getBatchLogWithHttpInfo(String projectId, String batchId, String xAuthToken, Integer from, Integer size, String type, Integer index) throws ApiException {
        okhttp3.Call call = getBatchLogValidateBeforeCall(projectId, batchId, xAuthToken, from, size, type, index, null, null);
        Type localVarReturnType = new TypeToken<SessionLog>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get specified batch log (asynchronously)
     * Get specified batch log.
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param from  (optional)
     * @param size  (optional)
     * @param type  (optional)
     * @param index  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getBatchLogAsync(String projectId, String batchId, String xAuthToken, Integer from, Integer size, String type, Integer index, final ApiCallback<SessionLog> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getBatchLogValidateBeforeCall(projectId, batchId, xAuthToken, from, size, type, index, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<SessionLog>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getBatchState
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getBatchStateCall(String projectId, String batchId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/batches/{batch_id}/state"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "batch_id" + "\\}", apiClient.escapeString(batchId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getBatchStateValidateBeforeCall(String projectId, String batchId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getBatchState(Async)");
        }
        
        // verify the required parameter 'batchId' is set
        if (batchId == null) {
            throw new ApiException("Missing the required parameter 'batchId' when calling getBatchState(Async)");
        }
        
        
        okhttp3.Call call = getBatchStateCall(projectId, batchId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get specified session state
     * Get specified session state.
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @return SessionState
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public SessionState getBatchState(String projectId, String batchId, String xAuthToken) throws ApiException {
        ApiResponse<SessionState> resp = getBatchStateWithHttpInfo(projectId, batchId, xAuthToken);
        return resp.getData();
    }

    /**
     * Get specified session state
     * Get specified session state.
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;SessionState&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<SessionState> getBatchStateWithHttpInfo(String projectId, String batchId, String xAuthToken) throws ApiException {
        okhttp3.Call call = getBatchStateValidateBeforeCall(projectId, batchId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<SessionState>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get specified session state (asynchronously)
     * Get specified session state.
     * @param projectId Project ID for resource isolation. (required)
     * @param batchId Batch ID. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getBatchStateAsync(String projectId, String batchId, String xAuthToken, final ApiCallback<SessionState> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getBatchStateValidateBeforeCall(projectId, batchId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<SessionState>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getCluster
     * @param projectId Project ID for resource isolation. (required)
     * @param clusterName Cluster name (required)
     * @param xAuthToken Authorization Token (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getClusterCall(String projectId, String clusterName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/clusters/{cluster_name}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "cluster_name" + "\\}", apiClient.escapeString(clusterName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getClusterValidateBeforeCall(String projectId, String clusterName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getCluster(Async)");
        }
        
        // verify the required parameter 'clusterName' is set
        if (clusterName == null) {
            throw new ApiException("Missing the required parameter 'clusterName' when calling getCluster(Async)");
        }
        
        // verify the required parameter 'xAuthToken' is set
        if (xAuthToken == null) {
            throw new ApiException("Missing the required parameter 'xAuthToken' when calling getCluster(Async)");
        }
        
        
        okhttp3.Call call = getClusterCall(projectId, clusterName, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List specified cluster
     * List specified cluster.
     * @param projectId Project ID for resource isolation. (required)
     * @param clusterName Cluster name (required)
     * @param xAuthToken Authorization Token (required)
     * @return ClusterInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ClusterInfo getCluster(String projectId, String clusterName, String xAuthToken) throws ApiException {
        ApiResponse<ClusterInfo> resp = getClusterWithHttpInfo(projectId, clusterName, xAuthToken);
        return resp.getData();
    }

    /**
     * List specified cluster
     * List specified cluster.
     * @param projectId Project ID for resource isolation. (required)
     * @param clusterName Cluster name (required)
     * @param xAuthToken Authorization Token (required)
     * @return ApiResponse&lt;ClusterInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ClusterInfo> getClusterWithHttpInfo(String projectId, String clusterName, String xAuthToken) throws ApiException {
        okhttp3.Call call = getClusterValidateBeforeCall(projectId, clusterName, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ClusterInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List specified cluster (asynchronously)
     * List specified cluster.
     * @param projectId Project ID for resource isolation. (required)
     * @param clusterName Cluster name (required)
     * @param xAuthToken Authorization Token (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getClusterAsync(String projectId, String clusterName, String xAuthToken, final ApiCallback<ClusterInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getClusterValidateBeforeCall(projectId, clusterName, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ClusterInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getFlinkApigSinks
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getFlinkApigSinksCall(String projectId, Long jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/jobs/{job_id}/apig-sinks"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "job_id" + "\\}", apiClient.escapeString(jobId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getFlinkApigSinksValidateBeforeCall(String projectId, Long jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getFlinkApigSinks(Async)");
        }
        
        // verify the required parameter 'jobId' is set
        if (jobId == null) {
            throw new ApiException("Missing the required parameter 'jobId' when calling getFlinkApigSinks(Async)");
        }
        
        
        okhttp3.Call call = getFlinkApigSinksCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 查询作业apig网关服务访问地址
     * The apig sinks is json format.
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @return FlinkJobApigSinksResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public FlinkJobApigSinksResponse getFlinkApigSinks(String projectId, Long jobId, String xAuthToken) throws ApiException {
        ApiResponse<FlinkJobApigSinksResponse> resp = getFlinkApigSinksWithHttpInfo(projectId, jobId, xAuthToken);
        return resp.getData();
    }

    /**
     * 查询作业apig网关服务访问地址
     * The apig sinks is json format.
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;FlinkJobApigSinksResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<FlinkJobApigSinksResponse> getFlinkApigSinksWithHttpInfo(String projectId, Long jobId, String xAuthToken) throws ApiException {
        okhttp3.Call call = getFlinkApigSinksValidateBeforeCall(projectId, jobId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<FlinkJobApigSinksResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 查询作业apig网关服务访问地址 (asynchronously)
     * The apig sinks is json format.
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getFlinkApigSinksAsync(String projectId, Long jobId, String xAuthToken, final ApiCallback<FlinkJobApigSinksResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getFlinkApigSinksValidateBeforeCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<FlinkJobApigSinksResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getFlinkJobDetail
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getFlinkJobDetailCall(String projectId, Long jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/jobs/{job_id}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "job_id" + "\\}", apiClient.escapeString(jobId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getFlinkJobDetailValidateBeforeCall(String projectId, Long jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getFlinkJobDetail(Async)");
        }
        
        // verify the required parameter 'jobId' is set
        if (jobId == null) {
            throw new ApiException("Missing the required parameter 'jobId' when calling getFlinkJobDetail(Async)");
        }
        
        
        okhttp3.Call call = getFlinkJobDetailCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 查询作业详情
     * Get job detail information.
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @return GetFlinkJobDetailResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GetFlinkJobDetailResponse getFlinkJobDetail(String projectId, Long jobId, String xAuthToken) throws ApiException {
        ApiResponse<GetFlinkJobDetailResponse> resp = getFlinkJobDetailWithHttpInfo(projectId, jobId, xAuthToken);
        return resp.getData();
    }

    /**
     * 查询作业详情
     * Get job detail information.
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;GetFlinkJobDetailResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GetFlinkJobDetailResponse> getFlinkJobDetailWithHttpInfo(String projectId, Long jobId, String xAuthToken) throws ApiException {
        okhttp3.Call call = getFlinkJobDetailValidateBeforeCall(projectId, jobId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<GetFlinkJobDetailResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 查询作业详情 (asynchronously)
     * Get job detail information.
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getFlinkJobDetailAsync(String projectId, Long jobId, String xAuthToken, final ApiCallback<GetFlinkJobDetailResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getFlinkJobDetailValidateBeforeCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GetFlinkJobDetailResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getFlinkJobExecuteGraph
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getFlinkJobExecuteGraphCall(String projectId, Long jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/jobs/{job_id}/execute-graph"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "job_id" + "\\}", apiClient.escapeString(jobId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getFlinkJobExecuteGraphValidateBeforeCall(String projectId, Long jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getFlinkJobExecuteGraph(Async)");
        }
        
        // verify the required parameter 'jobId' is set
        if (jobId == null) {
            throw new ApiException("Missing the required parameter 'jobId' when calling getFlinkJobExecuteGraph(Async)");
        }
        
        
        okhttp3.Call call = getFlinkJobExecuteGraphCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 查询作业执行计划图
     * The execution graph is json format.
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @return FlinkJobExecutePlanResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public FlinkJobExecutePlanResponse getFlinkJobExecuteGraph(String projectId, Long jobId, String xAuthToken) throws ApiException {
        ApiResponse<FlinkJobExecutePlanResponse> resp = getFlinkJobExecuteGraphWithHttpInfo(projectId, jobId, xAuthToken);
        return resp.getData();
    }

    /**
     * 查询作业执行计划图
     * The execution graph is json format.
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;FlinkJobExecutePlanResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<FlinkJobExecutePlanResponse> getFlinkJobExecuteGraphWithHttpInfo(String projectId, Long jobId, String xAuthToken) throws ApiException {
        okhttp3.Call call = getFlinkJobExecuteGraphValidateBeforeCall(projectId, jobId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<FlinkJobExecutePlanResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 查询作业执行计划图 (asynchronously)
     * The execution graph is json format.
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId 作业ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getFlinkJobExecuteGraphAsync(String projectId, Long jobId, String xAuthToken, final ApiCallback<FlinkJobExecutePlanResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getFlinkJobExecuteGraphValidateBeforeCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<FlinkJobExecutePlanResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getFlinkJobTemplates
     * @param projectId project id, 用于不同project取token. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param offset 作业偏移量 (optional)
     * @param limit 查询条数限制 (optional, default to 10)
     * @param order 查询结果排序, 升序和降序两种可选 (optional, default to desc)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getFlinkJobTemplatesCall(String projectId, String xAuthToken, Long offset, Integer limit, String order, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/job-templates"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("offset", offset));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("limit", limit));
        if (order != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("order", order));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getFlinkJobTemplatesValidateBeforeCall(String projectId, String xAuthToken, Long offset, Integer limit, String order, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getFlinkJobTemplates(Async)");
        }
        
        
        okhttp3.Call call = getFlinkJobTemplatesCall(projectId, xAuthToken, offset, limit, order, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 查询作业模板列表
     * 
     * @param projectId project id, 用于不同project取token. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param offset 作业偏移量 (optional)
     * @param limit 查询条数限制 (optional, default to 10)
     * @param order 查询结果排序, 升序和降序两种可选 (optional, default to desc)
     * @return FlinkJobTemplateListResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public FlinkJobTemplateListResponse getFlinkJobTemplates(String projectId, String xAuthToken, Long offset, Integer limit, String order) throws ApiException {
        ApiResponse<FlinkJobTemplateListResponse> resp = getFlinkJobTemplatesWithHttpInfo(projectId, xAuthToken, offset, limit, order);
        return resp.getData();
    }

    /**
     * 查询作业模板列表
     * 
     * @param projectId project id, 用于不同project取token. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param offset 作业偏移量 (optional)
     * @param limit 查询条数限制 (optional, default to 10)
     * @param order 查询结果排序, 升序和降序两种可选 (optional, default to desc)
     * @return ApiResponse&lt;FlinkJobTemplateListResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<FlinkJobTemplateListResponse> getFlinkJobTemplatesWithHttpInfo(String projectId, String xAuthToken, Long offset, Integer limit, String order) throws ApiException {
        okhttp3.Call call = getFlinkJobTemplatesValidateBeforeCall(projectId, xAuthToken, offset, limit, order, null, null);
        Type localVarReturnType = new TypeToken<FlinkJobTemplateListResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 查询作业模板列表 (asynchronously)
     * 
     * @param projectId project id, 用于不同project取token. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param offset 作业偏移量 (optional)
     * @param limit 查询条数限制 (optional, default to 10)
     * @param order 查询结果排序, 升序和降序两种可选 (optional, default to desc)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getFlinkJobTemplatesAsync(String projectId, String xAuthToken, Long offset, Integer limit, String order, final ApiCallback<FlinkJobTemplateListResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getFlinkJobTemplatesValidateBeforeCall(projectId, xAuthToken, offset, limit, order, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<FlinkJobTemplateListResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getFlinkJobs
     * @param projectId project id, 用于不同project取token. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param name 作业名 (optional)
     * @param status 作业状态码, 请参考DLI文档 (optional)
     * @param queueName 队列名称 (optional)
     * @param showDetail 是否返回作业详情信息 (optional, default to false)
     * @param offset 作业偏移量 (optional)
     * @param limit 返回的数据条数 (optional, default to 10)
     * @param order 查询结果排序, 升序和降序两种可选 (optional, default to desc)
     * @param rootJobId 边缘父作业ID, 用于查询指定边缘作业的子作业; 不带该参数时, 查询所有非边缘作业和边缘父作业, 不包括边缘子作业 (optional)
     * @param userName 用户名，可作为筛选条件 (optional)
     * @param jobType 作业类型 (optional)
     * @param showJobType 显示数据类型，可选spark，flink， all， 默认为all (optional, default to all)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getFlinkJobsCall(String projectId, String xAuthToken, String name, String status, String queueName, Boolean showDetail, Long offset, Integer limit, String order, Long rootJobId, String userName, String jobType, String showJobType, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/jobs"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (name != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("name", name));
        if (status != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("status", status));
        if (queueName != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("queue_name", queueName));
        if (showDetail != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("show_detail", showDetail));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("offset", offset));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("limit", limit));
        if (order != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("order", order));
        if (rootJobId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("root_job_id", rootJobId));
        if (userName != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("user_name", userName));
        if (jobType != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("job_type", jobType));
        if (showJobType != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("show_job_type", showJobType));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getFlinkJobsValidateBeforeCall(String projectId, String xAuthToken, String name, String status, String queueName, Boolean showDetail, Long offset, Integer limit, String order, Long rootJobId, String userName, String jobType, String showJobType, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getFlinkJobs(Async)");
        }
        
        
        okhttp3.Call call = getFlinkJobsCall(projectId, xAuthToken, name, status, queueName, showDetail, offset, limit, order, rootJobId, userName, jobType, showJobType, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 查询作业列表
     * 作业列表查询, 支持以下参数: name, status, show_detail, cursor, next, limit, order, root_job_id. The cursor here is job id.
     * @param projectId project id, 用于不同project取token. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param name 作业名 (optional)
     * @param status 作业状态码, 请参考DLI文档 (optional)
     * @param queueName 队列名称 (optional)
     * @param showDetail 是否返回作业详情信息 (optional, default to false)
     * @param offset 作业偏移量 (optional)
     * @param limit 返回的数据条数 (optional, default to 10)
     * @param order 查询结果排序, 升序和降序两种可选 (optional, default to desc)
     * @param rootJobId 边缘父作业ID, 用于查询指定边缘作业的子作业; 不带该参数时, 查询所有非边缘作业和边缘父作业, 不包括边缘子作业 (optional)
     * @param userName 用户名，可作为筛选条件 (optional)
     * @param jobType 作业类型 (optional)
     * @param showJobType 显示数据类型，可选spark，flink， all， 默认为all (optional, default to all)
     * @return QueryFlinkJobListResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public QueryFlinkJobListResponse getFlinkJobs(String projectId, String xAuthToken, String name, String status, String queueName, Boolean showDetail, Long offset, Integer limit, String order, Long rootJobId, String userName, String jobType, String showJobType) throws ApiException {
        ApiResponse<QueryFlinkJobListResponse> resp = getFlinkJobsWithHttpInfo(projectId, xAuthToken, name, status, queueName, showDetail, offset, limit, order, rootJobId, userName, jobType, showJobType);
        return resp.getData();
    }

    /**
     * 查询作业列表
     * 作业列表查询, 支持以下参数: name, status, show_detail, cursor, next, limit, order, root_job_id. The cursor here is job id.
     * @param projectId project id, 用于不同project取token. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param name 作业名 (optional)
     * @param status 作业状态码, 请参考DLI文档 (optional)
     * @param queueName 队列名称 (optional)
     * @param showDetail 是否返回作业详情信息 (optional, default to false)
     * @param offset 作业偏移量 (optional)
     * @param limit 返回的数据条数 (optional, default to 10)
     * @param order 查询结果排序, 升序和降序两种可选 (optional, default to desc)
     * @param rootJobId 边缘父作业ID, 用于查询指定边缘作业的子作业; 不带该参数时, 查询所有非边缘作业和边缘父作业, 不包括边缘子作业 (optional)
     * @param userName 用户名，可作为筛选条件 (optional)
     * @param jobType 作业类型 (optional)
     * @param showJobType 显示数据类型，可选spark，flink， all， 默认为all (optional, default to all)
     * @return ApiResponse&lt;QueryFlinkJobListResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<QueryFlinkJobListResponse> getFlinkJobsWithHttpInfo(String projectId, String xAuthToken, String name, String status, String queueName, Boolean showDetail, Long offset, Integer limit, String order, Long rootJobId, String userName, String jobType, String showJobType) throws ApiException {
        okhttp3.Call call = getFlinkJobsValidateBeforeCall(projectId, xAuthToken, name, status, queueName, showDetail, offset, limit, order, rootJobId, userName, jobType, showJobType, null, null);
        Type localVarReturnType = new TypeToken<QueryFlinkJobListResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 查询作业列表 (asynchronously)
     * 作业列表查询, 支持以下参数: name, status, show_detail, cursor, next, limit, order, root_job_id. The cursor here is job id.
     * @param projectId project id, 用于不同project取token. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param name 作业名 (optional)
     * @param status 作业状态码, 请参考DLI文档 (optional)
     * @param queueName 队列名称 (optional)
     * @param showDetail 是否返回作业详情信息 (optional, default to false)
     * @param offset 作业偏移量 (optional)
     * @param limit 返回的数据条数 (optional, default to 10)
     * @param order 查询结果排序, 升序和降序两种可选 (optional, default to desc)
     * @param rootJobId 边缘父作业ID, 用于查询指定边缘作业的子作业; 不带该参数时, 查询所有非边缘作业和边缘父作业, 不包括边缘子作业 (optional)
     * @param userName 用户名，可作为筛选条件 (optional)
     * @param jobType 作业类型 (optional)
     * @param showJobType 显示数据类型，可选spark，flink， all， 默认为all (optional, default to all)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getFlinkJobsAsync(String projectId, String xAuthToken, String name, String status, String queueName, Boolean showDetail, Long offset, Integer limit, String order, Long rootJobId, String userName, String jobType, String showJobType, final ApiCallback<QueryFlinkJobListResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getFlinkJobsValidateBeforeCall(projectId, xAuthToken, name, status, queueName, showDetail, offset, limit, order, rootJobId, userName, jobType, showJobType, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<QueryFlinkJobListResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getFlinkJobsMetrics
     * @param projectId project id, 用于不同project取token. (required)
     * @param getFlinkJobsMetricsBody 查询作业监控信息, 支持同时查询多个作业监控, 请求参数为json格式 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getFlinkJobsMetricsCall(String projectId, GetFlinkJobsMetricsBody getFlinkJobsMetricsBody, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = getFlinkJobsMetricsBody;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/jobs/metrics"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getFlinkJobsMetricsValidateBeforeCall(String projectId, GetFlinkJobsMetricsBody getFlinkJobsMetricsBody, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getFlinkJobsMetrics(Async)");
        }
        
        // verify the required parameter 'getFlinkJobsMetricsBody' is set
        if (getFlinkJobsMetricsBody == null) {
            throw new ApiException("Missing the required parameter 'getFlinkJobsMetricsBody' when calling getFlinkJobsMetrics(Async)");
        }
        
        
        okhttp3.Call call = getFlinkJobsMetricsCall(projectId, getFlinkJobsMetricsBody, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 查询作业监控信息
     * 查询作业监控信息, 支持同时查询多个作业监控信息
     * @param projectId project id, 用于不同project取token. (required)
     * @param getFlinkJobsMetricsBody 查询作业监控信息, 支持同时查询多个作业监控, 请求参数为json格式 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return QueryFlinkJobMetricsResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public QueryFlinkJobMetricsResponse getFlinkJobsMetrics(String projectId, GetFlinkJobsMetricsBody getFlinkJobsMetricsBody, String xAuthToken) throws ApiException {
        ApiResponse<QueryFlinkJobMetricsResponse> resp = getFlinkJobsMetricsWithHttpInfo(projectId, getFlinkJobsMetricsBody, xAuthToken);
        return resp.getData();
    }

    /**
     * 查询作业监控信息
     * 查询作业监控信息, 支持同时查询多个作业监控信息
     * @param projectId project id, 用于不同project取token. (required)
     * @param getFlinkJobsMetricsBody 查询作业监控信息, 支持同时查询多个作业监控, 请求参数为json格式 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;QueryFlinkJobMetricsResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<QueryFlinkJobMetricsResponse> getFlinkJobsMetricsWithHttpInfo(String projectId, GetFlinkJobsMetricsBody getFlinkJobsMetricsBody, String xAuthToken) throws ApiException {
        okhttp3.Call call = getFlinkJobsMetricsValidateBeforeCall(projectId, getFlinkJobsMetricsBody, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<QueryFlinkJobMetricsResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 查询作业监控信息 (asynchronously)
     * 查询作业监控信息, 支持同时查询多个作业监控信息
     * @param projectId project id, 用于不同project取token. (required)
     * @param getFlinkJobsMetricsBody 查询作业监控信息, 支持同时查询多个作业监控, 请求参数为json格式 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getFlinkJobsMetricsAsync(String projectId, GetFlinkJobsMetricsBody getFlinkJobsMetricsBody, String xAuthToken, final ApiCallback<QueryFlinkJobMetricsResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getFlinkJobsMetricsValidateBeforeCall(projectId, getFlinkJobsMetricsBody, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<QueryFlinkJobMetricsResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getImportExportJobInfo
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getImportExportJobInfoCall(String projectId, String jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/jobs/{job_id}/detail"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "job_id" + "\\}", apiClient.escapeString(jobId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getImportExportJobInfoValidateBeforeCall(String projectId, String jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getImportExportJobInfo(Async)");
        }
        
        // verify the required parameter 'jobId' is set
        if (jobId == null) {
            throw new ApiException("Missing the required parameter 'jobId' when calling getImportExportJobInfo(Async)");
        }
        
        
        okhttp3.Call call = getImportExportJobInfoCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Import and Export detail
     * Query the details of imported and exported jobs, such as the job&#39;s databaseName, tableName, file size, and export mode.
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return DetailResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public DetailResult getImportExportJobInfo(String projectId, String jobId, String xAuthToken) throws ApiException {
        ApiResponse<DetailResult> resp = getImportExportJobInfoWithHttpInfo(projectId, jobId, xAuthToken);
        return resp.getData();
    }

    /**
     * Import and Export detail
     * Query the details of imported and exported jobs, such as the job&#39;s databaseName, tableName, file size, and export mode.
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;DetailResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<DetailResult> getImportExportJobInfoWithHttpInfo(String projectId, String jobId, String xAuthToken) throws ApiException {
        okhttp3.Call call = getImportExportJobInfoValidateBeforeCall(projectId, jobId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<DetailResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Import and Export detail (asynchronously)
     * Query the details of imported and exported jobs, such as the job&#39;s databaseName, tableName, file size, and export mode.
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getImportExportJobInfoAsync(String projectId, String jobId, String xAuthToken, final ApiCallback<DetailResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getImportExportJobInfoValidateBeforeCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<DetailResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getJobProgress
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId  (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getJobProgressCall(String projectId, String jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1/{project_id}/jobs/{job_id}/progress"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "job_id" + "\\}", apiClient.escapeString(jobId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getJobProgressValidateBeforeCall(String projectId, String jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getJobProgress(Async)");
        }
        
        // verify the required parameter 'jobId' is set
        if (jobId == null) {
            throw new ApiException("Missing the required parameter 'jobId' when calling getJobProgress(Async)");
        }
        
        
        okhttp3.Call call = getJobProgressCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get job progress
     * Get job progress
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId  (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return JobProgressResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public JobProgressResult getJobProgress(String projectId, String jobId, String xAuthToken) throws ApiException {
        ApiResponse<JobProgressResult> resp = getJobProgressWithHttpInfo(projectId, jobId, xAuthToken);
        return resp.getData();
    }

    /**
     * Get job progress
     * Get job progress
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId  (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;JobProgressResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<JobProgressResult> getJobProgressWithHttpInfo(String projectId, String jobId, String xAuthToken) throws ApiException {
        okhttp3.Call call = getJobProgressValidateBeforeCall(projectId, jobId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<JobProgressResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get job progress (asynchronously)
     * Get job progress
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId  (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getJobProgressAsync(String projectId, String jobId, String xAuthToken, final ApiCallback<JobProgressResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getJobProgressValidateBeforeCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<JobProgressResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getJobResult
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @param queueName The DLI queue that executed this API request. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getJobResultCall(String projectId, String jobId, String xAuthToken, Integer pageSize, Integer currentPage, String queueName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/jobs/{job_id}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "job_id" + "\\}", apiClient.escapeString(jobId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page-size", pageSize));
        if (currentPage != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("current-page", currentPage));
        if (queueName != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("queue-name", queueName));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getJobResultValidateBeforeCall(String projectId, String jobId, String xAuthToken, Integer pageSize, Integer currentPage, String queueName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getJobResult(Async)");
        }
        
        // verify the required parameter 'jobId' is set
        if (jobId == null) {
            throw new ApiException("Missing the required parameter 'jobId' when calling getJobResult(Async)");
        }
        
        
        okhttp3.Call call = getJobResultCall(projectId, jobId, xAuthToken, pageSize, currentPage, queueName, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get job result
     * After the job executing the SQL query is completed, review the result of the job execution. Currently, it is only supported to see the results of the execution of QUERY type jobs. The API can only view the results of the first 1000 records, to see all the results of the record, you need to export the query results before viewing
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @param queueName The DLI queue that executed this API request. (optional)
     * @return JobResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public JobResult getJobResult(String projectId, String jobId, String xAuthToken, Integer pageSize, Integer currentPage, String queueName) throws ApiException {
        ApiResponse<JobResult> resp = getJobResultWithHttpInfo(projectId, jobId, xAuthToken, pageSize, currentPage, queueName);
        return resp.getData();
    }

    /**
     * Get job result
     * After the job executing the SQL query is completed, review the result of the job execution. Currently, it is only supported to see the results of the execution of QUERY type jobs. The API can only view the results of the first 1000 records, to see all the results of the record, you need to export the query results before viewing
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @param queueName The DLI queue that executed this API request. (optional)
     * @return ApiResponse&lt;JobResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<JobResult> getJobResultWithHttpInfo(String projectId, String jobId, String xAuthToken, Integer pageSize, Integer currentPage, String queueName) throws ApiException {
        okhttp3.Call call = getJobResultValidateBeforeCall(projectId, jobId, xAuthToken, pageSize, currentPage, queueName, null, null);
        Type localVarReturnType = new TypeToken<JobResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get job result (asynchronously)
     * After the job executing the SQL query is completed, review the result of the job execution. Currently, it is only supported to see the results of the execution of QUERY type jobs. The API can only view the results of the first 1000 records, to see all the results of the record, you need to export the query results before viewing
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @param queueName The DLI queue that executed this API request. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getJobResultAsync(String projectId, String jobId, String xAuthToken, Integer pageSize, Integer currentPage, String queueName, final ApiCallback<JobResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getJobResultValidateBeforeCall(projectId, jobId, xAuthToken, pageSize, currentPage, queueName, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<JobResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getJobResult_0
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The current queue name, the SQL will use the current queue resources to calculate. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getJobResult_0Call(String projectId, String queueName, String jobId, String xAuthToken, Integer pageSize, Integer currentPage, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/queues/{queue_name}/jobs/{job_id}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "queue_name" + "\\}", apiClient.escapeString(queueName.toString()))
            .replaceAll("\\{" + "job_id" + "\\}", apiClient.escapeString(jobId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page-size", pageSize));
        if (currentPage != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("current-page", currentPage));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getJobResult_0ValidateBeforeCall(String projectId, String queueName, String jobId, String xAuthToken, Integer pageSize, Integer currentPage, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getJobResult_0(Async)");
        }
        
        // verify the required parameter 'queueName' is set
        if (queueName == null) {
            throw new ApiException("Missing the required parameter 'queueName' when calling getJobResult_0(Async)");
        }
        
        // verify the required parameter 'jobId' is set
        if (jobId == null) {
            throw new ApiException("Missing the required parameter 'jobId' when calling getJobResult_0(Async)");
        }
        
        
        okhttp3.Call call = getJobResult_0Call(projectId, queueName, jobId, xAuthToken, pageSize, currentPage, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get job result
     * After the job executing the SQL query is completed, review the result of the job execution. Currently, it is only supported to see the results of the execution of QUERY type jobs. The API can only view the results of the first 1000 records, to see all the results of the record, you need to export the query results before viewing
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The current queue name, the SQL will use the current queue resources to calculate. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @return JobResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public JobResult getJobResult_0(String projectId, String queueName, String jobId, String xAuthToken, Integer pageSize, Integer currentPage) throws ApiException {
        ApiResponse<JobResult> resp = getJobResult_0WithHttpInfo(projectId, queueName, jobId, xAuthToken, pageSize, currentPage);
        return resp.getData();
    }

    /**
     * Get job result
     * After the job executing the SQL query is completed, review the result of the job execution. Currently, it is only supported to see the results of the execution of QUERY type jobs. The API can only view the results of the first 1000 records, to see all the results of the record, you need to export the query results before viewing
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The current queue name, the SQL will use the current queue resources to calculate. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @return ApiResponse&lt;JobResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<JobResult> getJobResult_0WithHttpInfo(String projectId, String queueName, String jobId, String xAuthToken, Integer pageSize, Integer currentPage) throws ApiException {
        okhttp3.Call call = getJobResult_0ValidateBeforeCall(projectId, queueName, jobId, xAuthToken, pageSize, currentPage, null, null);
        Type localVarReturnType = new TypeToken<JobResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get job result (asynchronously)
     * After the job executing the SQL query is completed, review the result of the job execution. Currently, it is only supported to see the results of the execution of QUERY type jobs. The API can only view the results of the first 1000 records, to see all the results of the record, you need to export the query results before viewing
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The current queue name, the SQL will use the current queue resources to calculate. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getJobResult_0Async(String projectId, String queueName, String jobId, String xAuthToken, Integer pageSize, Integer currentPage, final ApiCallback<JobResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getJobResult_0ValidateBeforeCall(projectId, queueName, jobId, xAuthToken, pageSize, currentPage, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<JobResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getJobStatus
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getJobStatusCall(String projectId, String jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/jobs/{job_id}/status"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "job_id" + "\\}", apiClient.escapeString(jobId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getJobStatusValidateBeforeCall(String projectId, String jobId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getJobStatus(Async)");
        }
        
        // verify the required parameter 'jobId' is set
        if (jobId == null) {
            throw new ApiException("Missing the required parameter 'jobId' when calling getJobStatus(Async)");
        }
        
        
        okhttp3.Call call = getJobStatusCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get job status
     * Get job status after job submission.
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return StatusResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public StatusResult getJobStatus(String projectId, String jobId, String xAuthToken) throws ApiException {
        ApiResponse<StatusResult> resp = getJobStatusWithHttpInfo(projectId, jobId, xAuthToken);
        return resp.getData();
    }

    /**
     * Get job status
     * Get job status after job submission.
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;StatusResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<StatusResult> getJobStatusWithHttpInfo(String projectId, String jobId, String xAuthToken) throws ApiException {
        okhttp3.Call call = getJobStatusValidateBeforeCall(projectId, jobId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<StatusResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get job status (asynchronously)
     * Get job status after job submission.
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getJobStatusAsync(String projectId, String jobId, String xAuthToken, final ApiCallback<StatusResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getJobStatusValidateBeforeCall(projectId, jobId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<StatusResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getResourceInfo
     * @param projectId Project ID for resource isolation. (required)
     * @param resourceName Resource name. (required)
     * @param group Resource group. (optional)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getResourceInfoCall(String projectId, String resourceName, String group, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/resources/{resource_name}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "resource_name" + "\\}", apiClient.escapeString(resourceName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (group != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("group", group));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getResourceInfoValidateBeforeCall(String projectId, String resourceName, String group, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getResourceInfo(Async)");
        }
        
        // verify the required parameter 'resourceName' is set
        if (resourceName == null) {
            throw new ApiException("Missing the required parameter 'resourceName' when calling getResourceInfo(Async)");
        }
        
        
        okhttp3.Call call = getResourceInfoCall(projectId, resourceName, group, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List specified resource
     * List specified resource.
     * @param projectId Project ID for resource isolation. (required)
     * @param resourceName Resource name. (required)
     * @param group Resource group. (optional)
     * @param xAuthToken Authorization Token (optional)
     * @return PkgResourceInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PkgResourceInfo getResourceInfo(String projectId, String resourceName, String group, String xAuthToken) throws ApiException {
        ApiResponse<PkgResourceInfo> resp = getResourceInfoWithHttpInfo(projectId, resourceName, group, xAuthToken);
        return resp.getData();
    }

    /**
     * List specified resource
     * List specified resource.
     * @param projectId Project ID for resource isolation. (required)
     * @param resourceName Resource name. (required)
     * @param group Resource group. (optional)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;PkgResourceInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PkgResourceInfo> getResourceInfoWithHttpInfo(String projectId, String resourceName, String group, String xAuthToken) throws ApiException {
        okhttp3.Call call = getResourceInfoValidateBeforeCall(projectId, resourceName, group, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<PkgResourceInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List specified resource (asynchronously)
     * List specified resource.
     * @param projectId Project ID for resource isolation. (required)
     * @param resourceName Resource name. (required)
     * @param group Resource group. (optional)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getResourceInfoAsync(String projectId, String resourceName, String group, String xAuthToken, final ApiCallback<PkgResourceInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getResourceInfoValidateBeforeCall(projectId, resourceName, group, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PkgResourceInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getSpecifiedQueue
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the queue (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getSpecifiedQueueCall(String projectId, String queueName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/queues/{queue_name}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "queue_name" + "\\}", apiClient.escapeString(queueName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getSpecifiedQueueValidateBeforeCall(String projectId, String queueName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getSpecifiedQueue(Async)");
        }
        
        // verify the required parameter 'queueName' is set
        if (queueName == null) {
            throw new ApiException("Missing the required parameter 'queueName' when calling getSpecifiedQueue(Async)");
        }
        
        
        okhttp3.Call call = getSpecifiedQueueCall(projectId, queueName, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get queue
     * Get the specified queue.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the queue (required)
     * @param xAuthToken Authorization Token (optional)
     * @return QueueInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public QueueInfo getSpecifiedQueue(String projectId, String queueName, String xAuthToken) throws ApiException {
        ApiResponse<QueueInfo> resp = getSpecifiedQueueWithHttpInfo(projectId, queueName, xAuthToken);
        return resp.getData();
    }

    /**
     * Get queue
     * Get the specified queue.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the queue (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;QueueInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<QueueInfo> getSpecifiedQueueWithHttpInfo(String projectId, String queueName, String xAuthToken) throws ApiException {
        okhttp3.Call call = getSpecifiedQueueValidateBeforeCall(projectId, queueName, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<QueueInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get queue (asynchronously)
     * Get the specified queue.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the queue (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getSpecifiedQueueAsync(String projectId, String queueName, String xAuthToken, final ApiCallback<QueueInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getSpecifiedQueueValidateBeforeCall(projectId, queueName, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<QueueInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getTsdbById
     * @param projectId 项目ID (required)
     * @param tsdbId 时序数据库的ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getTsdbByIdCall(String projectId, Long tsdbId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v3/{project_id}/tsdbs/{tsdb_id}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "tsdb_id" + "\\}", apiClient.escapeString(tsdbId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getTsdbByIdValidateBeforeCall(String projectId, Long tsdbId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getTsdbById(Async)");
        }
        
        // verify the required parameter 'tsdbId' is set
        if (tsdbId == null) {
            throw new ApiException("Missing the required parameter 'tsdbId' when calling getTsdbById(Async)");
        }
        
        
        okhttp3.Call call = getTsdbByIdCall(projectId, tsdbId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 查询时序数据库配置信息详情
     * 根据时序数据库ID，查询时序数据库详情
     * @param projectId 项目ID (required)
     * @param tsdbId 时序数据库的ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @return GetTsdbByIdResp
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GetTsdbByIdResp getTsdbById(String projectId, Long tsdbId, String xAuthToken) throws ApiException {
        ApiResponse<GetTsdbByIdResp> resp = getTsdbByIdWithHttpInfo(projectId, tsdbId, xAuthToken);
        return resp.getData();
    }

    /**
     * 查询时序数据库配置信息详情
     * 根据时序数据库ID，查询时序数据库详情
     * @param projectId 项目ID (required)
     * @param tsdbId 时序数据库的ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;GetTsdbByIdResp&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GetTsdbByIdResp> getTsdbByIdWithHttpInfo(String projectId, Long tsdbId, String xAuthToken) throws ApiException {
        okhttp3.Call call = getTsdbByIdValidateBeforeCall(projectId, tsdbId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<GetTsdbByIdResp>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 查询时序数据库配置信息详情 (asynchronously)
     * 根据时序数据库ID，查询时序数据库详情
     * @param projectId 项目ID (required)
     * @param tsdbId 时序数据库的ID (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getTsdbByIdAsync(String projectId, Long tsdbId, String xAuthToken, final ApiCallback<GetTsdbByIdResp> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getTsdbByIdValidateBeforeCall(projectId, tsdbId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GetTsdbByIdResp>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getTsdbList
     * @param projectId  (required)
     * @param offset 偏移量 (optional, default to 0)
     * @param limit 每页的数量 (optional, default to 10)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call getTsdbListCall(String projectId, Integer offset, Integer limit, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v3/{project_id}/tsdbs"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("offset", offset));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("limit", limit));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call getTsdbListValidateBeforeCall(String projectId, Integer offset, Integer limit, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling getTsdbList(Async)");
        }
        
        
        okhttp3.Call call = getTsdbListCall(projectId, offset, limit, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 查询时序数据库配置信息列表
     * 
     * @param projectId  (required)
     * @param offset 偏移量 (optional, default to 0)
     * @param limit 每页的数量 (optional, default to 10)
     * @param xAuthToken Authorization Token (optional)
     * @return GetTsdbListResp
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GetTsdbListResp getTsdbList(String projectId, Integer offset, Integer limit, String xAuthToken) throws ApiException {
        ApiResponse<GetTsdbListResp> resp = getTsdbListWithHttpInfo(projectId, offset, limit, xAuthToken);
        return resp.getData();
    }

    /**
     * 查询时序数据库配置信息列表
     * 
     * @param projectId  (required)
     * @param offset 偏移量 (optional, default to 0)
     * @param limit 每页的数量 (optional, default to 10)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;GetTsdbListResp&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GetTsdbListResp> getTsdbListWithHttpInfo(String projectId, Integer offset, Integer limit, String xAuthToken) throws ApiException {
        okhttp3.Call call = getTsdbListValidateBeforeCall(projectId, offset, limit, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<GetTsdbListResp>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 查询时序数据库配置信息列表 (asynchronously)
     * 
     * @param projectId  (required)
     * @param offset 偏移量 (optional, default to 0)
     * @param limit 每页的数量 (optional, default to 10)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call getTsdbListAsync(String projectId, Integer offset, Integer limit, String xAuthToken, final ApiCallback<GetTsdbListResp> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = getTsdbListValidateBeforeCall(projectId, offset, limit, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GetTsdbListResp>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for importData
     * @param projectId Project ID for resource isolation. (required)
     * @param importExportInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call importDataCall(String projectId, ImportJobRequest importExportInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = importExportInfo;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/jobs/import-table"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call importDataValidateBeforeCall(String projectId, ImportJobRequest importExportInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling importData(Async)");
        }
        
        // verify the required parameter 'importExportInfo' is set
        if (importExportInfo == null) {
            throw new ApiException("Missing the required parameter 'importExportInfo' when calling importData(Async)");
        }
        
        
        okhttp3.Call call = importDataCall(projectId, importExportInfo, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Import data
     * Importing data from a file into a DLI table currently only supports importing data from OBS into DLI.
     * @param projectId Project ID for resource isolation. (required)
     * @param importExportInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ResponseJobInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseJobInfo importData(String projectId, ImportJobRequest importExportInfo, String xAuthToken) throws ApiException {
        ApiResponse<ResponseJobInfo> resp = importDataWithHttpInfo(projectId, importExportInfo, xAuthToken);
        return resp.getData();
    }

    /**
     * Import data
     * Importing data from a file into a DLI table currently only supports importing data from OBS into DLI.
     * @param projectId Project ID for resource isolation. (required)
     * @param importExportInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;ResponseJobInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseJobInfo> importDataWithHttpInfo(String projectId, ImportJobRequest importExportInfo, String xAuthToken) throws ApiException {
        okhttp3.Call call = importDataValidateBeforeCall(projectId, importExportInfo, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseJobInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Import data (asynchronously)
     * Importing data from a file into a DLI table currently only supports importing data from OBS into DLI.
     * @param projectId Project ID for resource isolation. (required)
     * @param importExportInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call importDataAsync(String projectId, ImportJobRequest importExportInfo, String xAuthToken, final ApiCallback<ResponseJobInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = importDataValidateBeforeCall(projectId, importExportInfo, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseJobInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for listAllDatabases
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call listAllDatabasesCall(String projectId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/databases"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call listAllDatabasesValidateBeforeCall(String projectId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling listAllDatabases(Async)");
        }
        
        
        okhttp3.Call call = listAllDatabasesCall(projectId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List all databases
     * List all databases info,include owner and table_number.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @return DatabaseResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public DatabaseResult listAllDatabases(String projectId, String xAuthToken) throws ApiException {
        ApiResponse<DatabaseResult> resp = listAllDatabasesWithHttpInfo(projectId, xAuthToken);
        return resp.getData();
    }

    /**
     * List all databases
     * List all databases info,include owner and table_number.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;DatabaseResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<DatabaseResult> listAllDatabasesWithHttpInfo(String projectId, String xAuthToken) throws ApiException {
        okhttp3.Call call = listAllDatabasesValidateBeforeCall(projectId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<DatabaseResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List all databases (asynchronously)
     * List all databases info,include owner and table_number.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call listAllDatabasesAsync(String projectId, String xAuthToken, final ApiCallback<DatabaseResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = listAllDatabasesValidateBeforeCall(projectId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<DatabaseResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for listAllJobs
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @param start  (optional)
     * @param end  (optional)
     * @param jobType  (optional)
     * @param tags  (optional)
     * @param queueName  (optional)
     * @param owner  (optional)
     * @param jobStatus  (optional)
     * @param order 查询结果排序, 升序和降序两种可选 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call listAllJobsCall(String projectId, String xAuthToken, Integer pageSize, Integer currentPage, Long start, Long end, String jobType, String tags, String queueName, String owner, String jobStatus, String order, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/jobs"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page-size", pageSize));
        if (currentPage != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("current-page", currentPage));
        if (start != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("start", start));
        if (end != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("end", end));
        if (jobType != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("job-type", jobType));
        if (tags != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("tags", tags));
        if (queueName != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("queue_name", queueName));
        if (owner != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("owner", owner));
        if (jobStatus != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("job-status", jobStatus));
        if (order != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("order", order));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call listAllJobsValidateBeforeCall(String projectId, String xAuthToken, Integer pageSize, Integer currentPage, Long start, Long end, String jobType, String tags, String queueName, String owner, String jobStatus, String order, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling listAllJobs(Async)");
        }
        
        
        okhttp3.Call call = listAllJobsCall(projectId, xAuthToken, pageSize, currentPage, start, end, jobType, tags, queueName, owner, jobStatus, order, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List all jobs
     * List all jobs
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @param start  (optional)
     * @param end  (optional)
     * @param jobType  (optional)
     * @param tags  (optional)
     * @param queueName  (optional)
     * @param owner  (optional)
     * @param jobStatus  (optional)
     * @param order 查询结果排序, 升序和降序两种可选 (optional)
     * @return JobListResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public JobListResult listAllJobs(String projectId, String xAuthToken, Integer pageSize, Integer currentPage, Long start, Long end, String jobType, String tags, String queueName, String owner, String jobStatus, String order) throws ApiException {
        ApiResponse<JobListResult> resp = listAllJobsWithHttpInfo(projectId, xAuthToken, pageSize, currentPage, start, end, jobType, tags, queueName, owner, jobStatus, order);
        return resp.getData();
    }

    /**
     * List all jobs
     * List all jobs
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @param start  (optional)
     * @param end  (optional)
     * @param jobType  (optional)
     * @param tags  (optional)
     * @param queueName  (optional)
     * @param owner  (optional)
     * @param jobStatus  (optional)
     * @param order 查询结果排序, 升序和降序两种可选 (optional)
     * @return ApiResponse&lt;JobListResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<JobListResult> listAllJobsWithHttpInfo(String projectId, String xAuthToken, Integer pageSize, Integer currentPage, Long start, Long end, String jobType, String tags, String queueName, String owner, String jobStatus, String order) throws ApiException {
        okhttp3.Call call = listAllJobsValidateBeforeCall(projectId, xAuthToken, pageSize, currentPage, start, end, jobType, tags, queueName, owner, jobStatus, order, null, null);
        Type localVarReturnType = new TypeToken<JobListResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List all jobs (asynchronously)
     * List all jobs
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @param start  (optional)
     * @param end  (optional)
     * @param jobType  (optional)
     * @param tags  (optional)
     * @param queueName  (optional)
     * @param owner  (optional)
     * @param jobStatus  (optional)
     * @param order 查询结果排序, 升序和降序两种可选 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call listAllJobsAsync(String projectId, String xAuthToken, Integer pageSize, Integer currentPage, Long start, Long end, String jobType, String tags, String queueName, String owner, String jobStatus, String order, final ApiCallback<JobListResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = listAllJobsValidateBeforeCall(projectId, xAuthToken, pageSize, currentPage, start, end, jobType, tags, queueName, owner, jobStatus, order, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<JobListResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for listAllQueues
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param queueType Queue Type (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call listAllQueuesCall(String projectId, String xAuthToken, String queueType, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/queues"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (queueType != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("queue_type", queueType));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call listAllQueuesValidateBeforeCall(String projectId, String xAuthToken, String queueType, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling listAllQueues(Async)");
        }
        
        
        okhttp3.Call call = listAllQueuesCall(projectId, xAuthToken, queueType, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List all queues
     * List all the queues under the project.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param queueType Queue Type (optional)
     * @return QueueResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public QueueResult listAllQueues(String projectId, String xAuthToken, String queueType) throws ApiException {
        ApiResponse<QueueResult> resp = listAllQueuesWithHttpInfo(projectId, xAuthToken, queueType);
        return resp.getData();
    }

    /**
     * List all queues
     * List all the queues under the project.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param queueType Queue Type (optional)
     * @return ApiResponse&lt;QueueResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<QueueResult> listAllQueuesWithHttpInfo(String projectId, String xAuthToken, String queueType) throws ApiException {
        okhttp3.Call call = listAllQueuesValidateBeforeCall(projectId, xAuthToken, queueType, null, null);
        Type localVarReturnType = new TypeToken<QueueResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List all queues (asynchronously)
     * List all the queues under the project.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param queueType Queue Type (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call listAllQueuesAsync(String projectId, String xAuthToken, String queueType, final ApiCallback<QueueResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = listAllQueuesValidateBeforeCall(projectId, xAuthToken, queueType, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<QueueResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for listAllTables
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName View the database where the table name. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param keyword Keywords for filtering table names. (optional)
     * @param withDetail Whether to get the details of the table (owner, size, etc.). (optional)
     * @param pageSize  (optional)
     * @param currentPage  (optional)
     * @param tableType  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call listAllTablesCall(String projectId, String databaseName, String xAuthToken, String keyword, Boolean withDetail, Integer pageSize, Integer currentPage, String tableType, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/databases/{database_name}/tables"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "database_name" + "\\}", apiClient.escapeString(databaseName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (keyword != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("keyword", keyword));
        if (withDetail != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("with-detail", withDetail));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page-size", pageSize));
        if (currentPage != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("current-page", currentPage));
        if (tableType != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("table-type", tableType));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call listAllTablesValidateBeforeCall(String projectId, String databaseName, String xAuthToken, String keyword, Boolean withDetail, Integer pageSize, Integer currentPage, String tableType, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling listAllTables(Async)");
        }
        
        // verify the required parameter 'databaseName' is set
        if (databaseName == null) {
            throw new ApiException("Missing the required parameter 'databaseName' when calling listAllTables(Async)");
        }
        
        
        okhttp3.Call call = listAllTablesCall(projectId, databaseName, xAuthToken, keyword, withDetail, pageSize, currentPage, tableType, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List all tables
     * Query the specified database under the filter conditions or all of the table information.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName View the database where the table name. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param keyword Keywords for filtering table names. (optional)
     * @param withDetail Whether to get the details of the table (owner, size, etc.). (optional)
     * @param pageSize  (optional)
     * @param currentPage  (optional)
     * @param tableType  (optional)
     * @return TableListResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public TableListResult listAllTables(String projectId, String databaseName, String xAuthToken, String keyword, Boolean withDetail, Integer pageSize, Integer currentPage, String tableType) throws ApiException {
        ApiResponse<TableListResult> resp = listAllTablesWithHttpInfo(projectId, databaseName, xAuthToken, keyword, withDetail, pageSize, currentPage, tableType);
        return resp.getData();
    }

    /**
     * List all tables
     * Query the specified database under the filter conditions or all of the table information.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName View the database where the table name. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param keyword Keywords for filtering table names. (optional)
     * @param withDetail Whether to get the details of the table (owner, size, etc.). (optional)
     * @param pageSize  (optional)
     * @param currentPage  (optional)
     * @param tableType  (optional)
     * @return ApiResponse&lt;TableListResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<TableListResult> listAllTablesWithHttpInfo(String projectId, String databaseName, String xAuthToken, String keyword, Boolean withDetail, Integer pageSize, Integer currentPage, String tableType) throws ApiException {
        okhttp3.Call call = listAllTablesValidateBeforeCall(projectId, databaseName, xAuthToken, keyword, withDetail, pageSize, currentPage, tableType, null, null);
        Type localVarReturnType = new TypeToken<TableListResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List all tables (asynchronously)
     * Query the specified database under the filter conditions or all of the table information.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName View the database where the table name. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param keyword Keywords for filtering table names. (optional)
     * @param withDetail Whether to get the details of the table (owner, size, etc.). (optional)
     * @param pageSize  (optional)
     * @param currentPage  (optional)
     * @param tableType  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call listAllTablesAsync(String projectId, String databaseName, String xAuthToken, String keyword, Boolean withDetail, Integer pageSize, Integer currentPage, String tableType, final ApiCallback<TableListResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = listAllTablesValidateBeforeCall(projectId, databaseName, xAuthToken, keyword, withDetail, pageSize, currentPage, tableType, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<TableListResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for listCluster
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call listClusterCall(String projectId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/clusters"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call listClusterValidateBeforeCall(String projectId, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling listCluster(Async)");
        }
        
        
        okhttp3.Call call = listClusterCall(projectId, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List all clusters
     * List all clusters.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ClusterInfos
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ClusterInfos listCluster(String projectId, String xAuthToken) throws ApiException {
        ApiResponse<ClusterInfos> resp = listClusterWithHttpInfo(projectId, xAuthToken);
        return resp.getData();
    }

    /**
     * List all clusters
     * List all clusters.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;ClusterInfos&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ClusterInfos> listClusterWithHttpInfo(String projectId, String xAuthToken) throws ApiException {
        okhttp3.Call call = listClusterValidateBeforeCall(projectId, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ClusterInfos>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List all clusters (asynchronously)
     * List all clusters.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call listClusterAsync(String projectId, String xAuthToken, final ApiCallback<ClusterInfos> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = listClusterValidateBeforeCall(projectId, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ClusterInfos>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for listDatabaseUsers
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The database name to be queried.. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call listDatabaseUsersCall(String projectId, String databaseName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/databases/{database_name}/users"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "database_name" + "\\}", apiClient.escapeString(databaseName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call listDatabaseUsersValidateBeforeCall(String projectId, String databaseName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling listDatabaseUsers(Async)");
        }
        
        // verify the required parameter 'databaseName' is set
        if (databaseName == null) {
            throw new ApiException("Missing the required parameter 'databaseName' when calling listDatabaseUsers(Async)");
        }
        
        
        okhttp3.Call call = listDatabaseUsersCall(projectId, databaseName, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List Database Users
     * View the current database has permission to use or access all user names.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The database name to be queried.. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return PrivilegeResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PrivilegeResult listDatabaseUsers(String projectId, String databaseName, String xAuthToken) throws ApiException {
        ApiResponse<PrivilegeResult> resp = listDatabaseUsersWithHttpInfo(projectId, databaseName, xAuthToken);
        return resp.getData();
    }

    /**
     * List Database Users
     * View the current database has permission to use or access all user names.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The database name to be queried.. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;PrivilegeResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PrivilegeResult> listDatabaseUsersWithHttpInfo(String projectId, String databaseName, String xAuthToken) throws ApiException {
        okhttp3.Call call = listDatabaseUsersValidateBeforeCall(projectId, databaseName, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<PrivilegeResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List Database Users (asynchronously)
     * View the current database has permission to use or access all user names.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The database name to be queried.. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call listDatabaseUsersAsync(String projectId, String databaseName, String xAuthToken, final ApiCallback<PrivilegeResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = listDatabaseUsersValidateBeforeCall(projectId, databaseName, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PrivilegeResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for listQueueUsers
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the queue (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call listQueueUsersCall(String projectId, String queueName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/queues/{queue_name}/users"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "queue_name" + "\\}", apiClient.escapeString(queueName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call listQueueUsersValidateBeforeCall(String projectId, String queueName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling listQueueUsers(Async)");
        }
        
        // verify the required parameter 'queueName' is set
        if (queueName == null) {
            throw new ApiException("Missing the required parameter 'queueName' when calling listQueueUsers(Async)");
        }
        
        
        okhttp3.Call call = listQueueUsersCall(projectId, queueName, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List queue users
     * Queries all the user names of the specified queue that can be used.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the queue (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return PrivilegeResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PrivilegeResult listQueueUsers(String projectId, String queueName, String xAuthToken) throws ApiException {
        ApiResponse<PrivilegeResult> resp = listQueueUsersWithHttpInfo(projectId, queueName, xAuthToken);
        return resp.getData();
    }

    /**
     * List queue users
     * Queries all the user names of the specified queue that can be used.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the queue (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;PrivilegeResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PrivilegeResult> listQueueUsersWithHttpInfo(String projectId, String queueName, String xAuthToken) throws ApiException {
        okhttp3.Call call = listQueueUsersValidateBeforeCall(projectId, queueName, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<PrivilegeResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List queue users (asynchronously)
     * Queries all the user names of the specified queue that can be used.
     * @param projectId Project ID for resource isolation. (required)
     * @param queueName The name of the queue (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call listQueueUsersAsync(String projectId, String queueName, String xAuthToken, final ApiCallback<PrivilegeResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = listQueueUsersValidateBeforeCall(projectId, queueName, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PrivilegeResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for listResources
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param kind  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call listResourcesCall(String projectId, String xAuthToken, String kind, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/resources"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (kind != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("kind", kind));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call listResourcesValidateBeforeCall(String projectId, String xAuthToken, String kind, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling listResources(Async)");
        }
        
        
        okhttp3.Call call = listResourcesCall(projectId, xAuthToken, kind, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List all resources
     * List all resources.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param kind  (optional)
     * @return ResourceInfos
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResourceInfos listResources(String projectId, String xAuthToken, String kind) throws ApiException {
        ApiResponse<ResourceInfos> resp = listResourcesWithHttpInfo(projectId, xAuthToken, kind);
        return resp.getData();
    }

    /**
     * List all resources
     * List all resources.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param kind  (optional)
     * @return ApiResponse&lt;ResourceInfos&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResourceInfos> listResourcesWithHttpInfo(String projectId, String xAuthToken, String kind) throws ApiException {
        okhttp3.Call call = listResourcesValidateBeforeCall(projectId, xAuthToken, kind, null, null);
        Type localVarReturnType = new TypeToken<ResourceInfos>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List all resources (asynchronously)
     * List all resources.
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token (optional)
     * @param kind  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call listResourcesAsync(String projectId, String xAuthToken, String kind, final ApiCallback<ResourceInfos> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = listResourcesValidateBeforeCall(projectId, xAuthToken, kind, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResourceInfos>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for listSqlJobs
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @param tags  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call listSqlJobsCall(String projectId, String xAuthToken, Integer pageSize, Integer currentPage, String tags, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/jobs/sql-jobs"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page-size", pageSize));
        if (currentPage != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("current-page", currentPage));
        if (tags != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("tags", tags));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call listSqlJobsValidateBeforeCall(String projectId, String xAuthToken, Integer pageSize, Integer currentPage, String tags, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling listSqlJobs(Async)");
        }
        
        
        okhttp3.Call call = listSqlJobsCall(projectId, xAuthToken, pageSize, currentPage, tags, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List all sql jobs
     * List all sql jobs
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @param tags  (optional)
     * @return JobListResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public JobListResult listSqlJobs(String projectId, String xAuthToken, Integer pageSize, Integer currentPage, String tags) throws ApiException {
        ApiResponse<JobListResult> resp = listSqlJobsWithHttpInfo(projectId, xAuthToken, pageSize, currentPage, tags);
        return resp.getData();
    }

    /**
     * List all sql jobs
     * List all sql jobs
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @param tags  (optional)
     * @return ApiResponse&lt;JobListResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<JobListResult> listSqlJobsWithHttpInfo(String projectId, String xAuthToken, Integer pageSize, Integer currentPage, String tags) throws ApiException {
        okhttp3.Call call = listSqlJobsValidateBeforeCall(projectId, xAuthToken, pageSize, currentPage, tags, null, null);
        Type localVarReturnType = new TypeToken<JobListResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List all sql jobs (asynchronously)
     * List all sql jobs
     * @param projectId Project ID for resource isolation. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param pageSize The maximum number of rows displayed per page,in the range: [1, 100]. The default is: 10. (optional)
     * @param currentPage The current page number, the default is the first page. (optional)
     * @param tags  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call listSqlJobsAsync(String projectId, String xAuthToken, Integer pageSize, Integer currentPage, String tags, final ApiCallback<JobListResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = listSqlJobsValidateBeforeCall(projectId, xAuthToken, pageSize, currentPage, tags, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<JobListResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for listTableUserPrivileges
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The database name to be queried. (required)
     * @param tableName The name of the table to be queried. (required)
     * @param userName The name of the user to be queried. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call listTableUserPrivilegesCall(String projectId, String databaseName, String tableName, String userName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/databases/{database_name}/tables/{table_name}/users/{user_name}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "database_name" + "\\}", apiClient.escapeString(databaseName.toString()))
            .replaceAll("\\{" + "table_name" + "\\}", apiClient.escapeString(tableName.toString()))
            .replaceAll("\\{" + "user_name" + "\\}", apiClient.escapeString(userName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call listTableUserPrivilegesValidateBeforeCall(String projectId, String databaseName, String tableName, String userName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling listTableUserPrivileges(Async)");
        }
        
        // verify the required parameter 'databaseName' is set
        if (databaseName == null) {
            throw new ApiException("Missing the required parameter 'databaseName' when calling listTableUserPrivileges(Async)");
        }
        
        // verify the required parameter 'tableName' is set
        if (tableName == null) {
            throw new ApiException("Missing the required parameter 'tableName' when calling listTableUserPrivileges(Async)");
        }
        
        // verify the required parameter 'userName' is set
        if (userName == null) {
            throw new ApiException("Missing the required parameter 'userName' when calling listTableUserPrivileges(Async)");
        }
        
        
        okhttp3.Call call = listTableUserPrivilegesCall(projectId, databaseName, tableName, userName, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List Table User Privileges
     * Query the specified user&#39;s privileges list on the table.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The database name to be queried. (required)
     * @param tableName The name of the table to be queried. (required)
     * @param userName The name of the user to be queried. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return PrivilegeResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PrivilegeResult listTableUserPrivileges(String projectId, String databaseName, String tableName, String userName, String xAuthToken) throws ApiException {
        ApiResponse<PrivilegeResult> resp = listTableUserPrivilegesWithHttpInfo(projectId, databaseName, tableName, userName, xAuthToken);
        return resp.getData();
    }

    /**
     * List Table User Privileges
     * Query the specified user&#39;s privileges list on the table.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The database name to be queried. (required)
     * @param tableName The name of the table to be queried. (required)
     * @param userName The name of the user to be queried. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;PrivilegeResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PrivilegeResult> listTableUserPrivilegesWithHttpInfo(String projectId, String databaseName, String tableName, String userName, String xAuthToken) throws ApiException {
        okhttp3.Call call = listTableUserPrivilegesValidateBeforeCall(projectId, databaseName, tableName, userName, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<PrivilegeResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List Table User Privileges (asynchronously)
     * Query the specified user&#39;s privileges list on the table.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The database name to be queried. (required)
     * @param tableName The name of the table to be queried. (required)
     * @param userName The name of the user to be queried. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call listTableUserPrivilegesAsync(String projectId, String databaseName, String tableName, String userName, String xAuthToken, final ApiCallback<PrivilegeResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = listTableUserPrivilegesValidateBeforeCall(projectId, databaseName, tableName, userName, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PrivilegeResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for listTableUsers
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The database name to be queried.. (required)
     * @param tableName The name of the table to be queried. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call listTableUsersCall(String projectId, String databaseName, String tableName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/databases/{database_name}/tables/{table_name}/users"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "database_name" + "\\}", apiClient.escapeString(databaseName.toString()))
            .replaceAll("\\{" + "table_name" + "\\}", apiClient.escapeString(tableName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call listTableUsersValidateBeforeCall(String projectId, String databaseName, String tableName, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling listTableUsers(Async)");
        }
        
        // verify the required parameter 'databaseName' is set
        if (databaseName == null) {
            throw new ApiException("Missing the required parameter 'databaseName' when calling listTableUsers(Async)");
        }
        
        // verify the required parameter 'tableName' is set
        if (tableName == null) {
            throw new ApiException("Missing the required parameter 'tableName' when calling listTableUsers(Async)");
        }
        
        
        okhttp3.Call call = listTableUsersCall(projectId, databaseName, tableName, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * List Table Users
     * View all users who have access to the columns of the specified table or table.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The database name to be queried.. (required)
     * @param tableName The name of the table to be queried. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return PrivilegeResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PrivilegeResult listTableUsers(String projectId, String databaseName, String tableName, String xAuthToken) throws ApiException {
        ApiResponse<PrivilegeResult> resp = listTableUsersWithHttpInfo(projectId, databaseName, tableName, xAuthToken);
        return resp.getData();
    }

    /**
     * List Table Users
     * View all users who have access to the columns of the specified table or table.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The database name to be queried.. (required)
     * @param tableName The name of the table to be queried. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;PrivilegeResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PrivilegeResult> listTableUsersWithHttpInfo(String projectId, String databaseName, String tableName, String xAuthToken) throws ApiException {
        okhttp3.Call call = listTableUsersValidateBeforeCall(projectId, databaseName, tableName, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<PrivilegeResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List Table Users (asynchronously)
     * View all users who have access to the columns of the specified table or table.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The database name to be queried.. (required)
     * @param tableName The name of the table to be queried. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call listTableUsersAsync(String projectId, String databaseName, String tableName, String xAuthToken, final ApiCallback<PrivilegeResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = listTableUsersValidateBeforeCall(projectId, databaseName, tableName, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PrivilegeResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for previewJobResult
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param queueName The DLI queue that executed this API request. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call previewJobResultCall(String projectId, String jobId, String xAuthToken, String queueName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/jobs/{job_id}/preview"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "job_id" + "\\}", apiClient.escapeString(jobId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (queueName != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("queue-name", queueName));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call previewJobResultValidateBeforeCall(String projectId, String jobId, String xAuthToken, String queueName, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling previewJobResult(Async)");
        }
        
        // verify the required parameter 'jobId' is set
        if (jobId == null) {
            throw new ApiException("Missing the required parameter 'jobId' when calling previewJobResult(Async)");
        }
        
        
        okhttp3.Call call = previewJobResultCall(projectId, jobId, xAuthToken, queueName, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get job result
     * After the job executing the SQL query is completed, review the result of the job execution. Currently, it is only supported to see the results of the execution of QUERY type jobs. The API can only view the results of the first 1000 records, to see all the results of the record, you need to export the query results before viewing
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param queueName The DLI queue that executed this API request. (optional)
     * @return JobResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public JobResult previewJobResult(String projectId, String jobId, String xAuthToken, String queueName) throws ApiException {
        ApiResponse<JobResult> resp = previewJobResultWithHttpInfo(projectId, jobId, xAuthToken, queueName);
        return resp.getData();
    }

    /**
     * Get job result
     * After the job executing the SQL query is completed, review the result of the job execution. Currently, it is only supported to see the results of the execution of QUERY type jobs. The API can only view the results of the first 1000 records, to see all the results of the record, you need to export the query results before viewing
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param queueName The DLI queue that executed this API request. (optional)
     * @return ApiResponse&lt;JobResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<JobResult> previewJobResultWithHttpInfo(String projectId, String jobId, String xAuthToken, String queueName) throws ApiException {
        okhttp3.Call call = previewJobResultValidateBeforeCall(projectId, jobId, xAuthToken, queueName, null, null);
        Type localVarReturnType = new TypeToken<JobResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get job result (asynchronously)
     * After the job executing the SQL query is completed, review the result of the job execution. Currently, it is only supported to see the results of the execution of QUERY type jobs. The API can only view the results of the first 1000 records, to see all the results of the record, you need to export the query results before viewing
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param queueName The DLI queue that executed this API request. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call previewJobResultAsync(String projectId, String jobId, String xAuthToken, String queueName, final ApiCallback<JobResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = previewJobResultValidateBeforeCall(projectId, jobId, xAuthToken, queueName, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<JobResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for queueAction
     * @param projectId project id, 用于不同project取token. (required)
     * @param queueName queue名称，指定queue (required)
     * @param body 队列操作请求体, 请求参数为json格式 (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call queueActionCall(String projectId, String queueName, QueueActionRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/queues/{queue_name}/action"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "queue_name" + "\\}", apiClient.escapeString(queueName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call queueActionValidateBeforeCall(String projectId, String queueName, QueueActionRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling queueAction(Async)");
        }
        
        // verify the required parameter 'queueName' is set
        if (queueName == null) {
            throw new ApiException("Missing the required parameter 'queueName' when calling queueAction(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling queueAction(Async)");
        }
        
        
        okhttp3.Call call = queueActionCall(projectId, queueName, body, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 队列操作
     * 
     * @param projectId project id, 用于不同project取token. (required)
     * @param queueName queue名称，指定queue (required)
     * @param body 队列操作请求体, 请求参数为json格式 (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return QueueActionResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public QueueActionResponse queueAction(String projectId, String queueName, QueueActionRequest body, String xAuthToken) throws ApiException {
        ApiResponse<QueueActionResponse> resp = queueActionWithHttpInfo(projectId, queueName, body, xAuthToken);
        return resp.getData();
    }

    /**
     * 队列操作
     * 
     * @param projectId project id, 用于不同project取token. (required)
     * @param queueName queue名称，指定queue (required)
     * @param body 队列操作请求体, 请求参数为json格式 (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;QueueActionResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<QueueActionResponse> queueActionWithHttpInfo(String projectId, String queueName, QueueActionRequest body, String xAuthToken) throws ApiException {
        okhttp3.Call call = queueActionValidateBeforeCall(projectId, queueName, body, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<QueueActionResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 队列操作 (asynchronously)
     * 
     * @param projectId project id, 用于不同project取token. (required)
     * @param queueName queue名称，指定queue (required)
     * @param body 队列操作请求体, 请求参数为json格式 (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call queueActionAsync(String projectId, String queueName, QueueActionRequest body, String xAuthToken, final ApiCallback<QueueActionResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = queueActionValidateBeforeCall(projectId, queueName, body, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<QueueActionResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for runFlinkJob
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call runFlinkJobCall(String projectId, RunFlinkJobRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/jobs/run"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call runFlinkJobValidateBeforeCall(String projectId, RunFlinkJobRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling runFlinkJob(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling runFlinkJob(Async)");
        }
        
        
        okhttp3.Call call = runFlinkJobCall(projectId, body, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 运行作业
     * 触发运行作业
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return List&lt;GlobalBatchResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<GlobalBatchResponse> runFlinkJob(String projectId, RunFlinkJobRequest body, String xAuthToken) throws ApiException {
        ApiResponse<List<GlobalBatchResponse>> resp = runFlinkJobWithHttpInfo(projectId, body, xAuthToken);
        return resp.getData();
    }

    /**
     * 运行作业
     * 触发运行作业
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;List&lt;GlobalBatchResponse&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<GlobalBatchResponse>> runFlinkJobWithHttpInfo(String projectId, RunFlinkJobRequest body, String xAuthToken) throws ApiException {
        okhttp3.Call call = runFlinkJobValidateBeforeCall(projectId, body, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<List<GlobalBatchResponse>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 运行作业 (asynchronously)
     * 触发运行作业
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call runFlinkJobAsync(String projectId, RunFlinkJobRequest body, String xAuthToken, final ApiCallback<List<GlobalBatchResponse>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = runFlinkJobValidateBeforeCall(projectId, body, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<GlobalBatchResponse>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for shareQueue
     * @param projectId Project ID for resource isolation. (required)
     * @param privilegeInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call shareQueueCall(String projectId, PrivilegeInfo privilegeInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = privilegeInfo;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/queues/user-authorization"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call shareQueueValidateBeforeCall(String projectId, PrivilegeInfo privilegeInfo, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling shareQueue(Async)");
        }
        
        // verify the required parameter 'privilegeInfo' is set
        if (privilegeInfo == null) {
            throw new ApiException("Missing the required parameter 'privilegeInfo' when calling shareQueue(Async)");
        }
        
        
        okhttp3.Call call = shareQueueCall(projectId, privilegeInfo, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Share queues
     * To share the specified queue with other users, you can assign the user the privilege to use the specified queue or to recover the usage privileges.
     * @param projectId Project ID for resource isolation. (required)
     * @param privilegeInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ResponseInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseInfo shareQueue(String projectId, PrivilegeInfo privilegeInfo, String xAuthToken) throws ApiException {
        ApiResponse<ResponseInfo> resp = shareQueueWithHttpInfo(projectId, privilegeInfo, xAuthToken);
        return resp.getData();
    }

    /**
     * Share queues
     * To share the specified queue with other users, you can assign the user the privilege to use the specified queue or to recover the usage privileges.
     * @param projectId Project ID for resource isolation. (required)
     * @param privilegeInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @return ApiResponse&lt;ResponseInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseInfo> shareQueueWithHttpInfo(String projectId, PrivilegeInfo privilegeInfo, String xAuthToken) throws ApiException {
        okhttp3.Call call = shareQueueValidateBeforeCall(projectId, privilegeInfo, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Share queues (asynchronously)
     * To share the specified queue with other users, you can assign the user the privilege to use the specified queue or to recover the usage privileges.
     * @param projectId Project ID for resource isolation. (required)
     * @param privilegeInfo Request parameters (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call shareQueueAsync(String projectId, PrivilegeInfo privilegeInfo, String xAuthToken, final ApiCallback<ResponseInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = shareQueueValidateBeforeCall(projectId, privilegeInfo, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for showPartitions
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The name of the database where the table to be described is located. (required)
     * @param tableName The name of the table to be described. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param offset The offset of the table to be set. (optional, default to 0)
     * @param limit The limit of the table to be set. (optional, default to 100)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call showPartitionsCall(String projectId, String databaseName, String tableName, String xAuthToken, Integer offset, Integer limit, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/databases/{database_name}/tables/{table_name}/partitions"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "database_name" + "\\}", apiClient.escapeString(databaseName.toString()))
            .replaceAll("\\{" + "table_name" + "\\}", apiClient.escapeString(tableName.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("offset", offset));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("limit", limit));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call showPartitionsValidateBeforeCall(String projectId, String databaseName, String tableName, String xAuthToken, Integer offset, Integer limit, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling showPartitions(Async)");
        }
        
        // verify the required parameter 'databaseName' is set
        if (databaseName == null) {
            throw new ApiException("Missing the required parameter 'databaseName' when calling showPartitions(Async)");
        }
        
        // verify the required parameter 'tableName' is set
        if (tableName == null) {
            throw new ApiException("Missing the required parameter 'tableName' when calling showPartitions(Async)");
        }
        
        
        okhttp3.Call call = showPartitionsCall(projectId, databaseName, tableName, xAuthToken, offset, limit, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Show partition information
     * Describes the partition information for the specified table.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The name of the database where the table to be described is located. (required)
     * @param tableName The name of the table to be described. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param offset The offset of the table to be set. (optional, default to 0)
     * @param limit The limit of the table to be set. (optional, default to 100)
     * @return PartitionResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PartitionResult showPartitions(String projectId, String databaseName, String tableName, String xAuthToken, Integer offset, Integer limit) throws ApiException {
        ApiResponse<PartitionResult> resp = showPartitionsWithHttpInfo(projectId, databaseName, tableName, xAuthToken, offset, limit);
        return resp.getData();
    }

    /**
     * Show partition information
     * Describes the partition information for the specified table.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The name of the database where the table to be described is located. (required)
     * @param tableName The name of the table to be described. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param offset The offset of the table to be set. (optional, default to 0)
     * @param limit The limit of the table to be set. (optional, default to 100)
     * @return ApiResponse&lt;PartitionResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PartitionResult> showPartitionsWithHttpInfo(String projectId, String databaseName, String tableName, String xAuthToken, Integer offset, Integer limit) throws ApiException {
        okhttp3.Call call = showPartitionsValidateBeforeCall(projectId, databaseName, tableName, xAuthToken, offset, limit, null, null);
        Type localVarReturnType = new TypeToken<PartitionResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Show partition information (asynchronously)
     * Describes the partition information for the specified table.
     * @param projectId Project ID for resource isolation. (required)
     * @param databaseName The name of the database where the table to be described is located. (required)
     * @param tableName The name of the table to be described. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param offset The offset of the table to be set. (optional, default to 0)
     * @param limit The limit of the table to be set. (optional, default to 100)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call showPartitionsAsync(String projectId, String databaseName, String tableName, String xAuthToken, Integer offset, Integer limit, final ApiCallback<PartitionResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = showPartitionsValidateBeforeCall(projectId, databaseName, tableName, xAuthToken, offset, limit, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PartitionResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for stopFlinkJob
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call stopFlinkJobCall(String projectId, StopFlinkJobRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/jobs/stop"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call stopFlinkJobValidateBeforeCall(String projectId, StopFlinkJobRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling stopFlinkJob(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling stopFlinkJob(Async)");
        }
        
        
        okhttp3.Call call = stopFlinkJobCall(projectId, body, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 停止作业
     * 
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return List&lt;GlobalBatchResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<GlobalBatchResponse> stopFlinkJob(String projectId, StopFlinkJobRequest body, String xAuthToken) throws ApiException {
        ApiResponse<List<GlobalBatchResponse>> resp = stopFlinkJobWithHttpInfo(projectId, body, xAuthToken);
        return resp.getData();
    }

    /**
     * 停止作业
     * 
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;List&lt;GlobalBatchResponse&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<GlobalBatchResponse>> stopFlinkJobWithHttpInfo(String projectId, StopFlinkJobRequest body, String xAuthToken) throws ApiException {
        okhttp3.Call call = stopFlinkJobValidateBeforeCall(projectId, body, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<List<GlobalBatchResponse>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 停止作业 (asynchronously)
     * 
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call stopFlinkJobAsync(String projectId, StopFlinkJobRequest body, String xAuthToken, final ApiCallback<List<GlobalBatchResponse>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = stopFlinkJobValidateBeforeCall(projectId, body, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<GlobalBatchResponse>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for storeJobResult
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param exportCommonInfo Request parameters (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call storeJobResultCall(String projectId, String jobId, String xAuthToken, ExportCommonInfo exportCommonInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = exportCommonInfo;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/jobs/{job_id}/export-result"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "job_id" + "\\}", apiClient.escapeString(jobId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call storeJobResultValidateBeforeCall(String projectId, String jobId, String xAuthToken, ExportCommonInfo exportCommonInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling storeJobResult(Async)");
        }
        
        // verify the required parameter 'jobId' is set
        if (jobId == null) {
            throw new ApiException("Missing the required parameter 'jobId' when calling storeJobResult(Async)");
        }
        
        
        okhttp3.Call call = storeJobResultCall(projectId, jobId, xAuthToken, exportCommonInfo, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Export job result
     * Export the results of the SQL statement to the OBS object store and only support the export of query results for \&quot;QUERY\&quot; type jobs.
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param exportCommonInfo Request parameters (optional)
     * @return ResponseJobInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponseJobInfo storeJobResult(String projectId, String jobId, String xAuthToken, ExportCommonInfo exportCommonInfo) throws ApiException {
        ApiResponse<ResponseJobInfo> resp = storeJobResultWithHttpInfo(projectId, jobId, xAuthToken, exportCommonInfo);
        return resp.getData();
    }

    /**
     * Export job result
     * Export the results of the SQL statement to the OBS object store and only support the export of query results for \&quot;QUERY\&quot; type jobs.
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param exportCommonInfo Request parameters (optional)
     * @return ApiResponse&lt;ResponseJobInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponseJobInfo> storeJobResultWithHttpInfo(String projectId, String jobId, String xAuthToken, ExportCommonInfo exportCommonInfo) throws ApiException {
        okhttp3.Call call = storeJobResultValidateBeforeCall(projectId, jobId, xAuthToken, exportCommonInfo, null, null);
        Type localVarReturnType = new TypeToken<ResponseJobInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Export job result (asynchronously)
     * Export the results of the SQL statement to the OBS object store and only support the export of query results for \&quot;QUERY\&quot; type jobs.
     * @param projectId Project ID for resource isolation. (required)
     * @param jobId Job ID. (required)
     * @param xAuthToken Authorization Token. (optional)
     * @param exportCommonInfo Request parameters (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call storeJobResultAsync(String projectId, String jobId, String xAuthToken, ExportCommonInfo exportCommonInfo, final ApiCallback<ResponseJobInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = storeJobResultValidateBeforeCall(projectId, jobId, xAuthToken, exportCommonInfo, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponseJobInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for submitFlinkJarJob
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call submitFlinkJarJobCall(String projectId, CreateFlinkJarJobRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/flink-jobs"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call submitFlinkJarJobValidateBeforeCall(String projectId, CreateFlinkJarJobRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling submitFlinkJarJob(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling submitFlinkJarJob(Async)");
        }
        
        
        okhttp3.Call call = submitFlinkJarJobCall(projectId, body, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 创建一个用户自定义Flink作业
     * 用户自定义Flink作业目前支持jar格式, 运行在独享集群中
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return JobStatusResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public JobStatusResponse submitFlinkJarJob(String projectId, CreateFlinkJarJobRequest body, String xAuthToken) throws ApiException {
        ApiResponse<JobStatusResponse> resp = submitFlinkJarJobWithHttpInfo(projectId, body, xAuthToken);
        return resp.getData();
    }

    /**
     * 创建一个用户自定义Flink作业
     * 用户自定义Flink作业目前支持jar格式, 运行在独享集群中
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;JobStatusResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<JobStatusResponse> submitFlinkJarJobWithHttpInfo(String projectId, CreateFlinkJarJobRequest body, String xAuthToken) throws ApiException {
        okhttp3.Call call = submitFlinkJarJobValidateBeforeCall(projectId, body, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<JobStatusResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 创建一个用户自定义Flink作业 (asynchronously)
     * 用户自定义Flink作业目前支持jar格式, 运行在独享集群中
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call submitFlinkJarJobAsync(String projectId, CreateFlinkJarJobRequest body, String xAuthToken, final ApiCallback<JobStatusResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = submitFlinkJarJobValidateBeforeCall(projectId, body, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<JobStatusResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for submitFlinkSqlJob
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call submitFlinkSqlJobCall(String projectId, SubmitFlinkSqlJobRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/sql-jobs"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call submitFlinkSqlJobValidateBeforeCall(String projectId, SubmitFlinkSqlJobRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling submitFlinkSqlJob(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling submitFlinkSqlJob(Async)");
        }
        
        
        okhttp3.Call call = submitFlinkSqlJobCall(projectId, body, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 提交流式SQL作业到DLI服务
     * 通过POST方式, 提交流式SQL作业, 请求体为JSON格式
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return JobStatusResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public JobStatusResponse submitFlinkSqlJob(String projectId, SubmitFlinkSqlJobRequest body, String xAuthToken) throws ApiException {
        ApiResponse<JobStatusResponse> resp = submitFlinkSqlJobWithHttpInfo(projectId, body, xAuthToken);
        return resp.getData();
    }

    /**
     * 提交流式SQL作业到DLI服务
     * 通过POST方式, 提交流式SQL作业, 请求体为JSON格式
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;JobStatusResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<JobStatusResponse> submitFlinkSqlJobWithHttpInfo(String projectId, SubmitFlinkSqlJobRequest body, String xAuthToken) throws ApiException {
        okhttp3.Call call = submitFlinkSqlJobValidateBeforeCall(projectId, body, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<JobStatusResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 提交流式SQL作业到DLI服务 (asynchronously)
     * 通过POST方式, 提交流式SQL作业, 请求体为JSON格式
     * @param projectId project id, 用于不同project取token. (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call submitFlinkSqlJobAsync(String projectId, SubmitFlinkSqlJobRequest body, String xAuthToken, final ApiCallback<JobStatusResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = submitFlinkSqlJobValidateBeforeCall(projectId, body, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<JobStatusResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateFlinkJarJob
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId  (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call updateFlinkJarJobCall(String projectId, Long jobId, UpdateFlinkJarJobRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/flink-jobs/{job_id}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "job_id" + "\\}", apiClient.escapeString(jobId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call updateFlinkJarJobValidateBeforeCall(String projectId, Long jobId, UpdateFlinkJarJobRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling updateFlinkJarJob(Async)");
        }
        
        // verify the required parameter 'jobId' is set
        if (jobId == null) {
            throw new ApiException("Missing the required parameter 'jobId' when calling updateFlinkJarJob(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling updateFlinkJarJob(Async)");
        }
        
        
        okhttp3.Call call = updateFlinkJarJobCall(projectId, jobId, body, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 更新用户自定义Flink作业
     * 目前仅支持Jar格式, 运行在独享集群中
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId  (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return JobUpdateResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public JobUpdateResponse updateFlinkJarJob(String projectId, Long jobId, UpdateFlinkJarJobRequest body, String xAuthToken) throws ApiException {
        ApiResponse<JobUpdateResponse> resp = updateFlinkJarJobWithHttpInfo(projectId, jobId, body, xAuthToken);
        return resp.getData();
    }

    /**
     * 更新用户自定义Flink作业
     * 目前仅支持Jar格式, 运行在独享集群中
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId  (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;JobUpdateResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<JobUpdateResponse> updateFlinkJarJobWithHttpInfo(String projectId, Long jobId, UpdateFlinkJarJobRequest body, String xAuthToken) throws ApiException {
        okhttp3.Call call = updateFlinkJarJobValidateBeforeCall(projectId, jobId, body, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<JobUpdateResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 更新用户自定义Flink作业 (asynchronously)
     * 目前仅支持Jar格式, 运行在独享集群中
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId  (required)
     * @param body JSON格式的请求体 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call updateFlinkJarJobAsync(String projectId, Long jobId, UpdateFlinkJarJobRequest body, String xAuthToken, final ApiCallback<JobUpdateResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = updateFlinkJarJobValidateBeforeCall(projectId, jobId, body, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<JobUpdateResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateFlinkJobTemplate
     * @param projectId project id, 用于不同project取token. (required)
     * @param templateId  (required)
     * @param body 提交修改SQL作业模板请求 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call updateFlinkJobTemplateCall(String projectId, Long templateId, UpdateFlinkJobTemplateRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/job-templates/{template_id}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "template_id" + "\\}", apiClient.escapeString(templateId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call updateFlinkJobTemplateValidateBeforeCall(String projectId, Long templateId, UpdateFlinkJobTemplateRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling updateFlinkJobTemplate(Async)");
        }
        
        // verify the required parameter 'templateId' is set
        if (templateId == null) {
            throw new ApiException("Missing the required parameter 'templateId' when calling updateFlinkJobTemplate(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling updateFlinkJobTemplate(Async)");
        }
        
        
        okhttp3.Call call = updateFlinkJobTemplateCall(projectId, templateId, body, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 更新作业模板
     * Update job template on Data lake insight
     * @param projectId project id, 用于不同project取token. (required)
     * @param templateId  (required)
     * @param body 提交修改SQL作业模板请求 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return GlobalResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GlobalResponse updateFlinkJobTemplate(String projectId, Long templateId, UpdateFlinkJobTemplateRequest body, String xAuthToken) throws ApiException {
        ApiResponse<GlobalResponse> resp = updateFlinkJobTemplateWithHttpInfo(projectId, templateId, body, xAuthToken);
        return resp.getData();
    }

    /**
     * 更新作业模板
     * Update job template on Data lake insight
     * @param projectId project id, 用于不同project取token. (required)
     * @param templateId  (required)
     * @param body 提交修改SQL作业模板请求 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;GlobalResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GlobalResponse> updateFlinkJobTemplateWithHttpInfo(String projectId, Long templateId, UpdateFlinkJobTemplateRequest body, String xAuthToken) throws ApiException {
        okhttp3.Call call = updateFlinkJobTemplateValidateBeforeCall(projectId, templateId, body, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<GlobalResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 更新作业模板 (asynchronously)
     * Update job template on Data lake insight
     * @param projectId project id, 用于不同project取token. (required)
     * @param templateId  (required)
     * @param body 提交修改SQL作业模板请求 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call updateFlinkJobTemplateAsync(String projectId, Long templateId, UpdateFlinkJobTemplateRequest body, String xAuthToken, final ApiCallback<GlobalResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = updateFlinkJobTemplateValidateBeforeCall(projectId, templateId, body, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GlobalResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateFlinkSqlJob
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId  (required)
     * @param body 提交修改SQL作业请求 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call updateFlinkSqlJobCall(String projectId, Long jobId, UpdateFlinkSqlJobRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/v1.0/{project_id}/streaming/sql-jobs/{job_id}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "job_id" + "\\}", apiClient.escapeString(jobId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call updateFlinkSqlJobValidateBeforeCall(String projectId, Long jobId, UpdateFlinkSqlJobRequest body, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling updateFlinkSqlJob(Async)");
        }
        
        // verify the required parameter 'jobId' is set
        if (jobId == null) {
            throw new ApiException("Missing the required parameter 'jobId' when calling updateFlinkSqlJob(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling updateFlinkSqlJob(Async)");
        }
        
        
        okhttp3.Call call = updateFlinkSqlJobCall(projectId, jobId, body, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 更新流式SQL作业
     * 流式SQL的语法扩展了Apache Flink SQL, 具体详情请参考DLI官方文档
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId  (required)
     * @param body 提交修改SQL作业请求 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return JobUpdateResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public JobUpdateResponse updateFlinkSqlJob(String projectId, Long jobId, UpdateFlinkSqlJobRequest body, String xAuthToken) throws ApiException {
        ApiResponse<JobUpdateResponse> resp = updateFlinkSqlJobWithHttpInfo(projectId, jobId, body, xAuthToken);
        return resp.getData();
    }

    /**
     * 更新流式SQL作业
     * 流式SQL的语法扩展了Apache Flink SQL, 具体详情请参考DLI官方文档
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId  (required)
     * @param body 提交修改SQL作业请求 (required)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;JobUpdateResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<JobUpdateResponse> updateFlinkSqlJobWithHttpInfo(String projectId, Long jobId, UpdateFlinkSqlJobRequest body, String xAuthToken) throws ApiException {
        okhttp3.Call call = updateFlinkSqlJobValidateBeforeCall(projectId, jobId, body, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<JobUpdateResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 更新流式SQL作业 (asynchronously)
     * 流式SQL的语法扩展了Apache Flink SQL, 具体详情请参考DLI官方文档
     * @param projectId project id, 用于不同project取token. (required)
     * @param jobId  (required)
     * @param body 提交修改SQL作业请求 (required)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call updateFlinkSqlJobAsync(String projectId, Long jobId, UpdateFlinkSqlJobRequest body, String xAuthToken, final ApiCallback<JobUpdateResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = updateFlinkSqlJobValidateBeforeCall(projectId, jobId, body, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<JobUpdateResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateTsdb
     * @param projectId  (required)
     * @param tsdbId  (required)
     * @param updateTsdbReq This is a auto create Body Object (optional)
     * @param xAuthToken Authorization Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call updateTsdbCall(String projectId, String tsdbId, UpdateTsdbReq updateTsdbReq, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = updateTsdbReq;
        
        // create path and map variables
        String localVarPath = "/v3/{project_id}/tsdbs/{tsdb_id}"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()))
            .replaceAll("\\{" + "tsdb_id" + "\\}", apiClient.escapeString(tsdbId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call updateTsdbValidateBeforeCall(String projectId, String tsdbId, UpdateTsdbReq updateTsdbReq, String xAuthToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling updateTsdb(Async)");
        }
        
        // verify the required parameter 'tsdbId' is set
        if (tsdbId == null) {
            throw new ApiException("Missing the required parameter 'tsdbId' when calling updateTsdb(Async)");
        }
        
        
        okhttp3.Call call = updateTsdbCall(projectId, tsdbId, updateTsdbReq, xAuthToken, progressListener, progressRequestListener);
        return call;

    }

    /**
     * 修改时序数据库配置信息
     * 修改时序数据库配置信息
     * @param projectId  (required)
     * @param tsdbId  (required)
     * @param updateTsdbReq This is a auto create Body Object (optional)
     * @param xAuthToken Authorization Token (optional)
     * @return GlobalResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public GlobalResponse updateTsdb(String projectId, String tsdbId, UpdateTsdbReq updateTsdbReq, String xAuthToken) throws ApiException {
        ApiResponse<GlobalResponse> resp = updateTsdbWithHttpInfo(projectId, tsdbId, updateTsdbReq, xAuthToken);
        return resp.getData();
    }

    /**
     * 修改时序数据库配置信息
     * 修改时序数据库配置信息
     * @param projectId  (required)
     * @param tsdbId  (required)
     * @param updateTsdbReq This is a auto create Body Object (optional)
     * @param xAuthToken Authorization Token (optional)
     * @return ApiResponse&lt;GlobalResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<GlobalResponse> updateTsdbWithHttpInfo(String projectId, String tsdbId, UpdateTsdbReq updateTsdbReq, String xAuthToken) throws ApiException {
        okhttp3.Call call = updateTsdbValidateBeforeCall(projectId, tsdbId, updateTsdbReq, xAuthToken, null, null);
        Type localVarReturnType = new TypeToken<GlobalResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 修改时序数据库配置信息 (asynchronously)
     * 修改时序数据库配置信息
     * @param projectId  (required)
     * @param tsdbId  (required)
     * @param updateTsdbReq This is a auto create Body Object (optional)
     * @param xAuthToken Authorization Token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call updateTsdbAsync(String projectId, String tsdbId, UpdateTsdbReq updateTsdbReq, String xAuthToken, final ApiCallback<GlobalResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = updateTsdbValidateBeforeCall(projectId, tsdbId, updateTsdbReq, xAuthToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<GlobalResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for uploadFiles
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call uploadFilesCall(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/resources/files"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));
        if (USER_ID != null)
        localVarHeaderParams.put("USER_ID", apiClient.parameterToString(USER_ID));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call uploadFilesValidateBeforeCall(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling uploadFiles(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling uploadFiles(Async)");
        }
        
        
        okhttp3.Call call = uploadFilesCall(projectId, body, xAuthToken, USER_ID, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Upload files
     * Upload files.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @return ResourceMsg
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResourceMsg uploadFiles(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID) throws ApiException {
        ApiResponse<ResourceMsg> resp = uploadFilesWithHttpInfo(projectId, body, xAuthToken, USER_ID);
        return resp.getData();
    }

    /**
     * Upload files
     * Upload files.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @return ApiResponse&lt;ResourceMsg&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResourceMsg> uploadFilesWithHttpInfo(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID) throws ApiException {
        okhttp3.Call call = uploadFilesValidateBeforeCall(projectId, body, xAuthToken, USER_ID, null, null);
        Type localVarReturnType = new TypeToken<ResourceMsg>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Upload files (asynchronously)
     * Upload files.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call uploadFilesAsync(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID, final ApiCallback<ResourceMsg> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = uploadFilesValidateBeforeCall(projectId, body, xAuthToken, USER_ID, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResourceMsg>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for uploadJars
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call uploadJarsCall(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/resources/jars"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));
        if (USER_ID != null)
        localVarHeaderParams.put("USER_ID", apiClient.parameterToString(USER_ID));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call uploadJarsValidateBeforeCall(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling uploadJars(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling uploadJars(Async)");
        }
        
        
        okhttp3.Call call = uploadJarsCall(projectId, body, xAuthToken, USER_ID, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Upload jars
     * Upload jars.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @return ResourceMsg
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResourceMsg uploadJars(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID) throws ApiException {
        ApiResponse<ResourceMsg> resp = uploadJarsWithHttpInfo(projectId, body, xAuthToken, USER_ID);
        return resp.getData();
    }

    /**
     * Upload jars
     * Upload jars.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @return ApiResponse&lt;ResourceMsg&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResourceMsg> uploadJarsWithHttpInfo(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID) throws ApiException {
        okhttp3.Call call = uploadJarsValidateBeforeCall(projectId, body, xAuthToken, USER_ID, null, null);
        Type localVarReturnType = new TypeToken<ResourceMsg>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Upload jars (asynchronously)
     * Upload jars.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call uploadJarsAsync(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID, final ApiCallback<ResourceMsg> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = uploadJarsValidateBeforeCall(projectId, body, xAuthToken, USER_ID, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResourceMsg>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for uploadPyFiles
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call uploadPyFilesCall(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/resources/pyfiles"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));
        if (USER_ID != null)
        localVarHeaderParams.put("USER_ID", apiClient.parameterToString(USER_ID));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call uploadPyFilesValidateBeforeCall(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling uploadPyFiles(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling uploadPyFiles(Async)");
        }
        
        
        okhttp3.Call call = uploadPyFilesCall(projectId, body, xAuthToken, USER_ID, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Upload pyfiles
     * Upload pyfiles.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @return ResourceMsg
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResourceMsg uploadPyFiles(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID) throws ApiException {
        ApiResponse<ResourceMsg> resp = uploadPyFilesWithHttpInfo(projectId, body, xAuthToken, USER_ID);
        return resp.getData();
    }

    /**
     * Upload pyfiles
     * Upload pyfiles.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @return ApiResponse&lt;ResourceMsg&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResourceMsg> uploadPyFilesWithHttpInfo(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID) throws ApiException {
        okhttp3.Call call = uploadPyFilesValidateBeforeCall(projectId, body, xAuthToken, USER_ID, null, null);
        Type localVarReturnType = new TypeToken<ResourceMsg>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Upload pyfiles (asynchronously)
     * Upload pyfiles.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call uploadPyFilesAsync(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID, final ApiCallback<ResourceMsg> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = uploadPyFilesValidateBeforeCall(projectId, body, xAuthToken, USER_ID, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResourceMsg>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for uploadResources
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public okhttp3.Call uploadResourcesCall(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/v2.0/{project_id}/resources"
            .replaceAll("\\{" + "project_id" + "\\}", apiClient.escapeString(projectId.toString()));

        if (ApiClient.isTest()) {
            localVarPath = localVarPath.replace("metastore/", "");
        }
        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (xAuthToken != null)
        localVarHeaderParams.put("X-Auth-Token", apiClient.parameterToString(xAuthToken));
        if (USER_ID != null)
        localVarHeaderParams.put("USER_ID", apiClient.parameterToString(USER_ID));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new okhttp3.Interceptor() {
                @Override
                public okhttp3.Response intercept(okhttp3.Interceptor.Chain chain) throws IOException {
                    okhttp3.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    private okhttp3.Call uploadResourcesValidateBeforeCall(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'projectId' is set
        if (projectId == null) {
            throw new ApiException("Missing the required parameter 'projectId' when calling uploadResources(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling uploadResources(Async)");
        }
        
        
        okhttp3.Call call = uploadResourcesCall(projectId, body, xAuthToken, USER_ID, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Upload resources
     * Upload resources.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @return ResourceMsg
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResourceMsg uploadResources(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID) throws ApiException {
        ApiResponse<ResourceMsg> resp = uploadResourcesWithHttpInfo(projectId, body, xAuthToken, USER_ID);
        return resp.getData();
    }

    /**
     * Upload resources
     * Upload resources.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @return ApiResponse&lt;ResourceMsg&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResourceMsg> uploadResourcesWithHttpInfo(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID) throws ApiException {
        okhttp3.Call call = uploadResourcesValidateBeforeCall(projectId, body, xAuthToken, USER_ID, null, null);
        Type localVarReturnType = new TypeToken<ResourceMsg>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Upload resources (asynchronously)
     * Upload resources.
     * @param projectId Project ID for resource isolation. (required)
     * @param body  (required)
     * @param xAuthToken Authorization Token (optional)
     * @param USER_ID Real user id (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public okhttp3.Call uploadResourcesAsync(String projectId, PkgResourceRequest body, String xAuthToken, String USER_ID, final ApiCallback<ResourceMsg> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        okhttp3.Call call = uploadResourcesValidateBeforeCall(projectId, body, xAuthToken, USER_ID, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResourceMsg>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
